var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from '../../utils/PropTypes';
import invariant from 'tiny-invariant';
import AppConfigContext from '../../contexts/AppConfig';

export default function AppTitle(_ref) {
	var style = _ref.style,
	    fontSize = _ref.fontSize,
	    color = _ref.color,
	    textAlign = _ref.textAlign,
	    other = _objectWithoutProperties(_ref, ['style', 'fontSize', 'color', 'textAlign']);

	return React.createElement(
		AppConfigContext.Consumer,
		null,
		function (appConfig) {
			!appConfig ? process.env.NODE_ENV !== 'production' ? invariant(false, 'You should not use <AppTitle> outside <AppContext>') : invariant(false) : void 0;
			return React.createElement(
				'h1',
				_extends({}, other, {
					style: _extends({
						margin: 0,
						overflow: 'hidden',
						textOverflow: 'ellipsis',
						fontSize: fontSize,
						textAlign: textAlign,
						color: color
					}, style)
				}),
				appConfig.title
			);
		}
	);
}

AppTitle.propTypes = {
	style: PropTypes.object,
	fontSize: PropTypes.stringOrNumber,
	textAlign: PropTypes.string,
	color: PropTypes.string
};

AppTitle.defaultProps = {
	fontSize: 20,
	textAlign: 'center',
	color: 'inherit'
};