import { style as _style } from 'antd/lib/modal/style';
import _default from 'antd/lib/modal';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from '../../utils/PropTypes';
import ContextButton from '../ContextButton';

import { isFunction } from '../../utils/fp';

var ConfirmButton = (_temp2 = _class = function (_Component) {
	_inherits(ConfirmButton, _Component);

	function ConfirmButton() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, ConfirmButton);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ConfirmButton.__proto__ || Object.getPrototypeOf(ConfirmButton)).call.apply(_ref, [this].concat(args))), _this), _this._handleClick = function (ev, actions) {
			var _this$props = _this.props,
			    title = _this$props.title,
			    content = _this$props.content,
			    _onOk = _this$props.onOk,
			    okText = _this$props.okText,
			    method = _this$props.method;

			ev.preventDefault();
			_default.confirm({
				title: isFunction(title) ? title(actions.getData()) : title,
				content: isFunction(content) ? content(actions.getData()) : content,
				okText: okText,
				onOk: function onOk() {
					if (_onOk) {
						_onOk(actions);
					}
					if (method) {
						actions.store.call(method, {
							method: 'POST',
							keys: actions.selectedKeys
						});
					}
				}
			});
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(ConfirmButton, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    title = _props.title,
			    content = _props.content,
			    onOk = _props.onOk,
			    okText = _props.okText,
			    method = _props.method,
			    other = _objectWithoutProperties(_props, ['title', 'content', 'onOk', 'okText', 'method']);

			return React.createElement(ContextButton, _extends({}, other, {
				onClick: this._handleClick
			}));
		}
	}]);

	return ConfirmButton;
}(Component), _class.propTypes = {
	title: PropTypes.stringOrFunc.isRequired,
	content: PropTypes.stringOrFunc,
	onOk: PropTypes.func,
	okText: PropTypes.string,
	method: PropTypes.string
}, _class.defaultProps = {
	okText: 'OK'
}, _temp2);
export { ConfirmButton as default };