import { style as _style } from 'antd/lib/button/style';
import _default from 'antd/lib/button';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from '../../utils/PropTypes';
import { observer } from 'mobx-react';
import withActions from '../../hocs/withActions';
import withIssuer from '../../hocs/withIssuer';

import LinkButton from '../LinkButton';
import { TABLE } from '../../utils/Issuers';
import { isFunction } from '../../utils/fp';

var ContextButton = (_dec = withIssuer(), _dec(_class = withActions(_class = observer(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(ContextButton, _Component);

	function ContextButton() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, ContextButton);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ContextButton.__proto__ || Object.getPrototypeOf(ContextButton)).call.apply(_ref, [this].concat(args))), _this), _this._handleClick = function (ev) {
			var _this$props = _this.props,
			    onClick = _this$props.onClick,
			    method = _this$props.method,
			    actions = _this$props.actions;

			if (onClick) {
				onClick(ev, actions);
			}
			if (method) {
				ev.preventDefault();
				actions.store.call(method, {
					method: 'POST',
					keys: actions.selectedKeys
				});
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(ContextButton, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    _props$actions = _props.actions,
			    selectedKeys = _props$actions.selectedKeys,
			    getData = _props$actions.getData,
			    component = _props.component,
			    children = _props.children,
			    label = _props.label,
			    multiLabel = _props.multiLabel,
			    minSelected = _props.minSelected,
			    maxSelected = _props.maxSelected,
			    issuers = _props.issuers,
			    method = _props.method,
			    other = _objectWithoutProperties(_props, ['actions', 'component', 'children', 'label', 'multiLabel', 'minSelected', 'maxSelected', 'issuers', 'method']);

			var selected = selectedKeys.length;
			var disabled = minSelected > selected || maxSelected < selected;
			var Comp = issuers.has(TABLE) ? component : _default;
			var renderChild = children || (minSelected && selected > 1 && multiLabel ? multiLabel : label);

			return React.createElement(
				Comp,
				_extends({ disabled: disabled }, other, { onClick: this._handleClick }),
				isFunction(renderChild) ? renderChild(getData() || {}) : renderChild
			);
		}
	}]);

	return ContextButton;
}(Component), _class2.propTypes = {
	children: PropTypes.nodeOrFunc,
	label: PropTypes.stringOrFunc,
	multiLabel: PropTypes.stringOrFunc,
	actions: PropTypes.shape({
		selectedKeys: PropTypes.array.isRequired
	}).isRequired,
	component: PropTypes.component,
	minSelected: PropTypes.number,
	maxSelected: PropTypes.number,
	method: PropTypes.string,
	issuers: PropTypes.instanceOf(Set).isRequired,
	onClick: PropTypes.func
}, _class2.defaultProps = {
	type: 'primary',
	component: LinkButton,
	minSelected: 0,
	maxSelected: Infinity
}, _temp2)) || _class) || _class) || _class);
export { ContextButton as default };