import React from 'react';
import PropTypes from '../../utils/PropTypes';

var EditorToolbar = function EditorToolbar(props) {
	return React.createElement(
		'div',
		{ className: 'editor-toolbar' },
		props.font && React.createElement('select', { className: 'ql-font' }),
		props.size && React.createElement('select', { className: 'ql-size' }),
		props.bold && React.createElement('button', { className: 'ql-bold' }),
		props.italic && React.createElement('button', { className: 'ql-italic' }),
		props.underline && React.createElement('button', { className: 'ql-underline' }),
		props.strike && React.createElement('button', { className: 'ql-strike' }),
		props.color && React.createElement('select', { className: 'ql-color' }),
		props.background && React.createElement('select', { className: 'ql-background' }),
		props.script && React.createElement('button', { className: 'ql-script', value: 'sub' }),
		props.script && React.createElement('button', { className: 'ql-script', value: 'super' }),
		props.header && React.createElement('button', { className: 'ql-header', value: '1' }),
		props.header && React.createElement('button', { className: 'ql-header', value: '2' }),
		props.blockquote && React.createElement('button', { className: 'ql-blockquote' }),
		props.codeBlock && React.createElement('button', { className: 'ql-code-block' }),
		props.list && React.createElement('button', { className: 'ql-list', value: 'ordered' }),
		props.list && React.createElement('button', { className: 'ql-list', value: 'bullet' }),
		props.indent && React.createElement('button', { className: 'ql-indent', value: '-1' }),
		props.indent && React.createElement('button', { className: 'ql-indent', value: '+1' }),
		props.direction && React.createElement('button', { className: 'ql-direction', value: 'rtl' }),
		props.align && React.createElement('select', { className: 'ql-align' }),
		props.link && React.createElement('button', { className: 'ql-link' }),
		props.image && React.createElement('button', { className: 'ql-image' }),
		props.video && React.createElement('button', { className: 'ql-video' }),
		props.formula && React.createElement('button', { className: 'ql-formula' }),
		props.clean && React.createElement('button', { className: 'ql-clean' }),
		props.children
	);
};

EditorToolbar.propTypes = {
	children: PropTypes.node,
	font: PropTypes.bool,
	size: PropTypes.bool,
	bold: PropTypes.bool,
	italic: PropTypes.bool,
	underline: PropTypes.bool,
	strike: PropTypes.bool,
	color: PropTypes.bool,
	background: PropTypes.bool,
	script: PropTypes.bool,
	header: PropTypes.bool,
	blockquote: PropTypes.bool,
	codeBlock: PropTypes.bool,
	list: PropTypes.bool,
	indent: PropTypes.bool,
	direction: PropTypes.bool,
	align: PropTypes.bool,
	link: PropTypes.bool,
	image: PropTypes.bool,
	video: PropTypes.bool,
	formula: PropTypes.bool,
	clean: PropTypes.bool
};

EditorToolbar.defaultProps = {
	font: false,
	size: true,
	bold: true,
	italic: true,
	underline: true,
	strike: true,
	color: true,
	background: true,
	script: false,
	header: true,
	blockquote: true,
	codeBlock: true,
	list: true,
	indent: true,
	direction: false,
	align: true,
	link: true,
	image: true,
	video: true,
	formula: false,
	clean: true
};

export default EditorToolbar;