var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp, _initialiseProps;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent, cloneElement } from 'react';
import PropTypes from 'prop-types';
import invariant from 'tiny-invariant';
import naviStore from '../../stores/naviStore';
import PageContext from '../../contexts/PageContext';
import AppConfigContext from '../../contexts/AppConfig';
import DocumentTitle from 'react-document-title';

var NaviEnhancer = (_temp = _class = function (_PureComponent) {
	_inherits(NaviEnhancer, _PureComponent);

	function NaviEnhancer(props) {
		_classCallCheck(this, NaviEnhancer);

		var _this = _possibleConstructorReturn(this, (NaviEnhancer.__proto__ || Object.getPrototypeOf(NaviEnhancer)).call(this, props));

		_initialiseProps.call(_this);

		var children = props.children,
		    other = _objectWithoutProperties(props, ['children']);

		naviStore.setState(other);
		return _this;
	}

	_createClass(NaviEnhancer, [{
		key: 'render',
		value: function render() {
			return React.createElement(
				AppConfigContext.Consumer,
				null,
				this._renderInAppConfigContext
			);
		}
	}]);

	return NaviEnhancer;
}(PureComponent), _class.propTypes = {
	children: PropTypes.node.isRequired,
	title: PropTypes.string,
	pageTitle: PropTypes.string,
	table: PropTypes.string
}, _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this._renderInAppConfigContext = function (appConfig) {
		!appConfig ? process.env.NODE_ENV !== 'production' ? invariant(false, 'You should not use <EnhancedRoute> outside <AppContext>') : invariant(false) : void 0;

		var props = _this2.props,
		    _props = _this2.props,
		    children = _props.children,
		    other = _objectWithoutProperties(_props, ['children']);

		var appTitle = appConfig.title;

		var pageTitle = props.pageTitle || props.title || props.table;
		var title = pageTitle ? pageTitle + ' | ' + appTitle : appTitle;

		return React.createElement(
			DocumentTitle,
			{ title: title },
			React.createElement(
				PageContext.Provider,
				{ value: props },
				cloneElement(children, other)
			)
		);
	};
}, _temp);
export { NaviEnhancer as default };