var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import PropTypes from 'prop-types';
import React from 'react';
import { Route } from 'react-router-dom';
import NaviEnhancer from './NaviEnhancer';

export default function EnhancedRoute(props) {
	var Component = props.component,
	    exact = props.exact,
	    strict = props.strict,
	    other = _objectWithoutProperties(props, ['component', 'exact', 'strict']);

	var path = other.path;

	return React.createElement(Route, {
		path: path,
		exact: exact,
		strict: strict,
		render: function render(matchProps) {
			return React.createElement(
				NaviEnhancer,
				_extends({}, other, { path: path, key: path }),
				React.createElement(Component, matchProps)
			);
		}
	});
}

EnhancedRoute.propTypes = {
	component: PropTypes.any.isRequired,
	exact: PropTypes.any,
	strict: PropTypes.any,
	path: PropTypes.any,
	menuKey: PropTypes.string
};