var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from '../../utils/PropTypes';
import getDefaultEditorFormats from '../../utils/getDefaultEditorFormats';
import createComponent from './createComponent';
import EditorContext from '../../contexts/Editor';
import Quill from 'react-quill';
import EditorToolbar from '../EditorToolbar';

var formats = getDefaultEditorFormats();

var QuillEditorEnhancer = (_temp = _class = function (_Component) {
	_inherits(QuillEditorEnhancer, _Component);

	function QuillEditorEnhancer(props) {
		_classCallCheck(this, QuillEditorEnhancer);

		var _this = _possibleConstructorReturn(this, (QuillEditorEnhancer.__proto__ || Object.getPrototypeOf(QuillEditorEnhancer)).call(this, props));

		_this.state = {
			editor: {}
		};

		_this.saveRef = function (ref) {
			var innerRef = _this.props.innerRef;

			_this.reactQuillRef = ref;
			if (_this.state.editor !== ref) _this.setState({ editor: ref });
			if (innerRef) innerRef(ref);
		};

		var modules = props.modules;

		modules.toolbar = _extends({
			container: '.editor-toolbar'
		}, modules.toolbar);
		_this.modules = modules;
		return _this;
	}

	_createClass(QuillEditorEnhancer, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    containerClassName = _props.containerClassName,
			    containerStyle = _props.containerStyle,
			    toolbar = _props.toolbar,
			    innerRef = _props.innerRef,
			    formats = _props.formats,
			    other = _objectWithoutProperties(_props, ['containerClassName', 'containerStyle', 'toolbar', 'innerRef', 'formats']),
			    editor = this.state.editor,
			    modules = this.modules;

			return React.createElement(
				EditorContext.Provider,
				{ value: editor },
				React.createElement(
					'div',
					{ className: containerClassName, style: containerStyle },
					toolbar,
					React.createElement(Quill, _extends({}, other, {
						modules: modules,
						formats: formats,
						ref: this.saveRef
					}))
				)
			);
		}
	}]);

	return QuillEditorEnhancer;
}(Component), _class.propTypes = {
	containerStyle: PropTypes.object,
	containerClassName: PropTypes.string,
	toolbar: PropTypes.node,
	modules: PropTypes.object,
	formats: PropTypes.array,
	innerRef: PropTypes.func
}, _class.defaultProps = {
	modules: {},
	toolbar: React.createElement(EditorToolbar, null),
	formats: formats
}, _temp);


export default createComponent(QuillEditorEnhancer, {
	displayName: 'Editor',
	getValueFromChangeEvent: function getValueFromChangeEvent(value) {
		return value;
	}
});