var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { createRef } from '../../utils/reactPolyfill';
import FormLayoutContext from '../../contexts/FormLayout';
import PropTypes from 'prop-types';
import { Form } from 'react-form-mobx';

var FormView = (_temp2 = _class = function (_Component) {
	_inherits(FormView, _Component);

	function FormView() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, FormView);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormView.__proto__ || Object.getPrototypeOf(FormView)).call.apply(_ref, [this].concat(args))), _this), _this.formRef = createRef(), _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(FormView, [{
		key: 'getChildContext',
		value: function getChildContext() {
			var layout = this.props.layout;

			return {
				vertical: layout === 'vertical'
			};
		}
	}, {
		key: 'submit',
		value: function submit() {
			var _formRef$current;

			(_formRef$current = this.formRef.current).submit.apply(_formRef$current, arguments);
		}
	}, {
		key: 'reset',
		value: function reset() {
			var _formRef$current2;

			(_formRef$current2 = this.formRef.current).reset.apply(_formRef$current2, arguments);
		}
	}, {
		key: 'clear',
		value: function clear() {
			var _formRef$current3;

			(_formRef$current3 = this.formRef.current).clear.apply(_formRef$current3, arguments);
		}
	}, {
		key: 'getValidState',
		value: function getValidState() {
			return this.formRef.current.getValidState();
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    layout = _props.layout,
			    prefixCls = _props.prefixCls,
			    className = _props.className,
			    labelCol = _props.labelCol,
			    wrapperCol = _props.wrapperCol,
			    render = _props.render,
			    wrapperStyle = _props.wrapperStyle,
			    colon = _props.colon,
			    other = _objectWithoutProperties(_props, ['layout', 'prefixCls', 'className', 'labelCol', 'wrapperCol', 'render', 'wrapperStyle', 'colon']);

			var customClassName = className ? ' ' + className : '';
			return React.createElement(
				FormLayoutContext.Provider,
				{ value: layout },
				React.createElement(Form, _extends({
					ref: this.formRef,
					className: prefixCls + '-' + layout + customClassName
				}, other))
			);
		}
	}]);

	return FormView;
}(Component), _class.propTypes = {
	prefixCls: PropTypes.string,
	layout: PropTypes.string,
	className: PropTypes.string
}, _class.defaultProps = {
	prefixCls: 'ant-form',
	layout: 'horizontal'
}, _class.childContextTypes = {
	vertical: PropTypes.bool
}, _temp2);
export { FormView as default };