import { style as _style } from 'antd/lib/form/style';
import _default from 'antd/lib/form';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import { Demon } from 'react-form-mobx';
var Item = _default.Item;


var defaultStyle = {
	marginBottom: 12
};

export default function createComponent(Comp) {
	var _class, _temp;

	var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

	var _options$displayName = options.displayName,
	    displayName = _options$displayName === undefined ? 'InputElement' : _options$displayName,
	    defaultProps = options.defaultProps,
	    _options$mapForwarded = options.mapForwardedProps,
	    mapForwardedProps = _options$mapForwarded === undefined ? function (props) {
		return props;
	} : _options$mapForwarded,
	    otherOptions = _objectWithoutProperties(options, ['displayName', 'defaultProps', 'mapForwardedProps']);

	return _temp = _class = function (_PureComponent) {
		_inherits(FormElement, _PureComponent);

		_createClass(FormElement, null, [{
			key: 'getDrivedStateFromProps',
			value: function getDrivedStateFromProps(_ref, state) {
				var wrapperStyle = _ref.wrapperStyle;

				if (wrapperStyle !== state.wrapperStyle) {
					return {
						wrapperStyle: wrapperStyle,
						style: _extends({}, defaultStyle, wrapperStyle)
					};
				}
				return null;
			}
		}]);

		function FormElement(props) {
			_classCallCheck(this, FormElement);

			var _this = _possibleConstructorReturn(this, (FormElement.__proto__ || Object.getPrototypeOf(FormElement)).call(this, props));

			var wrapperStyle = props.wrapperStyle;

			_this.state = {
				wrapperStyle: wrapperStyle,
				style: _extends({}, defaultStyle, wrapperStyle)
			};
			return _this;
		}

		_createClass(FormElement, [{
			key: 'render',
			value: function render() {
				var _props = this.props,
				    label = _props.label,
				    labelCol = _props.labelCol,
				    wrapperCol = _props.wrapperCol,
				    colon = _props.colon,
				    wrapperStyle = _props.wrapperStyle,
				    props = _objectWithoutProperties(_props, ['label', 'labelCol', 'wrapperCol', 'colon', 'wrapperStyle']);

				var style = this.state.style;


				return React.createElement(
					Demon,
					_extends({ forwardedProps: props }, otherOptions),
					function (forwardedProps, _ref2) {
						var isInvalid = _ref2.isInvalid,
						    isTouched = _ref2.isTouched,
						    errorMessage = _ref2.errorMessage;
						return React.createElement(
							Item,
							{
								label: label,
								labelCol: labelCol,
								wrapperCol: wrapperCol,
								colon: colon,
								required: props.required,
								validateStatus: isTouched && isInvalid ? 'error' : 'success',
								help: isTouched && isInvalid ? errorMessage : '',
								style: style
							},
							React.createElement(Comp, mapForwardedProps(forwardedProps))
						);
					}
				);
			}
		}]);

		return FormElement;
	}(PureComponent), _class.propTypes = {
		required: PropTypes.bool,
		label: PropTypes.node,
		labelCol: PropTypes.object,
		wrapperCol: PropTypes.object,
		colon: PropTypes.bool,
		wrapperStyle: PropTypes.object
	}, _class.displayName = displayName, _temp;
}