var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from '../../utils/PropTypes';
import { observer } from 'mobx-react';
import warning from 'warning';
import FormStore from '../../stores/FormStore';
import { Form } from '../Form';
import FormItem from '../FormItem';
import SpinBox from '../SpinBox';

var FormBody = observer(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(FormBody, _Component);

	function FormBody() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, FormBody);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormBody.__proto__ || Object.getPrototypeOf(FormBody)).call.apply(_ref, [this].concat(args))), _this), _this.formStore = new FormStore(), _this.isPristine = true, _this.isValid = true, _this.isOk = false, _this._handleChange = function (state) {
			var onChange = _this.props.onChange;

			onChange && onChange(state);
			_this.formStore.setState(state.value);
			if (_this.isPristine) {
				_this.isPristine = false;
				_this._handleStatusChange();
			}
		}, _this._handleValidChange = function (isValid) {
			var onValidChange = _this.props.onValidChange;

			onValidChange && onValidChange(isValid);
			_this.isValid = isValid;
			_this._handleStatusChange();
		}, _this._handleSubmit = function (body, state) {
			if (!state.isInvalid) {
				var _this2 = _this,
				    _this2$props = _this2.props,
				    onSubmit = _this2$props.onSubmit,
				    selectedKeys = _this2$props.selectedKeys;

				var options = { selectedKeys: selectedKeys };
				if (onSubmit) {
					onSubmit(body, state, options);
				}
			} else if (process.env.NODE_ENV !== 'production') {
				process.env.NODE_ENV !== 'production' ? warning(false, 'INVALID') : void 0;
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(FormBody, [{
		key: '_handleStatusChange',
		value: function _handleStatusChange() {
			var onStatusChange = this.props.onStatusChange;

			if (onStatusChange) {
				var ok = !this.isPristine && this.isValid;
				if (this.isOk !== ok) {
					this.isOk = ok;
					onStatusChange(ok);
				}
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    store = _props.store,
			    children = _props.children,
			    value = _props.value,
			    formRef = _props.formRef,
			    footer = _props.footer,
			    selectedKeys = _props.selectedKeys,
			    onStatusChange = _props.onStatusChange,
			    other = _objectWithoutProperties(_props, ['store', 'children', 'value', 'formRef', 'footer', 'selectedKeys', 'onStatusChange']),
			    formStore = this.formStore;

			if (store && store.isFetching) return React.createElement(SpinBox, null);
			return React.createElement(
				Form,
				_extends({}, other, {
					ref: formRef,
					value: value,
					onSubmit: this._handleSubmit,
					onChange: this._handleChange,
					onValidChange: this._handleValidChange
				}),
				store && store.renderers.map(function (_ref2, index) {
					var renderForm = _ref2.renderForm;
					return React.createElement(FormItem, {
						renderForm: renderForm,
						formStore: formStore,
						key: index
					});
				}),
				children,
				footer
			);
		}
	}]);

	return FormBody;
}(Component), _class2.propTypes = {
	store: PropTypes.object,
	children: PropTypes.node,
	selectedKeys: PropTypes.oneOfType([PropTypes.array, PropTypes.string]),
	value: PropTypes.any,
	footer: PropTypes.node,
	formRef: PropTypes.any,
	onChange: PropTypes.func,
	onSubmit: PropTypes.func,
	onValidChange: PropTypes.func,
	onStatusChange: PropTypes.func
}, _temp2)) || _class;

export { FormBody as default };