import PropTypes from 'prop-types';
import React, { cloneElement } from 'react';
import { observer } from 'mobx-react';
import FormLayoutContext from '../../contexts/FormLayout';

var formItemLayout = {
	labelCol: {
		xs: { span: 24 },
		sm: { span: 6 }
	},
	wrapperCol: {
		xs: { span: 24 },
		sm: { span: 18 }
	}
};

var FormItem = function FormItem(_ref) {
	var renderForm = _ref.renderForm,
	    formStore = _ref.formStore;

	var children = renderForm(formStore);
	if (!children) return null;
	return React.createElement(
		FormLayoutContext.Consumer,
		null,
		function (layout) {
			return layout === 'horizontal' ? cloneElement(children, formItemLayout) : children;
		}
	);
};

FormItem.propTypes = {
	renderForm: PropTypes.func.isRequired,
	formStore: PropTypes.object.isRequired
};

export default observer(FormItem);