import { style as _style2 } from 'antd/lib/icon/style';
import _default2 from 'antd/lib/icon';
import { style as _style } from 'antd/lib/menu/style';
import _default from 'antd/lib/menu';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import styles from './styles';
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { toJS } from 'mobx';
import { observer } from 'mobx-react';
import routerStore from '../../stores/routerStore';
import panelsStore from '../../stores/panelsStore';
import naviStore from '../../stores/naviStore';
import { Link } from 'react-router-dom';
var SubMenu = _default.SubMenu,
    MenuItem = _default.Item;

var Navi = observer(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(Navi, _Component);

	function Navi() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Navi);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Navi.__proto__ || Object.getPrototypeOf(Navi)).call.apply(_ref, [this].concat(args))), _this), _this._handleClick = function (_ref2) {
			var item = _ref2.item;

			if (panelsStore.isSidebarCollapsed) {
				routerStore.push(item.props.path);
			}
		}, _this._handleOpenChange = function (openKeys) {
			naviStore.openKeys = openKeys;
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Navi, [{
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			naviStore.disposer();
		}
	}, {
		key: '_renderLink',
		value: function _renderLink(_ref3) {
			var title = _ref3.title,
			    path = _ref3.path,
			    isInternalPath = _ref3.isInternalPath;
			var top = this.props.top;

			var collapsed = !top && panelsStore.isSidebarCollapsed;

			// To hide title when collapsed
			if (collapsed) {
				return React.createElement(
					'span',
					null,
					title
				);
			}

			if (isInternalPath) {
				return React.createElement(
					Link,
					{ to: path, style: styles.link },
					title
				);
			}

			return React.createElement(
				'a',
				{ href: path, style: styles.link },
				title
			);
		}
	}, {
		key: '_renderMenu',
		value: function _renderMenu(menuList) {
			var _this2 = this;

			if (!menuList) return;

			var itemStyle = this.props.itemStyle;

			return menuList.map(function (menu) {
				if (!menu.children) {
					return !menu.menuKey ? null : React.createElement(
						MenuItem,
						{ key: menu.menuKey, path: menu.path, style: itemStyle },
						menu.icon && React.createElement(_default2, { type: menu.icon }),
						_this2._renderLink(menu)
					);
				}
				return React.createElement(
					SubMenu,
					{
						key: menu.menuKey,
						title: React.createElement(
							'span',
							null,
							menu.icon && React.createElement(_default2, { type: menu.icon }),
							React.createElement(
								'span',
								null,
								menu.title
							)
						)
					},
					_this2._renderMenu(menu.children)
				);
			}).filter(Boolean);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    menu = _props.menu,
			    top = _props.top,
			    itemStyle = _props.itemStyle,
			    other = _objectWithoutProperties(_props, ['menu', 'top', 'itemStyle']);

			var openKeys = naviStore.openKeys,
			    selectedKeys = naviStore.selectedKeys;

			return React.createElement(
				_default,
				_extends({
					mode: top ? 'horizontal' : 'inline',
					theme: top ? 'light' : 'dark',
					selectedKeys: process.env.NODE_ENV !== 'production' ? toJS(selectedKeys) : selectedKeys,
					openKeys: openKeys,
					onClick: this._handleClick,
					onOpenChange: this._handleOpenChange
				}, other),
				this._renderMenu(menu)
			);
		}
	}]);

	return Navi;
}(Component), _class2.propTypes = {
	menu: PropTypes.any,
	top: PropTypes.bool,
	itemStyle: PropTypes.object
}, _class2.defaultProps = {
	top: false
}, _temp2)) || _class;

export { Navi as default };