function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import DocumentTitle from 'react-document-title';

function PageContainer(props, context) {
	var pageTitle = props.title,
	    other = _objectWithoutProperties(props, ['title']);

	var appTitle = context.appConfig.title;

	var title = pageTitle ? pageTitle + ' | ' + appTitle : appTitle;
	return React.createElement(
		DocumentTitle,
		{ title: title },
		React.createElement('div', other)
	);
}

PageContainer.propTypes = {
	title: PropTypes.string
};

PageContainer.contextTypes = {
	appConfig: PropTypes.object
};

export default PageContainer;