import { style as _style3 } from 'antd/lib/input/style';
import _default3 from 'antd/lib/input';
import { style as _style2 } from 'antd/lib/button/style';
import _default2 from 'antd/lib/button';
import { style as _style } from 'antd/lib/icon/style';
import _default from 'antd/lib/icon';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp2;

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import PropTypes from '../../utils/PropTypes';
import React, { Component } from 'react';
import { polyfill } from 'react-lifecycles-compat';
import styles from './styles';
import { isFunction } from '../../utils/fp';
import joinKeys from '../../utils/joinKeys';
import { observer } from 'mobx-react';
import { REF } from '../../constants/Actions';
import ModalControllerContext from '../Modal/ModalControllerContext';
import createComponent from '../Form/createComponent';

var RefSelector = observer(_class = polyfill(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(RefSelector, _Component);

	function RefSelector() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, RefSelector);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = RefSelector.__proto__ || Object.getPrototypeOf(RefSelector)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
			value: _this.props.value
		}, _this._handleClick = function (ev) {
			var _this2 = _this,
			    props = _this2.props,
			    _this2$props = _this2.props,
			    placeholder = _this2$props.placeholder,
			    style = _this2$props.style,
			    onKeyPress = _this2$props.onKeyPress,
			    onChange = _this2$props.onChange,
			    _save = _this2$props.save,
			    render = _this2$props.render,
			    other = _objectWithoutProperties(_this2$props, ['placeholder', 'style', 'onKeyPress', 'onChange', 'save', 'render']),
			    modalController = _this2.modalController;

			ev.preventDefault();
			modalController.open(REF, _extends({
				keys: '',
				save: function save(_ref2) {
					var _this3 = this;

					var refKeys = _ref2.refKeys,
					    refStore = _ref2.refStore;
					return _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
						var val, pathname, url, options;
						return regeneratorRuntime.wrap(function _callee$(_context) {
							while (1) {
								switch (_context.prev = _context.next) {
									case 0:
										val = void 0;

										if (!_save) {
											_context.next = 10;
											break;
										}

										pathname = refStore.pathname;
										url = joinKeys(refKeys) + ('/' + pathname + '/') + joinKeys(refKeys);
										options = _extends({
											method: 'POST',
											url: url
										}, props, {
											keys: '',
											refKeys: refKeys,
											refStore: refStore
										});
										_context.next = 7;
										return isFunction(_save) ? _save(options) : refStore.call(_save, options);

									case 7:
										val = _context.sent;
										_context.next = 11;
										break;

									case 10:
										val = refKeys[0];

									case 11:
										onChange(val, refStore);

									case 12:
									case 'end':
										return _context.stop();
								}
							}
						}, _callee, _this3);
					}))();
				}
			}, other));
		}, _this._handleChange = function (ev) {
			var value = ev.currentTarget.value;

			_this.setState({ value: value });
			_this.props.onChange(value);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(RefSelector, [{
		key: '_render',
		value: function _render() {
			var _props = this.props,
			    render = _props.render,
			    style = _props.style,
			    props = _objectWithoutProperties(_props, ['render', 'style']),
			    value = this.state.value;

			return React.createElement(
				'a',
				{
					onClick: this._handleClick,
					href: '#',
					style: _extends({}, styles.button, style)
				},
				render(value, props)
			);
		}
	}, {
		key: '_renderInput',
		value: function _renderInput() {
			var _props2 = this.props,
			    placeholder = _props2.placeholder,
			    style = _props2.style,
			    onKeyPress = _props2.onKeyPress,
			    value = this.state.value;


			return React.createElement(_default3, {
				style: _extends({}, styles.button, style),
				placeholder: placeholder,
				value: value,
				size: 'default',
				onChange: this._handleChange,
				onKeyPress: onKeyPress,
				className: 'ant-input-search ant-input-search-enter-button',
				suffix: React.createElement(
					_default2,
					{
						className: 'ant-input-search-button',
						onClick: this._handleClick
					},
					React.createElement(_default, { type: 'bars' })
				)
			});
		}
	}, {
		key: 'render',
		value: function render() {
			var _this4 = this;

			var render = this.props.render;

			return React.createElement(
				ModalControllerContext.Consumer,
				null,
				function (modalController) {
					_this4.modalController = modalController;
					return render ? _this4._render() : _this4._renderInput();
				}
			);
		}
	}], [{
		key: 'getDerivedStateFromProps',
		value: function getDerivedStateFromProps(_ref3, prevState) {
			var value = _ref3.value;

			return value !== prevState.value ? { value: value } : null;
		}
	}]);

	return RefSelector;
}(Component), _class2.propTypes = {
	table: PropTypes.string.isRequired,
	fetch: PropTypes.stringOrFunc,
	save: PropTypes.stringOrFunc,
	onChange: PropTypes.func,
	onKeyPress: PropTypes.func,
	value: PropTypes.any,
	placeholder: PropTypes.string,
	style: PropTypes.object,
	label: PropTypes.node,
	width: PropTypes.stringOrNumber,
	render: PropTypes.func
}, _class2.defaultProps = {
	placeholder: '',
	fetch: 'fetch',
	width: '80%'
}, _temp2)) || _class) || _class;

export default createComponent(RefSelector, {
	displayName: 'RefSelector',
	getValueFromChangeEvent: function getValueFromChangeEvent(val) {
		return val;
	}
});