import { style as _style } from 'antd/lib/layout/style';
import _default from 'antd/lib/layout';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import styles from './styles';
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { observer } from 'mobx-react';
import panelsStore from '../../stores/panelsStore';

import AppTitle from '../AppTitle';
import Navi from '../Navi';

var Sider = _default.Sider;

var Sidebar = observer(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(Sidebar, _Component);

	function Sidebar() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Sidebar);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Sidebar.__proto__ || Object.getPrototypeOf(Sidebar)).call.apply(_ref, [this].concat(args))), _this), _this._handleCollapse = function (collapsed) {
			panelsStore.updateSidebar(collapsed);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Sidebar, [{
		key: 'render',
		value: function render() {
			var _context$appConfig = this.context.appConfig,
			    menus = _context$appConfig.navigator.menus,
			    logoNode = _context$appConfig.logoNode;
			var isSidebarCollapsed = panelsStore.isSidebarCollapsed;

			return React.createElement(
				Sider,
				{
					collapsible: true,
					collapsed: isSidebarCollapsed,
					onCollapse: this._handleCollapse,
					style: styles.container
				},
				React.createElement(
					'div',
					{ style: styles.title },
					logoNode,
					React.createElement(AppTitle, {
						style: {
							width: isSidebarCollapsed ? 0 : 'auto',
							marginLeft: !isSidebarCollapsed && logoNode ? 8 : 0,
							opacity: isSidebarCollapsed ? 0 : 1,
							transition: 'opacity 0.2s'
						}
					})
				),
				React.createElement(Navi, { menu: menus })
			);
		}
	}]);

	return Sidebar;
}(Component), _class2.contextTypes = {
	appConfig: PropTypes.object
}, _temp2)) || _class;

export { Sidebar as default };