var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import styles from './styles';
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { observer } from 'mobx-react';
import localize from '../../hocs/localize';
import Pagination from '../Pagination';

var TableFooter = (_dec = localize('TableBody'), _dec(_class = observer(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(TableFooter, _Component);

	function TableFooter() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, TableFooter);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TableFooter.__proto__ || Object.getPrototypeOf(TableFooter)).call.apply(_ref, [this].concat(args))), _this), _this._handlePageChange = function (parameter) {
			var store = _this.props.store;
			var useCursor = store.useCursor;

			var query = _extends({}, store.query);
			if (useCursor) {
				query.cursor = parameter;
				store.setQueryWithCursor(query);
			} else {
				query.page = parameter;
				store.setQuery(query);
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(TableFooter, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    store = _props.store,
			    localeStore = _props.localeStore;
			var total = store.total,
			    size = store.size,
			    query = store.query;

			var current = +query.page || 1;
			return React.createElement(
				'div',
				{ style: styles.footer },
				(total || total === 0) && React.createElement(
					'p',
					{ style: styles.total },
					localeStore.data.total,
					': ',
					total
				),
				React.createElement(Pagination, {
					style: styles.pagination,
					current: current,
					total: total,
					pageSize: size,
					store: store,
					onChange: this._handlePageChange
				})
			);
		}
	}]);

	return TableFooter;
}(Component), _class2.propTypes = {
	localeStore: PropTypes.object.isRequired,
	store: PropTypes.shape({
		total: PropTypes.number,
		size: PropTypes.number.isRequired,
		query: PropTypes.object.isRequired
	})
}, _temp2)) || _class) || _class);
export { TableFooter as default };