import { style as _style } from 'antd/lib/table/style';
import _default from 'antd/lib/table';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from '../../utils/PropTypes';
import { toJS } from 'mobx';
import { observer } from 'mobx-react';
import { isEmpty } from '../../utils/fp';
import clearSortedInfo from '../../utils/clearSortedInfo';
import { TABLE } from '../../utils/Issuers';
import withIssuer from '../../hocs/withIssuer';
import TableContext from './TableContext';

import TableCell from './TableCell';
import TableHeadCell from './TableHeadCell';

var components = {
	header: { cell: TableHeadCell },
	body: { cell: TableCell }
};

var TableView = (_dec = withIssuer({ issuer: TABLE }), _dec(_class = observer(_class = (_temp = _class2 = function (_Component) {
	_inherits(TableView, _Component);

	function TableView(props) {
		_classCallCheck(this, TableView);

		var _this = _possibleConstructorReturn(this, (TableView.__proto__ || Object.getPrototypeOf(TableView)).call(this, props));

		_this._toggleSelectedKey = function (selectedRowKey) {
			if (_this.props.selectionType === 'radio') {
				_this.props.store.toggleSelectedKey(selectedRowKey);
			}
		};

		_this._handleSelectChange = function (selectedRowKeys) {
			_this.props.store.setSelectedKeys(selectedRowKeys);
		};

		_this._handleChange = function (pagination, filters, sorter) {
			var _extends2;

			var _this$context = _this.context,
			    appConfig = _this$context.appConfig,
			    _this$context$appConf = _this$context.appConfig.api,
			    sortKey = _this$context$appConf.sortKey,
			    orderKey = _this$context$appConf.orderKey,
			    descValue = _this$context$appConf.descValue,
			    ascValue = _this$context$appConf.ascValue,
			    store = _this.props.store;

			if (isEmpty(sorter)) {
				return clearSortedInfo(appConfig);
			}
			store.setQuery(_extends({}, store.query, (_extends2 = {}, _defineProperty(_extends2, sortKey, sorter.columnKey), _defineProperty(_extends2, orderKey, sorter.order === 'descend' ? descValue : ascValue), _extends2)));
		};

		_this.tableContext = { toggleSelectedKey: _this._toggleSelectedKey };
		return _this;
	}

	_createClass(TableView, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    store = _props.store,
			    selectionType = _props.selectionType;
			var columns = store.columns,
			    collection = store.collection,
			    isFetching = store.isFetching,
			    selectedKeys = store.selectedKeys,
			    uniqueKey = store.uniqueKey,
			    maxSelections = store.maxSelections,
			    config = store.config;


			var rowSelection = maxSelections ? {
				type: selectionType,
				selectedRowKeys: selectedKeys,
				onChange: this._handleSelectChange,
				getCheckboxProps: function getCheckboxProps(record) {
					return {
						disabled: selectionType === 'checkbox' && maxSelections > 0 && selectedKeys.length >= maxSelections && selectedKeys.indexOf(record[uniqueKey]) < 0
					};
				}
			} : undefined;

			return React.createElement(
				TableContext.Provider,
				{ value: this.tableContext },
				React.createElement(_default, {
					rowSelection: rowSelection,
					columns: columns,
					dataSource: toJS(collection),
					loading: isFetching,
					pagination: false,
					components: components,
					onChange: this._handleChange,
					size: config.viewSize
				})
			);
		}
	}]);

	return TableView;
}(Component), _class2.propTypes = {
	store: PropTypes.shape({
		columns: PropTypes.array.isRequired,
		collection: PropTypes.array,
		isFetching: PropTypes.bool.isRequired,
		size: PropTypes.number.isRequired,
		setSelectedKeys: PropTypes.func.isRequired,
		toggleSelectedKey: PropTypes.func.isRequired,
		query: PropTypes.object.isRequired,
		config: PropTypes.object.isRequired
	}),
	selectionType: PropTypes.oneOf(['checkbox', 'radio'])
}, _class2.defaultProps = {
	selectionType: 'checkbox'
}, _class2.contextTypes = {
	appConfig: PropTypes.object.isRequired
}, _temp)) || _class) || _class);
export { TableView as default };