import { style as _style2 } from 'antd/lib/row/style';
import _default2 from 'antd/lib/row';
import { style as _style } from 'antd/lib/col/style';
import _default from 'antd/lib/col';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _class, _class2, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import styles from './styles';
import React, { Component, Children } from 'react';
import PropTypes from 'prop-types';
import { observer } from 'mobx-react';
import { QUERIER } from '../../utils/Issuers';

import { Form, Submit, Reset } from '../Form';
import QueryItem from './QueryItem';
import localize from '../../hocs/localize';
import withIssuer from '../../hocs/withIssuer';
import FormStore from '../../stores/FormStore';

var FooterContainer = function FooterContainer(_ref) {
	var children = _ref.children;
	return React.createElement(
		_default2,
		null,
		React.createElement(
			_default,
			{ span: 24, style: styles.footer },
			children
		)
	);
};

FooterContainer.propTypes = {
	children: PropTypes.node
};

var TableQuery = (_dec = withIssuer({ issuer: QUERIER }), _dec2 = localize('TableQuery'), _dec(_class = _dec2(_class = observer(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(TableQuery, _Component);

	function TableQuery() {
		var _ref2;

		var _temp, _this, _ret;

		_classCallCheck(this, TableQuery);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = TableQuery.__proto__ || Object.getPrototypeOf(TableQuery)).call.apply(_ref2, [this].concat(args))), _this), _this.formStore = new FormStore(), _this._handleSearch = function (query) {
			_this.props.store.setQuery(query);
		}, _this._handleReset = function () {
			_this.props.store.setQuery({});
		}, _this._handleChange = function (state) {
			_this.formStore.setState(state);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(TableQuery, [{
		key: '_renderBody',
		value: function _renderBody() {
			var _props = this.props,
			    children = _props.children,
			    renderers = _props.store.renderers,
			    formStore = this.formStore;

			if (children) {
				return Children.map(children, function (child, index) {
					return React.createElement(
						QueryItem,
						{ key: index },
						child
					);
				});
			}
			return renderers.length > 0 && React.createElement(
				_default2,
				{ style: styles.main },
				renderers.map(function (_ref3, key) {
					var renderQuery = _ref3.renderQuery;
					return renderQuery(formStore, {
						key: key,
						children: function children(render) {
							if (!render) return null;
							var children = render();
							return children && React.createElement(
								QueryItem,
								null,
								children
							);
						}
					});
				})
			);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props2 = this.props,
			    header = _props2.header,
			    footer = _props2.footer,
			    children = _props2.children,
			    hidden = _props2.hidden,
			    store = _props2.store,
			    localeStore = _props2.localeStore;

			var shouldHide = hidden || (!children || !Children.count(children)) && (!store || !store.renderers.length || !store.queryFieldsCount);
			return React.createElement(
				Form,
				{
					style: styles.container(shouldHide && styles.hidden),
					value: store.query,
					onSubmit: this._handleSearch,
					onReset: this._handleReset,
					onChange: this._handleChange,
					layout: 'inline'
				},
				!!header && header,
				this._renderBody(),
				!!footer && React.createElement(
					FooterContainer,
					null,
					footer
				),
				!footer && React.createElement(
					FooterContainer,
					null,
					React.createElement(
						Submit,
						{ type: 'primary' },
						localeStore.data.search
					),
					React.createElement(
						Reset,
						null,
						localeStore.data.reset
					)
				)
			);
		}
	}]);

	return TableQuery;
}(Component), _class2.propTypes = {
	localeStore: PropTypes.object.isRequired,
	store: PropTypes.object,
	children: PropTypes.node,
	header: PropTypes.node,
	footer: PropTypes.node,
	hidden: PropTypes.bool
}, _class2.defaultProps = {
	store: {},
	hidden: false
}, _class2.contextTypes = {
	appConfig: PropTypes.object.isRequired
}, _temp2)) || _class) || _class) || _class);
export { TableQuery as default };