var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import { polyfill } from 'react-lifecycles-compat';
import StoreContext from '../../contexts/Store';
import routerStore from '../../stores/routerStore';
import authStore from '../../stores/authStore';
import tableStoreCache from './tableStoreCache';

var TableStoreInternal = polyfill(_class = (_temp = _class2 = function (_PureComponent) {
	_inherits(TableStoreInternal, _PureComponent);

	_createClass(TableStoreInternal, null, [{
		key: 'getDerivedStateFromProps',
		value: function getDerivedStateFromProps(_ref, prevState) {
			var table = _ref.table;

			if (!prevState.table || prevState.table === table) return null;
			return { store: prevState.getStore(table) };
		}
	}]);

	function TableStoreInternal(props, context) {
		_classCallCheck(this, TableStoreInternal);

		var _this = _possibleConstructorReturn(this, (TableStoreInternal.__proto__ || Object.getPrototypeOf(TableStoreInternal)).call(this, props, context));

		_initialiseProps.call(_this);

		var table = props.table,
		    parentStore = props.parentStore;

		var state = { store: null, getStore: _this._getStore };
		if (table) state.store = _this._getStore();else if (props.store) state.store = props.store;
		if (!state.store && parentStore) state.store = parentStore;
		_this.state = state;
		return _this;
	}

	_createClass(TableStoreInternal, [{
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			var store = this.store;

			store && store.unmount();
		}
	}, {
		key: 'render',
		value: function render() {
			var store = this.state.store,
			    children = this.props.children;

			return React.createElement(
				StoreContext.Provider,
				{ value: store },
				children({ store: store })
			);
		}
	}]);

	return TableStoreInternal;
}(PureComponent), _class2.propTypes = {
	children: PropTypes.func.isRequired,
	appConfig: PropTypes.object.isRequired,
	store: PropTypes.object,
	parentStore: PropTypes.object,
	table: PropTypes.string,
	type: PropTypes.string,
	useCache: PropTypes.bool,
	useRouter: PropTypes.bool,
	syncLocation: PropTypes.bool
}, _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this._getStore = function () {
		var _props = _this2.props,
		    table = _props.table,
		    useCache = _props.useCache,
		    useRouter = _props.useRouter,
		    syncLocation = _props.syncLocation,
		    type = _props.type,
		    appConfig = _props.appConfig;

		var store = tableStoreCache.ensureStore(table, {
			useCache: useCache,
			router: useRouter || syncLocation ? routerStore : null,
			type: type,
			authStore: authStore,
			appConfig: appConfig
		});
		store.mount();
		return store;
	};
}, _temp)) || _class;

export { TableStoreInternal as default };