var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import { observable } from 'mobx';
import getRequest from '../../utils/getRequest';
import DataListStore from '../../stores/DataListStore';
import DataDetailStore from '../../stores/DataDetailStore';

var TableStoreCache = function () {
	function TableStoreCache() {
		_classCallCheck(this, TableStoreCache);

		this.list = observable.map();
		this.detail = observable.map();
	}

	_createClass(TableStoreCache, [{
		key: 'ensureStore',
		value: function ensureStore(name) {
			var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
			var _options$type = options.type,
			    type = _options$type === undefined ? 'list' : _options$type,
			    config = options.config,
			    useCache = options.useCache,
			    router = options.router,
			    appConfig = options.appConfig,
			    authStore = options.authStore;


			var createStore = function createStore() {
				var Store = type === 'list' ? DataListStore : DataDetailStore;
				return new Store({
					name: name,
					appConfig: appConfig,
					authStore: authStore,
					baseRequest: getRequest(appConfig),
					config: config,
					router: router
				});
			};

			if (!~['list', 'detail'].indexOf(type)) {
				throw new Error('Only type "list" or "detail" is valid, but received "' + type + '"');
			}
			var stores = this[type];

			if (useCache) {
				if (stores.has(name)) {
					var store = stores.get(name);
					store.mount();
					return store;
				} else {
					var _store = createStore();
					stores.set(name, _store);
					return _store;
				}
			} else {
				return createStore();
			}
		}
	}]);

	return TableStoreCache;
}();

export default new TableStoreCache();