var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from '../../utils/PropTypes';
import { isFunction } from '../../utils/fp';
import localize from '../../hocs/localize';
import ContextButton from '../ContextButton';

var UpdateButton = (_dec = localize('UpdateButton'), _dec(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(UpdateButton, _Component);

	function UpdateButton() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, UpdateButton);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = UpdateButton.__proto__ || Object.getPrototypeOf(UpdateButton)).call.apply(_ref, [this].concat(args))), _this), _this._handleClick = function (ev, actions) {
			ev.preventDefault();
			var _this2 = _this,
			    localeStore = _this2.props.localeStore,
			    props = _this2.props;
			var update = actions.update;

			var params = _this._getModalParams(props, actions, localeStore);
			params ? update(params) : update();
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(UpdateButton, [{
		key: '_getModalParams',
		value: function _getModalParams(options, actions, localeStore) {
			var names = options.names,
			    title = options.title,
			    label = options.label,
			    table = options.table,
			    save = options.save;
			var getData = actions.getData;

			if (save || title || table || names) {
				var getTitle = title || localeStore.localizeProp(label, 'label');
				var params = {
					title: isFunction(getTitle) ? getTitle(getData()) : getTitle,
					save: save,
					names: names
				};
				if (table) params.table = table;
				return params;
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    title = _props.title,
			    table = _props.table,
			    save = _props.save,
			    names = _props.names,
			    localeStore = _props.localeStore,
			    other = _objectWithoutProperties(_props, ['title', 'table', 'save', 'names', 'localeStore']);

			return React.createElement(ContextButton, _extends({}, localeStore.localize(other), {
				onClick: this._handleClick,
				minSelected: 1
			}));
		}
	}]);

	return UpdateButton;
}(Component), _class2.propTypes = {
	localeStore: PropTypes.object.isRequired,
	table: PropTypes.string,
	title: PropTypes.stringOrFunc,
	label: PropTypes.stringOrFunc,
	multiLabel: PropTypes.stringOrFunc,
	names: PropTypes.array,
	save: PropTypes.stringOrFunc
}, _temp2)) || _class);
export { UpdateButton as default };