var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import { isValidElement } from 'react';
import jsxToPlainObject from '../../utils/jsxToPlainObject';
import { isUndefined, isObject, isFunction } from '../../utils/fp';
import warning from 'warning';
import * as SchemaComponents from '../../schemas';

var isNotEmpty = function isNotEmpty(object) {
	if (!object) return false;
	if (Array.isArray(object)) return !!object.length;
	for (var i in object) {
		return true;
	}return false;
};

var parseSchemaNodes = function parseSchemaNodes(nodes, defaults) {
	var config = {};
	var parse = function parse(nodes) {
		if (isValidElement(nodes)) {
			var component = nodes.type;
			if (!component || !isObject(component.configuration)) {
				process.env.NODE_ENV !== 'production' ? warning(false, nodes + ' is NOT a valid schema') : void 0;
			} else {
				var _component$configurat = component.configuration,
				    name = _component$configurat.name,
				    pipe = _component$configurat.pipe;

				var ctx = isUndefined(config[name]) ? defaults[name] : config[name];
				config[name] = pipe.call(ctx, nodes.props, ctx, config);
			}
			return config;
		} else if (Array.isArray(nodes)) {
			nodes.forEach(parse);
			return config;
		} else {
			return nodes;
		}
	};
	return parse(nodes);
};

// eslint-disable-next-line
var mapComponent = function mapComponent(key) {
	return SchemaComponents[key];
};
var valid = function valid(component) {
	return component.configuration;
};
var components = Object.keys(SchemaComponents).map(mapComponent).filter(valid);

export var configShape = components.reduce(function (shape, _ref) {
	var configuration = _ref.configuration;
	var propType = configuration.propType,
	    name = configuration.name;

	if (propType) shape[name] = propType;
	return shape;
}, {});

export function getAppConfig(props) {
	var configProp = props.config,
	    children = props.children,
	    other = _objectWithoutProperties(props, ['config', 'children']);

	var config = {};
	components.forEach(function (component) {
		var defaultProps = component.defaultProps,
		    _component$configurat2 = component.configuration,
		    initialData = _component$configurat2.initialData,
		    name = _component$configurat2.name;

		config[name] = function () {
			if (isFunction(initialData)) return initialData();
			if (!isUndefined(initialData)) return initialData;
			if (defaultProps) return _extends({}, defaultProps);
			return {};
		}();
	});
	var assignArgs = [];
	if (isNotEmpty(configProp)) assignArgs.push(configProp);
	if (isNotEmpty(children)) assignArgs.push(parseSchemaNodes(children, config));
	if (isNotEmpty(other)) assignArgs.push(other);
	if (assignArgs.length) {
		Object.assign(config, jsxToPlainObject(Object.assign.apply(Object, [{}].concat(assignArgs))));
	}
	return config;
}