var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from '../../utils/PropTypes';
import { observer } from 'mobx-react';
import panelsStore from '../../stores/panelsStore';
import withTable from '../../hocs/withTable';
import TableBody from '../../components/TableBody';
import TableQuery from '../../components/TableQuery';
import Toolbar from '../../components/Toolbar';
import { ModalProvider } from '../../components/Modal';

var DataTableView = (_dec = withTable({ syncLocation: true, useCache: true }), _dec(_class = observer(_class = (_temp = _class2 = function (_Component) {
	_inherits(DataTableView, _Component);

	function DataTableView(props) {
		_classCallCheck(this, DataTableView);

		var _this = _possibleConstructorReturn(this, (DataTableView.__proto__ || Object.getPrototypeOf(DataTableView)).call(this, props));

		props.store.clearCollections();
		return _this;
	}

	_createClass(DataTableView, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    table = _props.table,
			    menuTitle = _props.title,
			    pageTitle = _props.pageTitle,
			    Header = _props.header,
			    Footer = _props.footer,
			    Toolbar = _props.toolbar,
			    store = _props.store;

			var title = pageTitle || menuTitle || table;
			return React.createElement(
				'div',
				null,
				Header && React.createElement(Header, { store: store, title: title }),
				React.createElement(TableQuery, { store: store, hidden: !panelsStore.isShowQuery }),
				Toolbar && React.createElement(Toolbar, { store: store }),
				React.createElement(TableBody, { store: store }),
				Footer && React.createElement(Footer, { store: store })
			);
		}
	}]);

	return DataTableView;
}(Component), _class2.propTypes = {
	table: PropTypes.string.isRequired,
	title: PropTypes.string,
	pageTitle: PropTypes.string,
	header: PropTypes.component,
	footer: PropTypes.component,
	toolbar: PropTypes.component,
	store: PropTypes.object
}, _class2.defaultProps = {
	toolbar: Toolbar
}, _temp)) || _class) || _class);
export { DataTableView as default };