import { style as _style } from 'antd/lib/message/style';
import _default from 'antd/lib/message';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import styles from './styles';
import React, { Component } from 'react';
import { createRef } from '../../utils/reactPolyfill';
import PropTypes from '../../utils/PropTypes';
import { observer } from 'mobx-react';
import warning from 'warning';
import { isFunction } from '../../utils/fp';
import routerStore from '../../stores/routerStore';
import localize from '../../hocs/localize';
import withTable from '../../hocs/withTable';
import withIssuer from '../../hocs/withIssuer';
import { Submit } from '../../components/Form';
import PageTitle from '../../components/PageTitle';
import FormBody from '../../components/FormBody';
import { CREATER } from '../../utils/Issuers';


export default function createFormDetailView(defaultTitle, issuer, displayName) {
	var _dec, _dec2, _dec3, _class, _class2, _temp, _initialiseProps;

	var isCreater = issuer === CREATER;

	var FormDetailView = (_dec = localize('FormPage'), _dec2 = withIssuer({ issuer: issuer }), _dec3 = withTable({ syncLocation: true, type: 'detail' }), _dec(_class = _dec2(_class = _dec3(_class = observer(_class = (_temp = _class2 = function (_Component) {
		_inherits(FormDetailView, _Component);

		function FormDetailView(props) {
			_classCallCheck(this, FormDetailView);

			var _this = _possibleConstructorReturn(this, (FormDetailView.__proto__ || Object.getPrototypeOf(FormDetailView)).call(this, props));

			_initialiseProps.call(_this);

			var store = props.store,
			    match = props.match;

			var selectedKeys = (match.params.key || '').split(',');
			if (isCreater) {
				_this._createrValue = {};
			} else {
				store.setSelectedKeys(selectedKeys);
				store.call('fetch');
			}
			return _this;
		}

		_createClass(FormDetailView, [{
			key: '_redirectToUpdate',
			value: function _redirectToUpdate(store, responseData) {
				var _routerStore$location = routerStore.location,
				    pathname = _routerStore$location.pathname,
				    search = _routerStore$location.search;
				var uniqueKey = store.config.uniqueKey;

				if (uniqueKey && responseData && responseData[uniqueKey]) {
					var key = responseData[uniqueKey];
					var newPathname = pathname.replace(/create$/, 'update/' + key);
					var path = newPathname + search;
					routerStore.replace(path);
				}
			}
		}, {
			key: 'render',
			value: function render() {
				var _props = this.props,
				    store = _props.store,
				    Header = _props.header,
				    Footer = _props.footer,
				    match = _props.match,
				    pageTitle = _props.pageTitle,
				    localeStore = _props.localeStore,
				    _state = this.state,
				    isSubmitting = _state.isSubmitting,
				    isOk = _state.isOk;

				var title = localeStore.localizeProp(pageTitle, defaultTitle);
				return React.createElement(
					'div',
					null,
					React.createElement(
						'div',
						{ style: styles.container },
						Header ? React.createElement(Header, { title: title, store: store }) : React.createElement(PageTitle, { title: title }),
						React.createElement(FormBody, {
							ref: this.formRef,
							selectedKeys: match.params.key,
							value: isCreater ? this._createrValue : store.getData(),
							store: store,
							onSubmit: this._handleSubmit,
							onStatusChange: this._handleStatusChange,
							layout: 'vertical',
							footer: React.createElement(
								Submit,
								{
									disabled: !isOk,
									type: 'primary',
									size: 'large',
									loading: isSubmitting
								},
								localeStore.data.submit
							)
						}),
						Footer && React.createElement(Footer, { store: store })
					)
				);
			}
		}]);

		return FormDetailView;
	}(Component), _class2.displayName = displayName, _class2.propTypes = {
		match: PropTypes.object.isRequired,
		store: PropTypes.object.isRequired,
		save: PropTypes.stringOrFunc,
		pageTitle: PropTypes.string,
		header: PropTypes.component,
		footer: PropTypes.component,
		localeStore: PropTypes.object.isRequired
	}, _class2.defaultProps = {
		save: isCreater ? 'create' : 'update'
	}, _initialiseProps = function _initialiseProps() {
		var _this2 = this;

		this.state = {
			isOk: false,
			isSubmitting: false
		};
		this.formRef = createRef();

		this._handleStatusChange = function (isOk) {
			if (_this2.state.isOk !== isOk) {
				_this2.setState({ isOk: isOk });
			}
		};

		this._handleSubmit = function () {
			var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(body, state, _ref2) {
				var selectedKeys = _ref2.selectedKeys;
				var props, save, store, localeStore, reqParams, responseData;
				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_this2.setState({ isSubmitting: true });
								props = _this2.props;
								save = props.save, store = props.store, localeStore = props.localeStore;
								_context.prev = 3;
								reqParams = _extends({}, props, {
									url: selectedKeys,
									body: body,
									refresh: false,
									throwError: true
								});

								if (!isFunction(save)) {
									_context.next = 11;
									break;
								}

								_context.next = 8;
								return save(reqParams);

							case 8:
								_context.t0 = _context.sent;
								_context.next = 14;
								break;

							case 11:
								_context.next = 13;
								return store.call(save, reqParams);

							case 13:
								_context.t0 = _context.sent;

							case 14:
								responseData = _context.t0;

								_this2.setState({ isSubmitting: false });
								_default.info(localeStore.data.successful);
								if (isCreater) {
									_this2._redirectToUpdate(store, responseData);
								}
								_context.next = 25;
								break;

							case 20:
								_context.prev = 20;
								_context.t1 = _context['catch'](3);

								_this2.setState({ isSubmitting: false });
								_default.error(localeStore.data.failed);
								process.env.NODE_ENV !== 'production' ? warning(false, _context.t1.message) : void 0;

							case 25:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, _this2, [[3, 20]]);
			}));

			return function (_x, _x2, _x3) {
				return _ref.apply(this, arguments);
			};
		}();
	}, _temp)) || _class) || _class) || _class) || _class);


	return FormDetailView;
}