import { style as _style } from 'antd/lib/layout/style';
import _default from 'antd/lib/layout';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import styles from './styles';
import React, { Component } from 'react';
import { Switch } from 'react-router-dom';
import PropTypes from 'prop-types';
import panelsStore from '../../stores/panelsStore';
import authStore from '../../stores/authStore';
import routerStore from '../../stores/routerStore';
import naviStore from '../../stores/naviStore';
import { observer } from 'mobx-react';
import Sidebar from '../../components/Sidebar';

import SpinBox from '../../components/SpinBox';
import FrameHeader from '../../components/FrameHeader';
import Breadcrumb from '../../components/Breadcrumb';
import { ModalProvider } from '../../components/Modal';

var Header = _default.Header,
    Content = _default.Content,
    Footer = _default.Footer;

var FrameView = observer(_class = (_temp = _class2 = function (_Component) {
	_inherits(FrameView, _Component);

	function FrameView(props, context) {
		_classCallCheck(this, FrameView);

		var _this = _possibleConstructorReturn(this, (FrameView.__proto__ || Object.getPrototypeOf(FrameView)).call(this, props, context));

		var menus = context.appConfig.navigator.menus;
		var location = routerStore.location;

		naviStore.init(menus, location);
		return _this;
	}

	_createClass(FrameView, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this._requestAuth();
		}
	}, {
		key: '_requestAuth',
		value: function () {
			var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
				var _routerStore$location, pathname, search, isOk;

				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_routerStore$location = routerStore.location, pathname = _routerStore$location.pathname, search = _routerStore$location.search;
								_context.next = 3;
								return authStore.auth();

							case 3:
								isOk = _context.sent;

								if (!isOk) {
									routerStore.history.replace({
										pathname: '/login',
										search: 'ref=' + (pathname + search)
									});
								}

							case 5:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			function _requestAuth() {
				return _ref.apply(this, arguments);
			}

			return _requestAuth;
		}()
	}, {
		key: 'render',
		value: function render() {
			if (authStore.isFetching || !authStore.accessToken) {
				return React.createElement(SpinBox, { delay: 800, style: styles.spinContainer, component: _default });
			}

			var _props = this.props,
			    routes = _props.routes,
			    footer = _props.footer;

			return React.createElement(
				_default,
				{ style: styles.container },
				React.createElement(Sidebar, null),
				React.createElement(
					_default,
					{
						style: { marginLeft: panelsStore.isSidebarCollapsed ? 80 : 200 }
					},
					React.createElement(
						Header,
						{ style: styles.header },
						React.createElement(
							'div',
							{ style: styles.headerLeft },
							React.createElement(Breadcrumb, { style: styles.breadcrumb })
						),
						React.createElement(FrameHeader, { style: styles.headerRight })
					),
					React.createElement(
						Content,
						{ style: styles.content },
						React.createElement(
							ModalProvider,
							{ style: styles.contentBody },
							React.createElement(
								Switch,
								null,
								routes
							)
						)
					),
					!!footer && React.createElement(
						Footer,
						{ style: styles.footer },
						footer
					)
				)
			);
		}
	}]);

	return FrameView;
}(Component), _class2.propTypes = {
	routes: PropTypes.node.isRequired,
	footer: PropTypes.node
}, _class2.contextTypes = {
	appConfig: PropTypes.object
}, _temp)) || _class;

export { FrameView as default };