var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component, Children, cloneElement } from 'react';
import PropTypes from '../../utils/PropTypes';
import { isFunction } from '../../utils/fp';
import withStore from '../../hocs/withStore';
import TableRowKeyContext from '../../contexts/TableRowKey';

var ActionInternalView = (_dec = withStore(), _dec(_class = (_temp = _class2 = function (_Component) {
	_inherits(ActionInternalView, _Component);

	function ActionInternalView() {
		_classCallCheck(this, ActionInternalView);

		return _possibleConstructorReturn(this, (ActionInternalView.__proto__ || Object.getPrototypeOf(ActionInternalView)).apply(this, arguments));
	}

	_createClass(ActionInternalView, [{
		key: '_renderChildren',
		value: function _renderChildren(_ref) {
			var children = _ref.children,
			    tableRowKey = _ref.tableRowKey,
			    store = _ref.store;

			var list = isFunction(children) ? children(store.getData(tableRowKey)) : children;
			var childrenArr = [];
			var length = Children.count(list);
			Children.forEach(list, function (child, index) {
				childrenArr.push(cloneElement(child, { key: index + '@1' }));
				if (index < length - 1) {
					childrenArr.push(React.createElement('span', { className: 'ant-divider', key: index + '@2' }));
				}
			});
			return childrenArr;
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    tableRowKey = _props.tableRowKey,
			    restProps = _objectWithoutProperties(_props, ['tableRowKey']);

			return React.createElement(
				TableRowKeyContext.Provider,
				{ value: tableRowKey },
				React.createElement(
					'div',
					null,
					this._renderChildren(restProps)
				)
			);
		}
	}]);

	return ActionInternalView;
}(Component), _class2.propTypes = {
	children: PropTypes.nodeOrFunc.isRequired,
	tableRowKey: PropTypes.string,
	store: PropTypes.object.isRequired
}, _temp)) || _class);
export { ActionInternalView as default };