var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import PropTypes from 'prop-types';
import { DateTimePicker } from '../../components/Form';
import field from '../../hocs/field';
import moment from 'moment';
import { isString, isObject, isFunction } from '../../utils/fp';
import renderDate from '../../utils/renderDate';

var buildInDefaultProps = {
	inputFilter: function inputFilter(val) {
		if (!val) return;
		if (isObject(val)) return val;
		if (isString(val)) return moment(val);
	},
	outputFilter: function outputFilter(val) {
		if (!val) return;
		if (isFunction(val.toISOString)) return val.toISOString();
		if (isString(val)) return val;
	}
};

function DateTimePickerField(props) {
	return React.createElement(DateTimePicker, _extends({
		defaultValue: undefined
	}, props, buildInDefaultProps));
}

/* eslint-disable react/prop-types */
DateTimePickerField.renderTable = function renderTable(_ref, _ref2) {
	var format = _ref.format,
	    dateFormat = _ref.dateFormat;
	var value = _ref2.value;

	return React.createElement(
		'span',
		null,
		renderDate(value, format, dateFormat)
	);
};

DateTimePickerField.propTypes = {
	format: PropTypes.string,
	dateFormat: PropTypes.string
};

DateTimePickerField.defaultProps = {
	format: 'dateTime'
};

export default field(DateTimePickerField);