import { style as _style } from 'antd/lib/modal/style';
import _default from 'antd/lib/modal';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import styles from './styles';
import React, { Component } from 'react';
import PropTypes from '../../utils/PropTypes';

import resizeMode from './resizeMode';
import { returnsArgument } from 'empty-functions';

var BLANK_IMAGE = 'data:image/gif;base64,R0lGODlhAQABAAAAACH5BAEKAAEALAAAAAABAAEAAAICTAEAOw==';

var ImageTableCell = (_temp2 = _class = function (_Component) {
	_inherits(ImageTableCell, _Component);

	function ImageTableCell() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, ImageTableCell);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ImageTableCell.__proto__ || Object.getPrototypeOf(ImageTableCell)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
			previewVisible: false
		}, _this._handleCloseModal = function () {
			_this.setState({ previewVisible: false });
		}, _this._handlePreview = function () {
			_this.setState({ previewVisible: true });
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(ImageTableCell, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    url = _props.url,
			    thumbWidth = _props.thumbWidth,
			    thumbHeight = _props.thumbHeight,
			    resizeMode = _props.resizeMode,
			    thumbStyle = _props.thumbStyle,
			    previewVisible = this.state.previewVisible;

			return React.createElement(
				'div',
				null,
				React.createElement(
					_default,
					{
						visible: previewVisible,
						footer: null,
						onCancel: this._handleCloseModal
					},
					React.createElement('img', { style: styles.image, src: url })
				),
				React.createElement('img', {
					src: url,
					style: _extends({}, styles.thumb, {
						width: thumbWidth,
						height: thumbHeight,
						objectFit: resizeMode
					}, thumbStyle),
					onClick: this._handlePreview
				})
			);
		}
	}]);

	return ImageTableCell;
}(Component), _class.propTypes = {
	url: PropTypes.string,
	thumbHeight: PropTypes.stringOrNumber,
	thumbWidth: PropTypes.stringOrNumber,
	resizeMode: PropTypes.oneOf(Object.keys(resizeMode).map(returnsArgument)),
	thumbStyle: PropTypes.object
}, _class.BLANK_IMAGE = BLANK_IMAGE, _class.defaultProps = {
	url: BLANK_IMAGE,
	thumbWidth: 64,
	thumbHeight: 64,
	resizeMode: 'fill'
}, _temp2);
export { ImageTableCell as default };