import { style as _style } from 'antd/lib/form/style';
import _default from 'antd/lib/form';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import styles from './styles';
import React, { Component, Children, cloneElement } from 'react';
import PropTypes from '../../utils/PropTypes';
import field from '../../hocs/field';
import { ObjectOf as FormObjectOf } from 'react-form-mobx';

import { createRef } from '../../utils/reactPolyfill';

var Item = _default.Item;


var formItemLayout = {
	labelCol: { span: 14 },
	wrapperCol: { span: 14 }
};

var ObjectOf = field(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(ObjectOf, _Component);

	function ObjectOf() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, ObjectOf);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ObjectOf.__proto__ || Object.getPrototypeOf(ObjectOf)).call.apply(_ref, [this].concat(args))), _this), _this.objRef = createRef(), _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(ObjectOf, [{
		key: 'getChildContext',
		value: function getChildContext() {
			return {
				vertical: true
			};
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    label = _props.label,
			    labelCol = _props.labelCol,
			    wrapperCol = _props.wrapperCol,
			    colon = _props.colon,
			    required = _props.required,
			    wrapperStyle = _props.wrapperStyle,
			    prefixCls = _props.prefixCls,
			    other = _objectWithoutProperties(_props, ['children', 'label', 'labelCol', 'wrapperCol', 'colon', 'required', 'wrapperStyle', 'prefixCls']);

			return React.createElement(
				Item,
				{
					label: label,
					labelCol: labelCol,
					wrapperCol: wrapperCol,
					colon: colon,
					required: required
					// validateStatus={isValid ? 'error' : 'success'}
					// help={errorMessage}
					, style: wrapperStyle
				},
				React.createElement(
					FormObjectOf,
					_extends({}, other, { ref: this.objRef }),
					React.createElement(
						'div',
						{ className: prefixCls + '-vertical', style: styles.main },
						Children.map(children, function (child) {
							return cloneElement(child, formItemLayout);
						})
					)
				)
			);
		}
	}], [{
		key: 'renderTable',
		value: function renderTable(props, _ref2) {
			var _ref2$text = _ref2.text,
			    text = _ref2$text === undefined ? {} : _ref2$text;

			return JSON.stringify(text);
		}
	}]);

	return ObjectOf;
}(Component), _class2.propTypes = {
	name: PropTypes.string,
	children: PropTypes.node,
	required: PropTypes.bool,
	label: PropTypes.node,
	labelCol: PropTypes.object,
	wrapperCol: PropTypes.object,
	colon: PropTypes.bool,
	wrapperStyle: PropTypes.object,
	prefixCls: PropTypes.string
}, _class2.defaultProps = {
	prefixCls: 'ant-form'
}, _class2.childContextTypes = {
	vertical: PropTypes.bool
}, _temp2)) || _class;

export { ObjectOf as default };