var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

import React from 'react';
import { RangePicker } from '../../components/Form';
import moment from 'moment';
import field from '../../hocs/field';
import { formatHelper } from 'react-form-mobx';
import { isString, isObject, isFunction, isUndefined } from '../../utils/fp';

var rangeInputFilter = function rangeInputFilter(range) {
	return range.map(function (val) {
		if (isObject(val)) {
			return val;
		} else if (isString(val)) {
			return moment(val);
		}
	});
};

var rangeOutputFilter = function rangeOutputFilter(range) {
	var output = range.map(function (val) {
		if (val && isFunction(val.toISOString)) {
			return val.toISOString();
		} else if (isString(val)) {
			return val;
		}
	}).filter(function (val) {
		return val;
	}).join(',');
	return output;
};

var formatFunc = function formatFunc(val) {
	return val.filter(Boolean).map(function (date) {
		return formatHelper.date(date);
	});
};

var buildInDefaultProps = {
	preFormat: function preFormat(val) {
		if (isString(val)) return val.split(',');
		return val;
	},
	inputFilter: function inputFilter() {
		var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

		if (isFunction(value.map)) {
			return rangeInputFilter(value);
		} else if (isFunction(value.split)) {
			var _value$split = value.split(','),
			    _value$split2 = _slicedToArray(_value$split, 2),
			    v0 = _value$split2[0],
			    v1 = _value$split2[1];

			return v0 && v1 ? [moment(v0), moment(v1)] : undefined;
		}
		return [undefined, undefined];
	},
	outputFilter: function outputFilter(value) {
		if (value && isFunction(value.map)) {
			return rangeOutputFilter(value);
		}
		return value;
	}
};

var isEmpty = function isEmpty(val) {
	if (!val) {
		return true;
	}
	if (isFunction(val.every)) {
		return val.every(function (item) {
			return isUndefined(item);
		});
	}
	return false;
};

// TODO: add should ignore support
var shouldIgnore = function shouldIgnore(value, pristineValue) {
	return isEmpty(value) && isEmpty(pristineValue);
};

function RangePickerField(props) {
	return React.createElement(RangePicker, _extends({}, buildInDefaultProps, props, { formatFunc: formatFunc }));
}

export default field(RangePickerField);