var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp2;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { isObject } from '../../utils/fp';
import warning from 'warning';
import field from '../../hocs/field';
import withAppConfig from '../../hocs/withAppConfig';
import RefSelector from '../../components/RefSelector';

var isRefObjectValue = function isRefObjectValue(val) {
	return val && isObject(val);
};

var warned = false;

var RefField = (_dec = withAppConfig(function (appConfig, props) {
	var tableConfig = appConfig.tables[props.table];
	if (tableConfig) return { tableUniqueKey: tableConfig.uniqueKey };
}), _dec(_class = field(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(RefField, _Component);

	function RefField() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, RefField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = RefField.__proto__ || Object.getPrototypeOf(RefField)).call.apply(_ref, [this].concat(args))), _this), _this._inputFilter = function (val) {
			if (isRefObjectValue(val)) {
				var tableUniqueKey = _this.props.tableUniqueKey;

				return val[tableUniqueKey];
			}
			return val;
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(RefField, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    tableUniqueKey = _props.tableUniqueKey,
			    other = _objectWithoutProperties(_props, ['tableUniqueKey']);

			return React.createElement(RefSelector, _extends({ inputFilter: this._inputFilter }, other));
		}
	}], [{
		key: 'renderTable',
		value: function renderTable(props, _ref2) {
			var value = _ref2.value;

			var content = value;
			if (isRefObjectValue(value)) {
				var displayField = props.displayField;

				if (displayField) {
					content = value[displayField];
				} else {
					process.env.NODE_ENV !== 'production' ? warning(warned, 'It\'s recommeded to set a `displayField` in Ref component') : void 0;
					warned = true;
					try {
						content = JSON.stringify(value);
					} catch (err) {}
				}
			}
			return React.createElement(
				'span',
				null,
				content
			);
		}
	}]);

	return RefField;
}(Component), _class2.propTypes = {
	table: PropTypes.string.isRequired,
	tableUniqueKey: PropTypes.string.isRequired,
	displayField: PropTypes.string
}, _temp2)) || _class) || _class);
export { RefField as default };