import { style as _style2 } from 'antd/lib/button/style';
import _default2 from 'antd/lib/button';
import { style as _style } from 'antd/lib/icon/style';
import _default from 'antd/lib/icon';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _class3, _temp;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _initDefineProp(target, property, descriptor, context) {
	if (!descriptor) return;
	Object.defineProperty(target, property, {
		enumerable: descriptor.enumerable,
		configurable: descriptor.configurable,
		writable: descriptor.writable,
		value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
	});
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}

function _initializerWarningHelper(descriptor, context) {
	throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

import React, { Component } from 'react';
import { createRef } from '../../utils/reactPolyfill';
import PropTypes from 'prop-types';
import { observable, action } from 'mobx';
import { observer } from 'mobx-react';
import withAppConfig from '../../hocs/withAppConfig';
import field from '../../hocs/field';
import ensureFileList from '../../utils/ensureFileList';

import { Upload } from '../../components/Form';

var Uploader = (_dec = withAppConfig(function (_ref) {
	var upload = _ref.upload;
	return {
		requireAccessToken: upload.requireAccessToken,
		mapFileList: upload.mapFileList,
		filePath: upload.filePath
	};
}), field(_class = _dec(_class = observer(_class = (_class2 = (_temp = _class3 = function (_Component) {
	_inherits(Uploader, _Component);

	function Uploader(props, context) {
		_classCallCheck(this, Uploader);

		var _this = _possibleConstructorReturn(this, (Uploader.__proto__ || Object.getPrototypeOf(Uploader)).call(this, props, context));

		_initDefineProp(_this, 'fileList', _descriptor, _this);

		_initDefineProp(_this, '_handleChange', _descriptor2, _this);

		_initDefineProp(_this, '_handleRemove', _descriptor3, _this);

		var authStore = context.authStore,
		    appConfig = context.appConfig;
		var filePath = props.filePath,
		    requireAccessToken = props.requireAccessToken;
		var accessTokenName = appConfig.api.accessTokenName;

		// TODO: should suppport `accessToken` in header

		var search = requireAccessToken ? '?' + accessTokenName + '=' + authStore.accessToken : '';
		_this._uploadPath = filePath + search;
		_this.uploadRef = createRef();
		return _this;
	}

	_createClass(Uploader, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			var value = this.uploadRef.current.getValue();
			this.fileList = ensureFileList(value);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    requireAccessToken = _props.requireAccessToken,
			    filePath = _props.filePath,
			    max = _props.max,
			    other = _objectWithoutProperties(_props, ['requireAccessToken', 'filePath', 'max']),
			    _uploadPath = this._uploadPath,
			    fileList = this.fileList;

			var uploadButton = React.createElement(
				_default2,
				null,
				React.createElement(_default, { type: 'upload' }),
				' Upload'
			);

			return React.createElement(
				Upload,
				_extends({}, other, {
					action: _uploadPath,
					fileList: fileList,
					onChange: this._handleChange,
					multiple: max > 1,
					noFieldDecorator: true,
					onRemove: this._handleRemove,
					ref: this.uploadRef
				}),
				fileList.length < max ? uploadButton : null
			);
		}
	}]);

	return Uploader;
}(Component), _class3.propTypes = {
	max: PropTypes.number,
	requireAccessToken: PropTypes.bool,
	filePath: PropTypes.string,
	mapFileList: PropTypes.func // required by `Upload` component
}, _class3.defaultProps = {
	max: 1
}, _class3.contextTypes = {
	authStore: PropTypes.object.isRequired,
	appConfig: PropTypes.object.isRequired
}, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'fileList', [observable], {
	enumerable: true,
	initializer: function initializer() {
		return [];
	}
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, '_handleChange', [action], {
	enumerable: true,
	initializer: function initializer() {
		var _this2 = this;

		return function (_ref2) {
			var fileList = _ref2.fileList;

			_this2.fileList = fileList;
		};
	}
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, '_handleRemove', [action], {
	enumerable: true,
	initializer: function initializer() {
		var _this3 = this;

		return function (file) {
			var index = _this3.fileList.findIndex(function (_ref3) {
				var id = _ref3.id;
				return id === file.id;
			});
			var shouldRemove = index > -1;
			if (shouldRemove) _this3.fileList.splice(index, 1);
		};
	}
})), _class2)) || _class) || _class) || _class);
export { Uploader as default };