var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { observer } from 'mobx-react';
import warning from 'warning';
import LocaleStores from '../../stores/LocaleStores';
import hoist, { extractRef } from '../hoist';

export default function localize(name) {
	var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	var _options$prop = options.prop,
	    prop = _options$prop === undefined ? 'localeStore' : _options$prop;

	return function createLocalizedComponent(WrappedComponent) {
		var _dec, _class;

		var hasLocale = LocaleStores.test(name);
		var storeProps = {};
		process.env.NODE_ENV !== 'production' ? warning(hasLocale, 'locale component "' + name + '" not found') : void 0;
		if (hasLocale) storeProps[prop] = LocaleStores.ensure(name);

		var Locale = (_dec = hoist(WrappedComponent), _dec(_class = observer(_class = function (_Component) {
			_inherits(Locale, _Component);

			function Locale() {
				_classCallCheck(this, Locale);

				return _possibleConstructorReturn(this, (Locale.__proto__ || Object.getPrototypeOf(Locale)).apply(this, arguments));
			}

			_createClass(Locale, [{
				key: 'render',
				value: function render() {
					return React.createElement(WrappedComponent, _extends({}, extractRef(this.props), storeProps));
				}
			}]);

			return Locale;
		}(Component)) || _class) || _class);


		return Locale;
	};
}