var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { observer } from 'mobx-react';
import Actions from './Actions';
import hoist, { extractRef } from '../hoist';
import withStore from '../withStore';
import withIssuer from '../withIssuer';
import ModalControllerContext from '../../components/Modal/ModalControllerContext';
import PageContext from '../../contexts/PageContext';
import TableRowKeyContext from '../../contexts/TableRowKey';

// Notice that this `Action` is NOT Redux or MobX action.
export default function withActions(WrappedComponent) {
	var _dec, _dec2, _dec3, _class, _class2, _temp2;

	var WithActions = (_dec = hoist(WrappedComponent), _dec2 = withIssuer(), _dec3 = withStore(), _dec(_class = _dec2(_class = _dec3(_class = observer(_class = (_temp2 = _class2 = function (_Component) {
		_inherits(WithActions, _Component);

		function WithActions() {
			var _ref;

			var _temp, _this, _ret;

			_classCallCheck(this, WithActions);

			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WithActions.__proto__ || Object.getPrototypeOf(WithActions)).call.apply(_ref, [this].concat(args))), _this), _this.actions = new Actions(_this), _temp), _possibleConstructorReturn(_this, _ret);
		}

		_createClass(WithActions, [{
			key: 'render',
			value: function render() {
				var _this2 = this;

				var _props = this.props,
				    store = _props.store,
				    pageContext = _props.pageContext,
				    tableRowKey = _props.tableRowKey,
				    enforceModal = _props.enforceModal,
				    props = _objectWithoutProperties(_props, ['store', 'pageContext', 'tableRowKey', 'enforceModal']),
				    actions = this.actions;

				return React.createElement(
					ModalControllerContext.Consumer,
					null,
					function (modalController) {
						_this2.modalController = modalController;
						return React.createElement(WrappedComponent, _extends({}, extractRef(props), { actions: actions }));
					}
				);
			}
		}]);

		return WithActions;
	}(Component), _class2.propTypes = {
		store: PropTypes.object.isRequired,
		issuers: PropTypes.instanceOf(Set).isRequired,
		pageContext: PropTypes.object,
		tableRowKey: PropTypes.string,
		enforceModal: PropTypes.bool
	}, _class2.defaultProps = {
		enforceModal: false
	}, _temp2)) || _class) || _class) || _class) || _class);


	function WithActionsWrapper(props) {
		return React.createElement(
			PageContext.Consumer,
			null,
			function (pageContext) {
				return React.createElement(
					TableRowKeyContext.Consumer,
					null,
					function (tableRowKey) {
						return React.createElement(WithActions, _extends({}, props, {
							pageContext: pageContext,
							tableRowKey: tableRowKey
						}));
					}
				);
			}
		);
	}

	return WithActionsWrapper;
}