var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import { createContext } from '../../utils/reactPolyfill';
import hoist, { extractRef } from '../hoist';

var IssuerContext = createContext(new Set());
IssuerContext.displayName = 'IssuerContext';

var extendIssuers = function extendIssuers(issuers, issuer) {
	var newIssuers = new Set(issuers);
	newIssuers.add(issuer);
	return newIssuers;
};

export default function withIssuer() {
	var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	var issuer = options.issuer;


	return function createIssuerComponent(WrappedComponent) {
		var _dec, _class, _class2, _temp;

		var WithIssuer = (_dec = hoist(WrappedComponent), _dec(_class = (_temp = _class2 = function (_Component) {
			_inherits(WithIssuer, _Component);

			function WithIssuer() {
				_classCallCheck(this, WithIssuer);

				return _possibleConstructorReturn(this, (WithIssuer.__proto__ || Object.getPrototypeOf(WithIssuer)).apply(this, arguments));
			}

			_createClass(WithIssuer, [{
				key: '_renderProvider',
				value: function _renderProvider(issuers) {
					return React.createElement(
						IssuerContext.Provider,
						{ value: extendIssuers(issuers, issuer) },
						React.createElement(WrappedComponent, extractRef(this.props))
					);
				}
			}, {
				key: '_renderConsumer',
				value: function _renderConsumer(issuers) {
					return React.createElement(WrappedComponent, _extends({}, extractRef(this.props), { issuers: issuers }));
				}
			}, {
				key: 'render',
				value: function render() {
					var _this2 = this;

					return React.createElement(
						IssuerContext.Consumer,
						null,
						function (issuers) {
							return issuer ? _this2._renderProvider(issuers) : _this2._renderConsumer(issuers);
						}
					);
				}
			}]);

			return WithIssuer;
		}(Component), _class2.defaultProps = _extends({}, WrappedComponent.defaultProps), _temp)) || _class);

		return WithIssuer;
	};
}