var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import hoist, { extractRef } from '../hoist';
import StoreContext from '../../contexts/Store';

export default function withStore() {
	var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	var _options$prop = options.prop,
	    prop = _options$prop === undefined ? 'store' : _options$prop;

	return function createStoreComponent(WrappedComponent) {
		var _dec, _class;

		var WithStore = (_dec = hoist(WrappedComponent), _dec(_class = function (_Component) {
			_inherits(WithStore, _Component);

			function WithStore() {
				_classCallCheck(this, WithStore);

				return _possibleConstructorReturn(this, (WithStore.__proto__ || Object.getPrototypeOf(WithStore)).apply(this, arguments));
			}

			_createClass(WithStore, [{
				key: 'render',
				value: function render() {
					var props = this.props;

					return React.createElement(
						StoreContext.Consumer,
						null,
						function (store) {
							var storeProps = _defineProperty({}, prop, store);
							return React.createElement(WrappedComponent, _extends({}, storeProps, extractRef(props)));
						}
					);
				}
			}]);

			return WithStore;
		}(Component)) || _class);

		return WithStore;
	};
}