var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import hoist, { extractRef } from '../hoist';
import { observer } from 'mobx-react';
import TableStoreProvider from '../../components/TableStoreProvider';

export default function withTable() {
	var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

	var storePropName = options.prop || 'store';
	return function createWithTableComponent(WrappedComponent) {
		var _dec, _class, _class2, _temp;

		var TableStoreComponent = (_dec = hoist(WrappedComponent), _dec(_class = (_temp = _class2 = function (_PureComponent) {
			_inherits(TableStoreComponent, _PureComponent);

			function TableStoreComponent() {
				_classCallCheck(this, TableStoreComponent);

				return _possibleConstructorReturn(this, (TableStoreComponent.__proto__ || Object.getPrototypeOf(TableStoreComponent)).apply(this, arguments));
			}

			_createClass(TableStoreComponent, [{
				key: 'getChildContext',


				// DEPRECATED
				value: function getChildContext() {
					return {
						store: this.props[storePropName]
					};
				}
				// DEPRECATED

			}, {
				key: 'componentDidMount',
				value: function componentDidMount() {
					var store = this.props[storePropName];
					store && store.setupQuery();
				}
			}, {
				key: 'render',
				value: function render() {
					return React.createElement(WrappedComponent, extractRef(this.props));
				}
			}]);

			return TableStoreComponent;
		}(PureComponent), _class2.childContextTypes = {
			store: PropTypes.object
		}, _temp)) || _class);


		var WithTable = function WithTable(props) {
			return React.createElement(
				TableStoreProvider,
				_extends({}, options, props),
				function (_ref) {
					var store = _ref.store;

					var extraStoreProp = _defineProperty({}, storePropName, store);
					return React.createElement(TableStoreComponent, _extends({}, props, extraStoreProp));
				}
			);
		};

		return observer(WithTable);
	};
}