var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _dec3, _class, _class2, _temp, _initialiseProps;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import PropTypes from '../../utils/PropTypes';
import React, { Component } from 'react';
import renderProp from '../../utils/renderProp';
import joinKeys from '../../utils/joinKeys';
import { REF } from '../../utils/Issuers';
import { isFunction } from '../../utils/fp';
import withTable from '../../hocs/withTable';
import withIssuer from '../../hocs/withIssuer';
// import withStore from 'hocs/withStore';
import { ModalConsumer } from '../../components/Modal';
import TableBody from '../../components/TableBody';
import TableQuery from '../../components/TableQuery';
import Toolbar from '../../components/Toolbar';
import QueryConnector from '../../components/QueryConnector';

var RefModal = (_dec = withTable({ prop: 'contextStore' }), _dec2 = withTable(), _dec3 = withIssuer({ issuer: REF }), _dec(_class = _dec2(_class = _dec3(_class = (_temp = _class2 = function (_Component) {
	_inherits(RefModal, _Component);

	function RefModal(props, context) {
		_classCallCheck(this, RefModal);

		var _this = _possibleConstructorReturn(this, (RefModal.__proto__ || Object.getPrototypeOf(RefModal)).call(this, props, context));

		_initialiseProps.call(_this);

		var fetch = props.fetch,
		    refStore = props.store;

		isFunction(fetch) ? fetch(props) : refStore.call(fetch, props);
		return _this;
	}

	_createClass(RefModal, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    noQuery = _props.noQuery,
			    store = _props.store,
			    title = _props.title,
			    width = _props.width,
			    Header = _props.header,
			    Footer = _props.footer,
			    ModalFooter = _props.modalFooter,
			    toolbar = _props.toolbar;

			return React.createElement(
				QueryConnector,
				{ store: store },
				React.createElement(
					ModalConsumer,
					{
						width: width,
						title: title,
						onOk: this._handleOk,
						footer: ModalFooter && React.createElement(ModalFooter, { store: store })
					},
					renderProp(Header),
					Header && React.createElement(Header, { store: store }),
					!noQuery && React.createElement(TableQuery, { store: store }),
					toolbar === true ? React.createElement(Toolbar, null) : renderProp(toolbar, { store: store }),
					React.createElement(TableBody, { store: store, selectionType: 'radio' }),
					Footer && React.createElement(Footer, { store: store })
				)
			);
		}
	}]);

	return RefModal;
}(Component), _class2.propTypes = {
	table: PropTypes.string.isRequired,
	fetch: PropTypes.stringOrFunc,
	keys: PropTypes.string,
	save: PropTypes.stringOrFunc,
	noQuery: PropTypes.any,
	store: PropTypes.object,
	contextStore: PropTypes.object.isRequired,
	title: PropTypes.node,
	width: PropTypes.stringOrNumber,
	header: PropTypes.component,
	footer: PropTypes.component,
	toolbar: PropTypes.oneOfType([PropTypes.component, PropTypes.bool, PropTypes.node]),
	modalFooter: PropTypes.component
}, _class2.defaultProps = {
	fetch: 'fetch',
	save: 'request',
	noQuery: false,
	title: 'Reference',
	width: 800,
	toolbar: false
}, _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this._handleOk = function () {
		var props = _this2.props,
		    _props2 = _this2.props,
		    keys = _props2.keys,
		    save = _props2.save,
		    refStore = _props2.store;
		var pathname = refStore.pathname;

		var refKeys = refStore.selectedKeys;
		var url = joinKeys(keys) + ('/' + pathname + '/') + joinKeys(refKeys);
		var options = _extends({ method: 'POST', url: url }, props, { keys: keys, refKeys: refKeys, refStore: refStore });
		isFunction(save) ? save(options) : refStore.call(save, options);
	};
}, _temp)) || _class) || _class) || _class);
export { RefModal as default };