function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';

export default function APISchema() {
	return React.createElement('noscript', null);
}

APISchema.propTypes = {
	baseURL: PropTypes.string.isRequired,
	timeout: PropTypes.number,
	count: PropTypes.number,
	accessTokenName: PropTypes.string,
	accessTokenLocation: PropTypes.oneOf(['headers', 'header', 'query']),
	sortKey: PropTypes.string,
	orderKey: PropTypes.string,
	descValue: PropTypes.string,
	ascValue: PropTypes.string
};

APISchema.defaultProps = {
	timeout: 15000,
	count: 20,
	accessTokenName: 'X-ACCESS-TOKEN',
	accessTokenLocation: 'headers',
	sortKey: 'sort',
	orderKey: 'order',
	descValue: 'desc',
	ascValue: 'asc'
};

APISchema.configuration = {
	name: 'api',
	propType: PropTypes.object,
	pipe: function pipe(_ref) {
		var accessTokenLocation = _ref.accessTokenLocation,
		    props = _objectWithoutProperties(_ref, ['accessTokenLocation']);

		return Object.assign(this, props, {
			accessTokenLocation: accessTokenLocation !== 'query' ? 'headers' : 'query'
		});
	}
};