import React from 'react';
import PropTypes from 'prop-types';
import { returnsArgument } from 'empty-functions';

export default function AuthSchema() {
	return React.createElement('noscript', null);
}

AuthSchema.propTypes = {
	basePath: PropTypes.string.isRequired,
	loginPath: PropTypes.string.isRequired,
	getUserPath: PropTypes.string.isRequired,
	defaultLoginRedirection: PropTypes.string,
	mapOnLoginResponse: PropTypes.func,
	mapOnGetUserResponse: PropTypes.func
};

AuthSchema.defaultProps = {
	defaultLoginRedirection: '/',
	mapOnLoginResponse: returnsArgument,
	mapOnGetUserResponse: returnsArgument
};

AuthSchema.configuration = {
	name: 'auth',
	propType: PropTypes.object,
	pipe: function pipe(props, auth) {
		return Object.assign(auth, props);
	}
};