import React from 'react';
import PropTypes from '../../utils/PropTypes';
import * as Actions from '../../constants/Actions';
import { UpdaterModal, CreaterModal } from '../../modals/FormModals';
import RefModal from '../../modals/RefModal';

export default function ModalSchema() {
	return React.createElement('noscript', null);
}

ModalSchema.propTypes = {
	name: PropTypes.string.isRequired,
	component: PropTypes.component.isRequired
};

ModalSchema.configuration = {
	name: 'modals',
	propType: PropTypes.map,
	pipe: function pipe(_ref, modals) {
		var name = _ref.name,
		    component = _ref.component;

		modals.set(name, component);
		return modals;
	},
	initialData: function initialData() {
		var modals = new Map();
		modals.set(Actions.CREATE, CreaterModal);
		modals.set(Actions.UPDATE, UpdaterModal);
		modals.set(Actions.REF, RefModal);
		return modals;
	}
};