import React from 'react';
import PropTypes from 'prop-types';

export default function UploadSchema() {
	return React.createElement('noscript', null);
}

UploadSchema.propTypes = {
	imagePath: PropTypes.string,
	imageSizeLimit: PropTypes.number,
	filePath: PropTypes.string,
	fileSizeLimit: PropTypes.number,
	strategies: PropTypes.object,
	requireAccessToken: PropTypes.bool,
	mapFileList: PropTypes.func
};

UploadSchema.defaultProps = {
	imagePath: 'upload/image',
	imageSizeLimit: 5120,
	filePath: 'upload/file',
	fileSizeLimit: 10240,
	strategies: {},
	requireAccessToken: false,
	mapFileList: function mapFileList(fileList) {
		return fileList.filter(function (_ref) {
			var status = _ref.status;
			return status === 'done';
		}).map(function (_ref2) {
			var thumbUrl = _ref2.thumbUrl,
			    response = _ref2.response;
			return response.url || thumbUrl;
		}).join(',');
	}
};

UploadSchema.configuration = {
	name: 'upload',
	propType: PropTypes.object,
	pipe: function pipe(props, config) {
		return Object.assign(config, props);
	}
};