var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import PropTypes from 'prop-types';
import { propTypes as MobxPropTypes } from 'mobx-react';
import warning from 'warning';

var warned = {};

export default _extends({}, PropTypes, {
	component: PropTypes.oneOfType([PropTypes.object, PropTypes.string, PropTypes.func]),
	array: PropTypes.oneOfType([PropTypes.array, MobxPropTypes.observableArray]),
	stringOrNumber: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
	stringOrObject: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),
	stringOrFunc: PropTypes.oneOfType([PropTypes.string, PropTypes.func]),
	nodeOrFunc: PropTypes.oneOfType([PropTypes.node, PropTypes.func]),
	render: PropTypes.oneOfType([PropTypes.bool, PropTypes.func]),
	deprecated: function deprecatedProp(propType, explanation) {
		return function validate(props, propName, componentName) {
			if (props[propName] != null) {
				// eslint-disable-next-line max-len
				var message = '"' + propName + '" property of "' + componentName + '" has been deprecated.';
				if (explanation) message += ' ' + explanation;

				if (!warned[message]) {
					warned[message] = true;
					process.env.NODE_ENV !== 'production' ? warning(false, message) : void 0;
				}
			}

			for (var _len = arguments.length, rest = Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
				rest[_key - 3] = arguments[_key];
			}

			return propType.apply(undefined, [props, propName, componentName].concat(rest));
		};
	}
});