import cookie from 'cookie';
import { defaults } from './fp';

export default {
	set: function set(name, value) {
		var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

		defaults(options, { path: '/' });
		return document.cookie = cookie.serialize(name, value, options);
	},
	get: function get(name) {
		return cookie.parse(document.cookie)[name];
	},
	remove: function remove(name) {
		var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

		options = defaults(options, { path: '/' });
		options.expires = new Date(0);
		return !!(document.cookie = cookie.serialize(name, '', options));
	}
};