import warning from 'warning';

var cache = new WeakSet();

export default function deprecated(fn, message) {
	return function () {
		if (!cache.has(fn)) {
			cache.add(fn);
			process.env.NODE_ENV !== 'production' ? warning(false, message || fn.name + ' is deprecated.') : void 0;
		}
		return fn.apply(undefined, arguments);
	};
}