import { isString, isArray, trim } from './fp';
import { isObservableArray } from 'mobx';

export default function ensureFileList() {
	var fileList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

	if (isString(fileList)) {
		fileList = fileList.split(',');
	}

	if (!isArray(fileList) && !isObservableArray(fileList)) {
		throw new Error('`fileList` must be a string or array');
	}

	return fileList.map(trim).filter(Boolean).map(function (url, index) {
		return {
			uid: -index,
			url: url,
			name: url
		};
	});
}