var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

export var isUndefined = function isUndefined(t) {
	return typeof t === 'undefined';
};
export var isFunction = function isFunction(t) {
	return typeof t === 'function';
};
export var isString = function isString(t) {
	return typeof t === 'string';
};
export var isNumber = function isNumber(t) {
	return typeof t === 'number';
};
export var isObject = function isObject(t) {
	return t && (typeof t === 'undefined' ? 'undefined' : _typeof(t)) === 'object';
};
export var isArray = function isArray(t) {
	return t instanceof Array;
};
export var isEmpty = function isEmpty(t) {
	return !t || (isArray(t) ? !t.length : isObject(t) && !Object.keys(t).length);
};

export var assign = function assign(src) {
	for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
		args[_key - 1] = arguments[_key];
	}

	return args.reduce(function (ret, arg) {
		return _extends({}, ret, arg);
	}, src);
};

export var defaults = function defaults(src, target) {
	return _extends({}, target, src);
};

export var map = function map(obj, each) {
	return Object.keys(obj).map(function (k) {
		return each(obj[k], k, obj);
	});
};

export var reduce = function reduce(obj, each, init) {
	return map(obj, function () {
		for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			args[_key2] = arguments[_key2];
		}

		return args;
	}).reduce(function (ret, args) {
		return each.apply(undefined, [ret].concat(_toConsumableArray(args)));
	}, init);
};

export var omitBy = function omitBy(obj, by) {
	return reduce(obj, function (ret, v, k) {
		return by(v, k) ? ret : _extends({}, ret, _defineProperty({}, k, v));
	}, {});
};

export var omit = function omit(obj, arr) {
	return omitBy(obj, function (v, k) {
		return ~arr.indexOf(k);
	});
};

export var flatMap = function flatMap(arr, each) {
	return arr.reduce(function (flat) {
		for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
			args[_key3 - 1] = arguments[_key3];
		}

		return flat.concat(each.apply(undefined, args));
	}, []);
};

export var trim = function trim(str) {
	return str.toString().replace(/^\s+/, '').replace(/\s+$/, '');
};