function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

import { Request } from 'fetch-extra';

var request = void 0;

export default function getRequest(config) {
	if (request) {
		return request;
	}

	var _config$api = config.api,
	    baseURL = _config$api.baseURL,
	    timeout = _config$api.timeout,
	    _config$errorMessages = config.errorMessages,
	    _config$errorMessages2 = _config$errorMessages.defaults,
	    defaults = _config$errorMessages2 === undefined ? 'Request failed' : _config$errorMessages2,
	    _config$errorMessages3 = _config$errorMessages.statusMap,
	    statusMap = _config$errorMessages3 === undefined ? {} : _config$errorMessages3,
	    _config$errorMessages4 = _config$errorMessages.validResponse,
	    validResponse = _config$errorMessages4 === undefined ? function (response) {
		return response.ok;
	} : _config$errorMessages4,
	    validResponseData = _config$errorMessages.validResponseData,
	    _config$errorMessages5 = _config$errorMessages.getMessage,
	    getMessage = _config$errorMessages5 === undefined ? function (err) {
		return err.reason;
	} : _config$errorMessages5;


	return request = new Request({
		timeout: timeout,
		url: baseURL,
		type: 'json',
		responseType: 'json',
		responseTransformer: function responseTransformer(response) {
			var _this = this;

			return _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
				var valid, error;
				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_context.next = 2;
								return validResponse(response);

							case 2:
								valid = _context.sent;

								if (valid) {
									_context.next = 7;
									break;
								}

								error = new Error(response.statusText);

								error.response = response;
								throw error;

							case 7:
								return _context.abrupt('return', response);

							case 8:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, _this);
			}))();
		},
		responseDataTransformer: function responseDataTransformer(data) {
			var _this2 = this;

			return _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
				var valid, error;
				return regeneratorRuntime.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								if (!validResponseData) {
									_context2.next = 8;
									break;
								}

								_context2.next = 3;
								return validResponseData(data);

							case 3:
								valid = _context2.sent;

								if (valid) {
									_context2.next = 8;
									break;
								}

								error = new Error(defaults);

								Object.assign(error, data);
								throw error;

							case 8:
								return _context2.abrupt('return', data);

							case 9:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, _this2);
			}))();
		},
		errorTransformer: function errorTransformer(err) {
			var _this3 = this;

			return _asyncToGenerator(regeneratorRuntime.mark(function _callee3() {
				var reason;
				return regeneratorRuntime.wrap(function _callee3$(_context3) {
					while (1) {
						switch (_context3.prev = _context3.next) {
							case 0:
								_context3.next = 2;
								return getMessage(err, err.response);

							case 2:
								err.reason = _context3.sent;

								if (!err.reason && err.response && err.response.status) {
									reason = statusMap[err.response.status];

									err.reason = reason || err.message;
								}
								if (!err.reason) {
									err.reason = defaults;
								}
								return _context3.abrupt('return', err);

							case 6:
							case 'end':
								return _context3.stop();
						}
					}
				}, _callee3, _this3);
			}))();
		}
	});
}