var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import { isString, isObject } from './fp';
import { parse } from 'tiny-querystring';
import { parsePath } from 'history';

export default function parseAPIPath(apiPath) {
	if (isString(apiPath)) {
		apiPath = parsePath(apiPath);
		apiPath.query = apiPath.search.slice(1);
	}

	if (isObject(apiPath)) {
		if (isString(apiPath.query)) {
			apiPath.query = parse(apiPath.query);
		}

		if (apiPath.query === null) {
			apiPath.query = {};
		}

		return _extends({
			pathname: '/',
			query: {},
			headers: {}
		}, apiPath);
	}

	throw new Error('`apiPath` should be string or object, but received', typeof apiPath === 'undefined' ? 'undefined' : _typeof(apiPath));
}