'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = AppTitle;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _tinyInvariant = require('tiny-invariant');

var _tinyInvariant2 = _interopRequireDefault(_tinyInvariant);

var _AppConfig = require('../../contexts/AppConfig');

var _AppConfig2 = _interopRequireDefault(_AppConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function AppTitle(_ref) {
	var style = _ref.style,
	    fontSize = _ref.fontSize,
	    color = _ref.color,
	    textAlign = _ref.textAlign,
	    other = _objectWithoutProperties(_ref, ['style', 'fontSize', 'color', 'textAlign']);

	return _react2.default.createElement(
		_AppConfig2.default.Consumer,
		null,
		function (appConfig) {
			!appConfig ? process.env.NODE_ENV !== 'production' ? (0, _tinyInvariant2.default)(false, 'You should not use <AppTitle> outside <AppContext>') : (0, _tinyInvariant2.default)(false) : void 0;
			return _react2.default.createElement(
				'h1',
				_extends({}, other, {
					style: _extends({
						margin: 0,
						overflow: 'hidden',
						textOverflow: 'ellipsis',
						fontSize: fontSize,
						textAlign: textAlign,
						color: color
					}, style)
				}),
				appConfig.title
			);
		}
	);
}

AppTitle.propTypes = {
	style: _PropTypes2.default.object,
	fontSize: _PropTypes2.default.stringOrNumber,
	textAlign: _PropTypes2.default.string,
	color: _PropTypes2.default.string
};

AppTitle.defaultProps = {
	fontSize: 20,
	textAlign: 'center',
	color: 'inherit'
};