'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EditorToolbar = function EditorToolbar(props) {
	return _react2.default.createElement(
		'div',
		{ className: 'editor-toolbar' },
		props.font && _react2.default.createElement('select', { className: 'ql-font' }),
		props.size && _react2.default.createElement('select', { className: 'ql-size' }),
		props.bold && _react2.default.createElement('button', { className: 'ql-bold' }),
		props.italic && _react2.default.createElement('button', { className: 'ql-italic' }),
		props.underline && _react2.default.createElement('button', { className: 'ql-underline' }),
		props.strike && _react2.default.createElement('button', { className: 'ql-strike' }),
		props.color && _react2.default.createElement('select', { className: 'ql-color' }),
		props.background && _react2.default.createElement('select', { className: 'ql-background' }),
		props.script && _react2.default.createElement('button', { className: 'ql-script', value: 'sub' }),
		props.script && _react2.default.createElement('button', { className: 'ql-script', value: 'super' }),
		props.header && _react2.default.createElement('button', { className: 'ql-header', value: '1' }),
		props.header && _react2.default.createElement('button', { className: 'ql-header', value: '2' }),
		props.blockquote && _react2.default.createElement('button', { className: 'ql-blockquote' }),
		props.codeBlock && _react2.default.createElement('button', { className: 'ql-code-block' }),
		props.list && _react2.default.createElement('button', { className: 'ql-list', value: 'ordered' }),
		props.list && _react2.default.createElement('button', { className: 'ql-list', value: 'bullet' }),
		props.indent && _react2.default.createElement('button', { className: 'ql-indent', value: '-1' }),
		props.indent && _react2.default.createElement('button', { className: 'ql-indent', value: '+1' }),
		props.direction && _react2.default.createElement('button', { className: 'ql-direction', value: 'rtl' }),
		props.align && _react2.default.createElement('select', { className: 'ql-align' }),
		props.link && _react2.default.createElement('button', { className: 'ql-link' }),
		props.image && _react2.default.createElement('button', { className: 'ql-image' }),
		props.video && _react2.default.createElement('button', { className: 'ql-video' }),
		props.formula && _react2.default.createElement('button', { className: 'ql-formula' }),
		props.clean && _react2.default.createElement('button', { className: 'ql-clean' }),
		props.children
	);
};

EditorToolbar.propTypes = {
	children: _PropTypes2.default.node,
	font: _PropTypes2.default.bool,
	size: _PropTypes2.default.bool,
	bold: _PropTypes2.default.bool,
	italic: _PropTypes2.default.bool,
	underline: _PropTypes2.default.bool,
	strike: _PropTypes2.default.bool,
	color: _PropTypes2.default.bool,
	background: _PropTypes2.default.bool,
	script: _PropTypes2.default.bool,
	header: _PropTypes2.default.bool,
	blockquote: _PropTypes2.default.bool,
	codeBlock: _PropTypes2.default.bool,
	list: _PropTypes2.default.bool,
	indent: _PropTypes2.default.bool,
	direction: _PropTypes2.default.bool,
	align: _PropTypes2.default.bool,
	link: _PropTypes2.default.bool,
	image: _PropTypes2.default.bool,
	video: _PropTypes2.default.bool,
	formula: _PropTypes2.default.bool,
	clean: _PropTypes2.default.bool
};

EditorToolbar.defaultProps = {
	font: false,
	size: true,
	bold: true,
	italic: true,
	underline: true,
	strike: true,
	color: true,
	background: true,
	script: false,
	header: true,
	blockquote: true,
	codeBlock: true,
	list: true,
	indent: true,
	direction: false,
	align: true,
	link: true,
	image: true,
	video: true,
	formula: false,
	clean: true
};

exports.default = EditorToolbar;