'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = EnhancedRoute;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _NaviEnhancer = require('./NaviEnhancer');

var _NaviEnhancer2 = _interopRequireDefault(_NaviEnhancer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function EnhancedRoute(props) {
	var Component = props.component,
	    exact = props.exact,
	    strict = props.strict,
	    other = _objectWithoutProperties(props, ['component', 'exact', 'strict']);

	var path = other.path;

	return _react2.default.createElement(_reactRouterDom.Route, {
		path: path,
		exact: exact,
		strict: strict,
		render: function render(matchProps) {
			return _react2.default.createElement(
				_NaviEnhancer2.default,
				_extends({}, other, { path: path, key: path }),
				_react2.default.createElement(Component, matchProps)
			);
		}
	});
}

EnhancedRoute.propTypes = {
	component: _propTypes2.default.any.isRequired,
	exact: _propTypes2.default.any,
	strict: _propTypes2.default.any,
	path: _propTypes2.default.any,
	menuKey: _propTypes2.default.string
};