'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _getDefaultEditorFormats = require('../../utils/getDefaultEditorFormats');

var _getDefaultEditorFormats2 = _interopRequireDefault(_getDefaultEditorFormats);

var _createComponent = require('./createComponent');

var _createComponent2 = _interopRequireDefault(_createComponent);

var _Editor = require('../../contexts/Editor');

var _Editor2 = _interopRequireDefault(_Editor);

var _reactQuill = require('react-quill');

var _reactQuill2 = _interopRequireDefault(_reactQuill);

var _EditorToolbar = require('../EditorToolbar');

var _EditorToolbar2 = _interopRequireDefault(_EditorToolbar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var formats = (0, _getDefaultEditorFormats2.default)();

var QuillEditorEnhancer = (_temp = _class = function (_Component) {
	_inherits(QuillEditorEnhancer, _Component);

	function QuillEditorEnhancer(props) {
		_classCallCheck(this, QuillEditorEnhancer);

		var _this = _possibleConstructorReturn(this, (QuillEditorEnhancer.__proto__ || Object.getPrototypeOf(QuillEditorEnhancer)).call(this, props));

		_this.state = {
			editor: {}
		};

		_this.saveRef = function (ref) {
			var innerRef = _this.props.innerRef;

			_this.reactQuillRef = ref;
			if (_this.state.editor !== ref) _this.setState({ editor: ref });
			if (innerRef) innerRef(ref);
		};

		var modules = props.modules;

		modules.toolbar = _extends({
			container: '.editor-toolbar'
		}, modules.toolbar);
		_this.modules = modules;
		return _this;
	}

	_createClass(QuillEditorEnhancer, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    containerClassName = _props.containerClassName,
			    containerStyle = _props.containerStyle,
			    toolbar = _props.toolbar,
			    innerRef = _props.innerRef,
			    formats = _props.formats,
			    other = _objectWithoutProperties(_props, ['containerClassName', 'containerStyle', 'toolbar', 'innerRef', 'formats']),
			    editor = this.state.editor,
			    modules = this.modules;

			return _react2.default.createElement(
				_Editor2.default.Provider,
				{ value: editor },
				_react2.default.createElement(
					'div',
					{ className: containerClassName, style: containerStyle },
					toolbar,
					_react2.default.createElement(_reactQuill2.default, _extends({}, other, {
						modules: modules,
						formats: formats,
						ref: this.saveRef
					}))
				)
			);
		}
	}]);

	return QuillEditorEnhancer;
}(_react.Component), _class.propTypes = {
	containerStyle: _PropTypes2.default.object,
	containerClassName: _PropTypes2.default.string,
	toolbar: _PropTypes2.default.node,
	modules: _PropTypes2.default.object,
	formats: _PropTypes2.default.array,
	innerRef: _PropTypes2.default.func
}, _class.defaultProps = {
	modules: {},
	toolbar: _react2.default.createElement(_EditorToolbar2.default, null),
	formats: formats
}, _temp);
exports.default = (0, _createComponent2.default)(QuillEditorEnhancer, {
	displayName: 'Editor',
	getValueFromChangeEvent: function getValueFromChangeEvent(value) {
		return value;
	}
});