'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _mobxReact = require('mobx-react');

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _FormStore = require('../../stores/FormStore');

var _FormStore2 = _interopRequireDefault(_FormStore);

var _Form = require('../Form');

var _FormItem = require('../FormItem');

var _FormItem2 = _interopRequireDefault(_FormItem);

var _SpinBox = require('../SpinBox');

var _SpinBox2 = _interopRequireDefault(_SpinBox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormBody = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(FormBody, _Component);

	function FormBody() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, FormBody);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormBody.__proto__ || Object.getPrototypeOf(FormBody)).call.apply(_ref, [this].concat(args))), _this), _this.formStore = new _FormStore2.default(), _this.isPristine = true, _this.isValid = true, _this.isOk = false, _this._handleChange = function (state) {
			var onChange = _this.props.onChange;

			onChange && onChange(state);
			_this.formStore.setState(state.value);
			if (_this.isPristine) {
				_this.isPristine = false;
				_this._handleStatusChange();
			}
		}, _this._handleValidChange = function (isValid) {
			var onValidChange = _this.props.onValidChange;

			onValidChange && onValidChange(isValid);
			_this.isValid = isValid;
			_this._handleStatusChange();
		}, _this._handleSubmit = function (body, state) {
			if (!state.isInvalid) {
				var _this2 = _this,
				    _this2$props = _this2.props,
				    onSubmit = _this2$props.onSubmit,
				    selectedKeys = _this2$props.selectedKeys;

				var options = { selectedKeys: selectedKeys };
				if (onSubmit) {
					onSubmit(body, state, options);
				}
			} else if (process.env.NODE_ENV !== 'production') {
				process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(false, 'INVALID') : void 0;
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(FormBody, [{
		key: '_handleStatusChange',
		value: function _handleStatusChange() {
			var onStatusChange = this.props.onStatusChange;

			if (onStatusChange) {
				var ok = !this.isPristine && this.isValid;
				if (this.isOk !== ok) {
					this.isOk = ok;
					onStatusChange(ok);
				}
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    store = _props.store,
			    children = _props.children,
			    value = _props.value,
			    formRef = _props.formRef,
			    footer = _props.footer,
			    selectedKeys = _props.selectedKeys,
			    onStatusChange = _props.onStatusChange,
			    other = _objectWithoutProperties(_props, ['store', 'children', 'value', 'formRef', 'footer', 'selectedKeys', 'onStatusChange']),
			    formStore = this.formStore;

			if (store && store.isFetching) return _react2.default.createElement(_SpinBox2.default, null);
			return _react2.default.createElement(
				_Form.Form,
				_extends({}, other, {
					ref: formRef,
					value: value,
					onSubmit: this._handleSubmit,
					onChange: this._handleChange,
					onValidChange: this._handleValidChange
				}),
				store && store.renderers.map(function (_ref2, index) {
					var renderForm = _ref2.renderForm;
					return _react2.default.createElement(_FormItem2.default, {
						renderForm: renderForm,
						formStore: formStore,
						key: index
					});
				}),
				children,
				footer
			);
		}
	}]);

	return FormBody;
}(_react.Component), _class2.propTypes = {
	store: _PropTypes2.default.object,
	children: _PropTypes2.default.node,
	selectedKeys: _PropTypes2.default.oneOfType([_PropTypes2.default.array, _PropTypes2.default.string]),
	value: _PropTypes2.default.any,
	footer: _PropTypes2.default.node,
	formRef: _PropTypes2.default.any,
	onChange: _PropTypes2.default.func,
	onSubmit: _PropTypes2.default.func,
	onValidChange: _PropTypes2.default.func,
	onStatusChange: _PropTypes2.default.func
}, _temp2)) || _class;

exports.default = FormBody;