'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _FormLayout = require('../../contexts/FormLayout');

var _FormLayout2 = _interopRequireDefault(_FormLayout);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var formItemLayout = {
	labelCol: {
		xs: { span: 24 },
		sm: { span: 6 }
	},
	wrapperCol: {
		xs: { span: 24 },
		sm: { span: 18 }
	}
};

var FormItem = function FormItem(_ref) {
	var renderForm = _ref.renderForm,
	    formStore = _ref.formStore;

	var children = renderForm(formStore);
	if (!children) return null;
	return _react2.default.createElement(
		_FormLayout2.default.Consumer,
		null,
		function (layout) {
			return layout === 'horizontal' ? (0, _react.cloneElement)(children, formItemLayout) : children;
		}
	);
};

FormItem.propTypes = {
	renderForm: _propTypes2.default.func.isRequired,
	formStore: _propTypes2.default.object.isRequired
};

exports.default = (0, _mobxReact.observer)(FormItem);