'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _style3 = require('antd/lib/icon/style');

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _style4 = require('antd/lib/menu/style');

var _menu = require('antd/lib/menu');

var _menu2 = _interopRequireDefault(_menu);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp2;

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _routerStore = require('../../stores/routerStore');

var _routerStore2 = _interopRequireDefault(_routerStore);

var _panelsStore = require('../../stores/panelsStore');

var _panelsStore2 = _interopRequireDefault(_panelsStore);

var _naviStore = require('../../stores/naviStore');

var _naviStore2 = _interopRequireDefault(_naviStore);

var _reactRouterDom = require('react-router-dom');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SubMenu = _menu2.default.SubMenu,
    MenuItem = _menu2.default.Item;

var Navi = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(Navi, _Component);

	function Navi() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Navi);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Navi.__proto__ || Object.getPrototypeOf(Navi)).call.apply(_ref, [this].concat(args))), _this), _this._handleClick = function (_ref2) {
			var item = _ref2.item;

			if (_panelsStore2.default.isSidebarCollapsed) {
				_routerStore2.default.push(item.props.path);
			}
		}, _this._handleOpenChange = function (openKeys) {
			_naviStore2.default.openKeys = openKeys;
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Navi, [{
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			_naviStore2.default.disposer();
		}
	}, {
		key: '_renderLink',
		value: function _renderLink(_ref3) {
			var title = _ref3.title,
			    path = _ref3.path,
			    isInternalPath = _ref3.isInternalPath;
			var top = this.props.top;

			var collapsed = !top && _panelsStore2.default.isSidebarCollapsed;

			// To hide title when collapsed
			if (collapsed) {
				return _react2.default.createElement(
					'span',
					null,
					title
				);
			}

			if (isInternalPath) {
				return _react2.default.createElement(
					_reactRouterDom.Link,
					{ to: path, style: _styles2.default.link },
					title
				);
			}

			return _react2.default.createElement(
				'a',
				{ href: path, style: _styles2.default.link },
				title
			);
		}
	}, {
		key: '_renderMenu',
		value: function _renderMenu(menuList) {
			var _this2 = this;

			if (!menuList) return;

			var itemStyle = this.props.itemStyle;

			return menuList.map(function (menu) {
				if (!menu.children) {
					return !menu.menuKey ? null : _react2.default.createElement(
						MenuItem,
						{ key: menu.menuKey, path: menu.path, style: itemStyle },
						menu.icon && _react2.default.createElement(_icon2.default, { type: menu.icon }),
						_this2._renderLink(menu)
					);
				}
				return _react2.default.createElement(
					SubMenu,
					{
						key: menu.menuKey,
						title: _react2.default.createElement(
							'span',
							null,
							menu.icon && _react2.default.createElement(_icon2.default, { type: menu.icon }),
							_react2.default.createElement(
								'span',
								null,
								menu.title
							)
						)
					},
					_this2._renderMenu(menu.children)
				);
			}).filter(Boolean);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    menu = _props.menu,
			    top = _props.top,
			    itemStyle = _props.itemStyle,
			    other = _objectWithoutProperties(_props, ['menu', 'top', 'itemStyle']);

			var openKeys = _naviStore2.default.openKeys,
			    selectedKeys = _naviStore2.default.selectedKeys;

			return _react2.default.createElement(
				_menu2.default,
				_extends({
					mode: top ? 'horizontal' : 'inline',
					theme: top ? 'light' : 'dark',
					selectedKeys: process.env.NODE_ENV !== 'production' ? (0, _mobx.toJS)(selectedKeys) : selectedKeys,
					openKeys: openKeys,
					onClick: this._handleClick,
					onOpenChange: this._handleOpenChange
				}, other),
				this._renderMenu(menu)
			);
		}
	}]);

	return Navi;
}(_react.Component), _class2.propTypes = {
	menu: _propTypes2.default.any,
	top: _propTypes2.default.bool,
	itemStyle: _propTypes2.default.object
}, _class2.defaultProps = {
	top: false
}, _temp2)) || _class;

exports.default = Navi;