'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _dec3, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _localize = require('../../hocs/localize');

var _localize2 = _interopRequireDefault(_localize);

var _withIssuer = require('../../hocs/withIssuer');

var _withIssuer2 = _interopRequireDefault(_withIssuer);

var _withStore = require('../../hocs/withStore');

var _withStore2 = _interopRequireDefault(_withStore);

var _Issuers = require('../../utils/Issuers');

var _ConfirmButton = require('../ConfirmButton');

var _ConfirmButton2 = _interopRequireDefault(_ConfirmButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RemoveButton = (_dec = (0, _withIssuer2.default)(), _dec2 = (0, _withStore2.default)(), _dec3 = (0, _localize2.default)('RemoveButton'), _dec(_class = _dec2(_class = _dec3(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(RemoveButton, _Component);

	function RemoveButton() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, RemoveButton);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = RemoveButton.__proto__ || Object.getPrototypeOf(RemoveButton)).call.apply(_ref, [this].concat(args))), _this), _this._handleOk = function (_ref2) {
			var getSelectedKeysString = _ref2.getSelectedKeysString;
			var _this$props = _this.props,
			    store = _this$props.store,
			    method = _this$props.method;

			var selectedKeys = getSelectedKeysString();
			store.call(method, {
				keys: selectedKeys,
				url: selectedKeys
			});
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(RemoveButton, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    issuers = _props.issuers,
			    localeStore = _props.localeStore,
			    method = _props.method,
			    other = _objectWithoutProperties(_props, ['issuers', 'localeStore', 'method']);

			var isInToolbar = issuers.has(_Issuers.TOOLBAR);
			var styleTypes = {};
			if (isInToolbar) styleTypes.type = 'danger';
			return _react2.default.createElement(_ConfirmButton2.default, _extends({
				onOk: this._handleOk
			}, styleTypes, localeStore.localize(other), {
				minSelected: 1
			}));
		}
	}]);

	return RemoveButton;
}(_react.Component), _class2.propTypes = {
	localeStore: _PropTypes2.default.object.isRequired,
	label: _PropTypes2.default.stringOrFunc,
	multiLabel: _PropTypes2.default.stringOrFunc,
	title: _PropTypes2.default.stringOrFunc,
	content: _PropTypes2.default.stringOrFunc,
	issuers: _PropTypes2.default.instanceOf(Set).isRequired,
	store: _PropTypes2.default.object.isRequired,
	method: _PropTypes2.default.string
}, _class2.defaultProps = {
	method: 'remove'
}, _temp2)) || _class) || _class) || _class);
exports.default = RemoveButton;