'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp2;

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _localize = require('../../hocs/localize');

var _localize2 = _interopRequireDefault(_localize);

var _Pagination = require('../Pagination');

var _Pagination2 = _interopRequireDefault(_Pagination);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TableFooter = (_dec = (0, _localize2.default)('TableBody'), _dec(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(TableFooter, _Component);

	function TableFooter() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, TableFooter);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TableFooter.__proto__ || Object.getPrototypeOf(TableFooter)).call.apply(_ref, [this].concat(args))), _this), _this._handlePageChange = function (parameter) {
			var store = _this.props.store;
			var useCursor = store.useCursor;

			var query = _extends({}, store.query);
			if (useCursor) {
				query.cursor = parameter;
				store.setQueryWithCursor(query);
			} else {
				query.page = parameter;
				store.setQuery(query);
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(TableFooter, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    store = _props.store,
			    localeStore = _props.localeStore;
			var total = store.total,
			    size = store.size,
			    query = store.query;

			var current = +query.page || 1;
			return _react2.default.createElement(
				'div',
				{ style: _styles2.default.footer },
				(total || total === 0) && _react2.default.createElement(
					'p',
					{ style: _styles2.default.total },
					localeStore.data.total,
					': ',
					total
				),
				_react2.default.createElement(_Pagination2.default, {
					style: _styles2.default.pagination,
					current: current,
					total: total,
					pageSize: size,
					store: store,
					onChange: this._handlePageChange
				})
			);
		}
	}]);

	return TableFooter;
}(_react.Component), _class2.propTypes = {
	localeStore: _propTypes2.default.object.isRequired,
	store: _propTypes2.default.shape({
		total: _propTypes2.default.number,
		size: _propTypes2.default.number.isRequired,
		query: _propTypes2.default.object.isRequired
	})
}, _temp2)) || _class) || _class);
exports.default = TableFooter;