'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _style2 = require('antd/lib/table/style');

var _table = require('antd/lib/table');

var _table2 = _interopRequireDefault(_table);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _fp = require('../../utils/fp');

var _clearSortedInfo = require('../../utils/clearSortedInfo');

var _clearSortedInfo2 = _interopRequireDefault(_clearSortedInfo);

var _Issuers = require('../../utils/Issuers');

var _withIssuer = require('../../hocs/withIssuer');

var _withIssuer2 = _interopRequireDefault(_withIssuer);

var _TableContext = require('./TableContext');

var _TableContext2 = _interopRequireDefault(_TableContext);

var _TableCell = require('./TableCell');

var _TableCell2 = _interopRequireDefault(_TableCell);

var _TableHeadCell = require('./TableHeadCell');

var _TableHeadCell2 = _interopRequireDefault(_TableHeadCell);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var components = {
	header: { cell: _TableHeadCell2.default },
	body: { cell: _TableCell2.default }
};

var TableView = (_dec = (0, _withIssuer2.default)({ issuer: _Issuers.TABLE }), _dec(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
	_inherits(TableView, _Component);

	function TableView(props) {
		_classCallCheck(this, TableView);

		var _this = _possibleConstructorReturn(this, (TableView.__proto__ || Object.getPrototypeOf(TableView)).call(this, props));

		_this._toggleSelectedKey = function (selectedRowKey) {
			if (_this.props.selectionType === 'radio') {
				_this.props.store.toggleSelectedKey(selectedRowKey);
			}
		};

		_this._handleSelectChange = function (selectedRowKeys) {
			_this.props.store.setSelectedKeys(selectedRowKeys);
		};

		_this._handleChange = function (pagination, filters, sorter) {
			var _extends2;

			var _this$context = _this.context,
			    appConfig = _this$context.appConfig,
			    _this$context$appConf = _this$context.appConfig.api,
			    sortKey = _this$context$appConf.sortKey,
			    orderKey = _this$context$appConf.orderKey,
			    descValue = _this$context$appConf.descValue,
			    ascValue = _this$context$appConf.ascValue,
			    store = _this.props.store;

			if ((0, _fp.isEmpty)(sorter)) {
				return (0, _clearSortedInfo2.default)(appConfig);
			}
			store.setQuery(_extends({}, store.query, (_extends2 = {}, _defineProperty(_extends2, sortKey, sorter.columnKey), _defineProperty(_extends2, orderKey, sorter.order === 'descend' ? descValue : ascValue), _extends2)));
		};

		_this.tableContext = { toggleSelectedKey: _this._toggleSelectedKey };
		return _this;
	}

	_createClass(TableView, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    store = _props.store,
			    selectionType = _props.selectionType;
			var columns = store.columns,
			    collection = store.collection,
			    isFetching = store.isFetching,
			    selectedKeys = store.selectedKeys,
			    uniqueKey = store.uniqueKey,
			    maxSelections = store.maxSelections,
			    config = store.config;


			var rowSelection = maxSelections ? {
				type: selectionType,
				selectedRowKeys: selectedKeys,
				onChange: this._handleSelectChange,
				getCheckboxProps: function getCheckboxProps(record) {
					return {
						disabled: selectionType === 'checkbox' && maxSelections > 0 && selectedKeys.length >= maxSelections && selectedKeys.indexOf(record[uniqueKey]) < 0
					};
				}
			} : undefined;

			return _react2.default.createElement(
				_TableContext2.default.Provider,
				{ value: this.tableContext },
				_react2.default.createElement(_table2.default, {
					rowSelection: rowSelection,
					columns: columns,
					dataSource: (0, _mobx.toJS)(collection),
					loading: isFetching,
					pagination: false,
					components: components,
					onChange: this._handleChange,
					size: config.viewSize
				})
			);
		}
	}]);

	return TableView;
}(_react.Component), _class2.propTypes = {
	store: _PropTypes2.default.shape({
		columns: _PropTypes2.default.array.isRequired,
		collection: _PropTypes2.default.array,
		isFetching: _PropTypes2.default.bool.isRequired,
		size: _PropTypes2.default.number.isRequired,
		setSelectedKeys: _PropTypes2.default.func.isRequired,
		toggleSelectedKey: _PropTypes2.default.func.isRequired,
		query: _PropTypes2.default.object.isRequired,
		config: _PropTypes2.default.object.isRequired
	}),
	selectionType: _PropTypes2.default.oneOf(['checkbox', 'radio'])
}, _class2.defaultProps = {
	selectionType: 'checkbox'
}, _class2.contextTypes = {
	appConfig: _PropTypes2.default.object.isRequired
}, _temp)) || _class) || _class);
exports.default = TableView;