'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _style3 = require('antd/lib/row/style');

var _row = require('antd/lib/row');

var _row2 = _interopRequireDefault(_row);

var _style4 = require('antd/lib/col/style');

var _col = require('antd/lib/col');

var _col2 = _interopRequireDefault(_col);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _class, _class2, _temp2;

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _Issuers = require('../../utils/Issuers');

var _Form = require('../Form');

var _QueryItem = require('./QueryItem');

var _QueryItem2 = _interopRequireDefault(_QueryItem);

var _localize = require('../../hocs/localize');

var _localize2 = _interopRequireDefault(_localize);

var _withIssuer = require('../../hocs/withIssuer');

var _withIssuer2 = _interopRequireDefault(_withIssuer);

var _FormStore = require('../../stores/FormStore');

var _FormStore2 = _interopRequireDefault(_FormStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FooterContainer = function FooterContainer(_ref) {
	var children = _ref.children;
	return _react2.default.createElement(
		_row2.default,
		null,
		_react2.default.createElement(
			_col2.default,
			{ span: 24, style: _styles2.default.footer },
			children
		)
	);
};

FooterContainer.propTypes = {
	children: _propTypes2.default.node
};

var TableQuery = (_dec = (0, _withIssuer2.default)({ issuer: _Issuers.QUERIER }), _dec2 = (0, _localize2.default)('TableQuery'), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(TableQuery, _Component);

	function TableQuery() {
		var _ref2;

		var _temp, _this, _ret;

		_classCallCheck(this, TableQuery);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = TableQuery.__proto__ || Object.getPrototypeOf(TableQuery)).call.apply(_ref2, [this].concat(args))), _this), _this.formStore = new _FormStore2.default(), _this._handleSearch = function (query) {
			_this.props.store.setQuery(query);
		}, _this._handleReset = function () {
			_this.props.store.setQuery({});
		}, _this._handleChange = function (state) {
			_this.formStore.setState(state);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(TableQuery, [{
		key: '_renderBody',
		value: function _renderBody() {
			var _props = this.props,
			    children = _props.children,
			    renderers = _props.store.renderers,
			    formStore = this.formStore;

			if (children) {
				return _react.Children.map(children, function (child, index) {
					return _react2.default.createElement(
						_QueryItem2.default,
						{ key: index },
						child
					);
				});
			}
			return renderers.length > 0 && _react2.default.createElement(
				_row2.default,
				{ style: _styles2.default.main },
				renderers.map(function (_ref3, key) {
					var renderQuery = _ref3.renderQuery;
					return renderQuery(formStore, {
						key: key,
						children: function children(render) {
							if (!render) return null;
							var children = render();
							return children && _react2.default.createElement(
								_QueryItem2.default,
								null,
								children
							);
						}
					});
				})
			);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props2 = this.props,
			    header = _props2.header,
			    footer = _props2.footer,
			    children = _props2.children,
			    hidden = _props2.hidden,
			    store = _props2.store,
			    localeStore = _props2.localeStore;

			var shouldHide = hidden || (!children || !_react.Children.count(children)) && (!store || !store.renderers.length || !store.queryFieldsCount);
			return _react2.default.createElement(
				_Form.Form,
				{
					style: _styles2.default.container(shouldHide && _styles2.default.hidden),
					value: store.query,
					onSubmit: this._handleSearch,
					onReset: this._handleReset,
					onChange: this._handleChange,
					layout: 'inline'
				},
				!!header && header,
				this._renderBody(),
				!!footer && _react2.default.createElement(
					FooterContainer,
					null,
					footer
				),
				!footer && _react2.default.createElement(
					FooterContainer,
					null,
					_react2.default.createElement(
						_Form.Submit,
						{ type: 'primary' },
						localeStore.data.search
					),
					_react2.default.createElement(
						_Form.Reset,
						null,
						localeStore.data.reset
					)
				)
			);
		}
	}]);

	return TableQuery;
}(_react.Component), _class2.propTypes = {
	localeStore: _propTypes2.default.object.isRequired,
	store: _propTypes2.default.object,
	children: _propTypes2.default.node,
	header: _propTypes2.default.node,
	footer: _propTypes2.default.node,
	hidden: _propTypes2.default.bool
}, _class2.defaultProps = {
	store: {},
	hidden: false
}, _class2.contextTypes = {
	appConfig: _propTypes2.default.object.isRequired
}, _temp2)) || _class) || _class) || _class);
exports.default = TableQuery;