'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp, _initialiseProps;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactLifecyclesCompat = require('react-lifecycles-compat');

var _Store = require('../../contexts/Store');

var _Store2 = _interopRequireDefault(_Store);

var _routerStore = require('../../stores/routerStore');

var _routerStore2 = _interopRequireDefault(_routerStore);

var _authStore = require('../../stores/authStore');

var _authStore2 = _interopRequireDefault(_authStore);

var _tableStoreCache = require('./tableStoreCache');

var _tableStoreCache2 = _interopRequireDefault(_tableStoreCache);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TableStoreInternal = (0, _reactLifecyclesCompat.polyfill)(_class = (_temp = _class2 = function (_PureComponent) {
	_inherits(TableStoreInternal, _PureComponent);

	_createClass(TableStoreInternal, null, [{
		key: 'getDerivedStateFromProps',
		value: function getDerivedStateFromProps(_ref, prevState) {
			var table = _ref.table;

			if (!prevState.table || prevState.table === table) return null;
			return { store: prevState.getStore(table) };
		}
	}]);

	function TableStoreInternal(props, context) {
		_classCallCheck(this, TableStoreInternal);

		var _this = _possibleConstructorReturn(this, (TableStoreInternal.__proto__ || Object.getPrototypeOf(TableStoreInternal)).call(this, props, context));

		_initialiseProps.call(_this);

		var table = props.table,
		    parentStore = props.parentStore;

		var state = { store: null, getStore: _this._getStore };
		if (table) state.store = _this._getStore();else if (props.store) state.store = props.store;
		if (!state.store && parentStore) state.store = parentStore;
		_this.state = state;
		return _this;
	}

	_createClass(TableStoreInternal, [{
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			var store = this.store;

			store && store.unmount();
		}
	}, {
		key: 'render',
		value: function render() {
			var store = this.state.store,
			    children = this.props.children;

			return _react2.default.createElement(
				_Store2.default.Provider,
				{ value: store },
				children({ store: store })
			);
		}
	}]);

	return TableStoreInternal;
}(_react.PureComponent), _class2.propTypes = {
	children: _propTypes2.default.func.isRequired,
	appConfig: _propTypes2.default.object.isRequired,
	store: _propTypes2.default.object,
	parentStore: _propTypes2.default.object,
	table: _propTypes2.default.string,
	type: _propTypes2.default.string,
	useCache: _propTypes2.default.bool,
	useRouter: _propTypes2.default.bool,
	syncLocation: _propTypes2.default.bool
}, _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this._getStore = function () {
		var _props = _this2.props,
		    table = _props.table,
		    useCache = _props.useCache,
		    useRouter = _props.useRouter,
		    syncLocation = _props.syncLocation,
		    type = _props.type,
		    appConfig = _props.appConfig;

		var store = _tableStoreCache2.default.ensureStore(table, {
			useCache: useCache,
			router: useRouter || syncLocation ? _routerStore2.default : null,
			type: type,
			authStore: _authStore2.default,
			appConfig: appConfig
		});
		store.mount();
		return store;
	};
}, _temp)) || _class;

exports.default = TableStoreInternal;