'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.configShape = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.getAppConfig = getAppConfig;

var _react = require('react');

var _jsxToPlainObject = require('../../utils/jsxToPlainObject');

var _jsxToPlainObject2 = _interopRequireDefault(_jsxToPlainObject);

var _fp = require('../../utils/fp');

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _schemas = require('../../schemas');

var SchemaComponents = _interopRequireWildcard(_schemas);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var isNotEmpty = function isNotEmpty(object) {
	if (!object) return false;
	if (Array.isArray(object)) return !!object.length;
	for (var i in object) {
		return true;
	}return false;
};

var parseSchemaNodes = function parseSchemaNodes(nodes, defaults) {
	var config = {};
	var parse = function parse(nodes) {
		if ((0, _react.isValidElement)(nodes)) {
			var component = nodes.type;
			if (!component || !(0, _fp.isObject)(component.configuration)) {
				process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(false, nodes + ' is NOT a valid schema') : void 0;
			} else {
				var _component$configurat = component.configuration,
				    name = _component$configurat.name,
				    pipe = _component$configurat.pipe;

				var ctx = (0, _fp.isUndefined)(config[name]) ? defaults[name] : config[name];
				config[name] = pipe.call(ctx, nodes.props, ctx, config);
			}
			return config;
		} else if (Array.isArray(nodes)) {
			nodes.forEach(parse);
			return config;
		} else {
			return nodes;
		}
	};
	return parse(nodes);
};

// eslint-disable-next-line
var mapComponent = function mapComponent(key) {
	return SchemaComponents[key];
};
var valid = function valid(component) {
	return component.configuration;
};
var components = Object.keys(SchemaComponents).map(mapComponent).filter(valid);

var configShape = exports.configShape = components.reduce(function (shape, _ref) {
	var configuration = _ref.configuration;
	var propType = configuration.propType,
	    name = configuration.name;

	if (propType) shape[name] = propType;
	return shape;
}, {});

function getAppConfig(props) {
	var configProp = props.config,
	    children = props.children,
	    other = _objectWithoutProperties(props, ['config', 'children']);

	var config = {};
	components.forEach(function (component) {
		var defaultProps = component.defaultProps,
		    _component$configurat2 = component.configuration,
		    initialData = _component$configurat2.initialData,
		    name = _component$configurat2.name;

		config[name] = function () {
			if ((0, _fp.isFunction)(initialData)) return initialData();
			if (!(0, _fp.isUndefined)(initialData)) return initialData;
			if (defaultProps) return _extends({}, defaultProps);
			return {};
		}();
	});
	var assignArgs = [];
	if (isNotEmpty(configProp)) assignArgs.push(configProp);
	if (isNotEmpty(children)) assignArgs.push(parseSchemaNodes(children, config));
	if (isNotEmpty(other)) assignArgs.push(other);
	if (assignArgs.length) {
		Object.assign(config, (0, _jsxToPlainObject2.default)(Object.assign.apply(Object, [{}].concat(assignArgs))));
	}
	return config;
}