'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouterDom = require('react-router-dom');

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _routerStore = require('../../stores/routerStore');

var _routerStore2 = _interopRequireDefault(_routerStore);

var _authStore = require('../../stores/authStore');

var _authStore2 = _interopRequireDefault(_authStore);

var _AppConfig = require('../../contexts/AppConfig');

var _AppConfig2 = _interopRequireDefault(_AppConfig);

var _reactRouterMobx = require('react-router-mobx');

var _reactDocumentTitle = require('react-document-title');

var _reactDocumentTitle2 = _interopRequireDefault(_reactDocumentTitle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var styles = {
	container: {
		height: '100%'
	}
};

var AdminContext = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
	_inherits(AdminContext, _Component);

	_createClass(AdminContext, [{
		key: 'getChildContext',
		value: function getChildContext() {
			return {
				appConfig: this._appConfig,
				authStore: _authStore2.default
			};
		}
	}]);

	function AdminContext(props) {
		_classCallCheck(this, AdminContext);

		var _this = _possibleConstructorReturn(this, (AdminContext.__proto__ || Object.getPrototypeOf(AdminContext)).call(this, props));

		_this._appConfig = (0, _mobx.observable)(props.appConfig);
		_authStore2.default.set(_this._appConfig);
		return _this;
	}

	_createClass(AdminContext, [{
		key: 'componentDidUpdate',
		value: function componentDidUpdate(_ref) {
			var appConfig = _ref.appConfig;

			Object.assign(this._appConfig, appConfig);
			_authStore2.default.set(this._appConfig);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props$appConfig = this.props.appConfig,
			    title = _props$appConfig.title,
			    footer = _props$appConfig.footer,
			    _props$appConfig$navi = _props$appConfig.navigator,
			    Frame = _props$appConfig$navi.frame,
			    Login = _props$appConfig$navi.login,
			    basename = _props$appConfig$navi.basename,
			    otherNaviProps = _objectWithoutProperties(_props$appConfig$navi, ['frame', 'login', 'basename']);

			return _react2.default.createElement(
				_AppConfig2.default.Provider,
				{ value: this._appConfig },
				_react2.default.createElement(
					_reactDocumentTitle2.default,
					{ title: title },
					_react2.default.createElement(
						_reactRouterMobx.Router,
						{
							component: _reactRouterDom.BrowserRouter,
							basename: basename,
							routerStore: _routerStore2.default
						},
						_react2.default.createElement(
							'div',
							{ style: styles.container },
							_react2.default.createElement(
								_reactRouterDom.Switch,
								null,
								_react2.default.createElement(_reactRouterDom.Route, { path: '/login', component: Login }),
								_react2.default.createElement(_reactRouterDom.Route, {
									render: function render(_ref2) {
										var location = _ref2.location;
										return _react2.default.createElement(Frame, _extends({
											locKey: location.key,
											footer: footer
										}, otherNaviProps));
									}
								})
							)
						)
					)
				)
			);
		}
	}]);

	return AdminContext;
}(_react.Component), _class2.propTypes = {
	appConfig: _propTypes2.default.object
}, _class2.childContextTypes = {
	appConfig: _propTypes2.default.object,
	authStore: _propTypes2.default.object
}, _temp)) || _class;

exports.default = AdminContext;