'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _mobxReact = require('mobx-react');

var _panelsStore = require('../../stores/panelsStore');

var _panelsStore2 = _interopRequireDefault(_panelsStore);

var _withTable = require('../../hocs/withTable');

var _withTable2 = _interopRequireDefault(_withTable);

var _TableBody = require('../../components/TableBody');

var _TableBody2 = _interopRequireDefault(_TableBody);

var _TableQuery = require('../../components/TableQuery');

var _TableQuery2 = _interopRequireDefault(_TableQuery);

var _Toolbar = require('../../components/Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _Modal = require('../../components/Modal');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DataTableView = (_dec = (0, _withTable2.default)({ syncLocation: true, useCache: true }), _dec(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
	_inherits(DataTableView, _Component);

	function DataTableView(props) {
		_classCallCheck(this, DataTableView);

		var _this = _possibleConstructorReturn(this, (DataTableView.__proto__ || Object.getPrototypeOf(DataTableView)).call(this, props));

		props.store.clearCollections();
		return _this;
	}

	_createClass(DataTableView, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    table = _props.table,
			    menuTitle = _props.title,
			    pageTitle = _props.pageTitle,
			    Header = _props.header,
			    Footer = _props.footer,
			    Toolbar = _props.toolbar,
			    store = _props.store;

			var title = pageTitle || menuTitle || table;
			return _react2.default.createElement(
				'div',
				null,
				Header && _react2.default.createElement(Header, { store: store, title: title }),
				_react2.default.createElement(_TableQuery2.default, { store: store, hidden: !_panelsStore2.default.isShowQuery }),
				Toolbar && _react2.default.createElement(Toolbar, { store: store }),
				_react2.default.createElement(_TableBody2.default, { store: store }),
				Footer && _react2.default.createElement(Footer, { store: store })
			);
		}
	}]);

	return DataTableView;
}(_react.Component), _class2.propTypes = {
	table: _PropTypes2.default.string.isRequired,
	title: _PropTypes2.default.string,
	pageTitle: _PropTypes2.default.string,
	header: _PropTypes2.default.component,
	footer: _PropTypes2.default.component,
	toolbar: _PropTypes2.default.component,
	store: _PropTypes2.default.object
}, _class2.defaultProps = {
	toolbar: _Toolbar2.default
}, _temp)) || _class) || _class);
exports.default = DataTableView;