'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _style2 = require('antd/lib/layout/style');

var _layout = require('antd/lib/layout');

var _layout2 = _interopRequireDefault(_layout);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouterDom = require('react-router-dom');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _panelsStore = require('../../stores/panelsStore');

var _panelsStore2 = _interopRequireDefault(_panelsStore);

var _authStore = require('../../stores/authStore');

var _authStore2 = _interopRequireDefault(_authStore);

var _routerStore = require('../../stores/routerStore');

var _routerStore2 = _interopRequireDefault(_routerStore);

var _naviStore = require('../../stores/naviStore');

var _naviStore2 = _interopRequireDefault(_naviStore);

var _mobxReact = require('mobx-react');

var _Sidebar = require('../../components/Sidebar');

var _Sidebar2 = _interopRequireDefault(_Sidebar);

var _SpinBox = require('../../components/SpinBox');

var _SpinBox2 = _interopRequireDefault(_SpinBox);

var _FrameHeader = require('../../components/FrameHeader');

var _FrameHeader2 = _interopRequireDefault(_FrameHeader);

var _Breadcrumb = require('../../components/Breadcrumb');

var _Breadcrumb2 = _interopRequireDefault(_Breadcrumb);

var _Modal = require('../../components/Modal');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Header = _layout2.default.Header,
    Content = _layout2.default.Content,
    Footer = _layout2.default.Footer;

var FrameView = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
	_inherits(FrameView, _Component);

	function FrameView(props, context) {
		_classCallCheck(this, FrameView);

		var _this = _possibleConstructorReturn(this, (FrameView.__proto__ || Object.getPrototypeOf(FrameView)).call(this, props, context));

		var menus = context.appConfig.navigator.menus;
		var location = _routerStore2.default.location;

		_naviStore2.default.init(menus, location);
		return _this;
	}

	_createClass(FrameView, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this._requestAuth();
		}
	}, {
		key: '_requestAuth',
		value: function () {
			var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
				var _routerStore$location, pathname, search, isOk;

				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_routerStore$location = _routerStore2.default.location, pathname = _routerStore$location.pathname, search = _routerStore$location.search;
								_context.next = 3;
								return _authStore2.default.auth();

							case 3:
								isOk = _context.sent;

								if (!isOk) {
									_routerStore2.default.history.replace({
										pathname: '/login',
										search: 'ref=' + (pathname + search)
									});
								}

							case 5:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			function _requestAuth() {
				return _ref.apply(this, arguments);
			}

			return _requestAuth;
		}()
	}, {
		key: 'render',
		value: function render() {
			if (_authStore2.default.isFetching || !_authStore2.default.accessToken) {
				return _react2.default.createElement(_SpinBox2.default, { delay: 800, style: _styles2.default.spinContainer, component: _layout2.default });
			}

			var _props = this.props,
			    routes = _props.routes,
			    footer = _props.footer;

			return _react2.default.createElement(
				_layout2.default,
				{ style: _styles2.default.container },
				_react2.default.createElement(_Sidebar2.default, null),
				_react2.default.createElement(
					_layout2.default,
					{
						style: { marginLeft: _panelsStore2.default.isSidebarCollapsed ? 80 : 200 }
					},
					_react2.default.createElement(
						Header,
						{ style: _styles2.default.header },
						_react2.default.createElement(
							'div',
							{ style: _styles2.default.headerLeft },
							_react2.default.createElement(_Breadcrumb2.default, { style: _styles2.default.breadcrumb })
						),
						_react2.default.createElement(_FrameHeader2.default, { style: _styles2.default.headerRight })
					),
					_react2.default.createElement(
						Content,
						{ style: _styles2.default.content },
						_react2.default.createElement(
							_Modal.ModalProvider,
							{ style: _styles2.default.contentBody },
							_react2.default.createElement(
								_reactRouterDom.Switch,
								null,
								routes
							)
						)
					),
					!!footer && _react2.default.createElement(
						Footer,
						{ style: _styles2.default.footer },
						footer
					)
				)
			);
		}
	}]);

	return FrameView;
}(_react.Component), _class2.propTypes = {
	routes: _propTypes2.default.node.isRequired,
	footer: _propTypes2.default.node
}, _class2.contextTypes = {
	appConfig: _propTypes2.default.object
}, _temp)) || _class;

exports.default = FrameView;