'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Form = require('../../components/Form');

var _field = require('../../hocs/field');

var _field2 = _interopRequireDefault(_field);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _fp = require('../../utils/fp');

var _renderDate = require('../../utils/renderDate');

var _renderDate2 = _interopRequireDefault(_renderDate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildInDefaultProps = {
	inputFilter: function inputFilter(val) {
		if (!val) return;
		if ((0, _fp.isObject)(val)) return val;
		if ((0, _fp.isString)(val)) return (0, _moment2.default)(val);
	},
	outputFilter: function outputFilter(val) {
		if (!val) return;
		if ((0, _fp.isFunction)(val.toISOString)) return val.toISOString();
		if ((0, _fp.isString)(val)) return val;
	}
};

function DatePickerField(props) {
	return _react2.default.createElement(_Form.DatePicker, _extends({ defaultValue: undefined }, props, buildInDefaultProps));
}

/* eslint-disable react/prop-types */
DatePickerField.renderTable = function renderTable(_ref, _ref2) {
	var format = _ref.format,
	    dateFormat = _ref.dateFormat;
	var value = _ref2.value;

	return _react2.default.createElement(
		'span',
		null,
		(0, _renderDate2.default)(value, format, dateFormat)
	);
};

DatePickerField.propTypes = {
	format: _propTypes2.default.string,
	dateFormat: _propTypes2.default.string
};

DatePickerField.defaultProps = {
	format: 'date'
};

exports.default = (0, _field2.default)(DatePickerField);