'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _style3 = require('antd/lib/modal/style');

var _modal = require('antd/lib/modal');

var _modal2 = _interopRequireDefault(_modal);

var _style4 = require('antd/lib/icon/style');

var _icon = require('antd/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _desc, _value, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _class3, _temp;

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPolyfill = require('../../utils/reactPolyfill');

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _Form = require('../../components/Form');

var _withAppConfig = require('../../hocs/withAppConfig');

var _withAppConfig2 = _interopRequireDefault(_withAppConfig);

var _field = require('../../hocs/field');

var _field2 = _interopRequireDefault(_field);

var _ensureFileList = require('../../utils/ensureFileList');

var _ensureFileList2 = _interopRequireDefault(_ensureFileList);

var _ImageTableCell = require('./ImageTableCell');

var _ImageTableCell2 = _interopRequireDefault(_ImageTableCell);

var _resizeMode = require('./resizeMode');

var _resizeMode2 = _interopRequireDefault(_resizeMode);

var _fp = require('../../utils/fp');

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _initDefineProp(target, property, descriptor, context) {
	if (!descriptor) return;
	Object.defineProperty(target, property, {
		enumerable: descriptor.enumerable,
		configurable: descriptor.configurable,
		writable: descriptor.writable,
		value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
	});
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}

function _initializerWarningHelper(descriptor, context) {
	throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var ImageField = (_dec = (0, _withAppConfig2.default)(function (_ref) {
	var upload = _ref.upload;
	return {
		requireAccessToken: upload.requireAccessToken,
		mapFileList: upload.mapFileList,
		imagePath: upload.imagePath
	};
}), (0, _field2.default)(_class = _dec(_class = (0, _mobxReact.observer)(_class = (_class2 = (_temp = _class3 = function (_Component) {
	_inherits(ImageField, _Component);

	_createClass(ImageField, null, [{
		key: 'renderTable',
		value: function renderTable(props, _ref2) {
			var text = _ref2.text;

			return _react2.default.createElement(_ImageTableCell2.default, _extends({}, props, { url: text }));
		}
	}]);

	function ImageField(props, context) {
		_classCallCheck(this, ImageField);

		var _this = _possibleConstructorReturn(this, (ImageField.__proto__ || Object.getPrototypeOf(ImageField)).call(this, props, context));

		_initDefineProp(_this, 'fileList', _descriptor, _this);

		_initDefineProp(_this, 'previewVisible', _descriptor2, _this);

		_initDefineProp(_this, 'previewImage', _descriptor3, _this);

		_initDefineProp(_this, '_handleCloseModal', _descriptor4, _this);

		_initDefineProp(_this, '_handlePreview', _descriptor5, _this);

		_initDefineProp(_this, '_handleChange', _descriptor6, _this);

		_initDefineProp(_this, '_handleRemove', _descriptor7, _this);

		var strategy = props.strategy,
		    imagePath = props.imagePath,
		    requireAccessToken = props.requireAccessToken;
		var authStore = context.authStore,
		    appConfig = context.appConfig;
		var accessTokenName = appConfig.api.accessTokenName;


		if ((0, _fp.isObject)(strategy)) {
			_this._customRequest = strategy;
		} else if (strategy) {
			var strategies = appConfig.upload.strategies;

			process.env.NODE_ENV !== 'production' && (process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(strategies.hasOwnProperty(strategy), 'Strategy "' + strategy + '" is NOT defined in config file') : void 0);
			_this._customRequest = strategies[strategy];
		}

		// TODO: should suppport `accessToken` in header
		var search = requireAccessToken ? '?' + accessTokenName + '=' + authStore.accessToken : '';
		_this._uploadPath = imagePath + search;
		_this.uploadRef = (0, _reactPolyfill.createRef)();
		return _this;
	}

	_createClass(ImageField, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			var value = this.uploadRef.current.getValue();
			this.fileList = (0, _ensureFileList2.default)(value);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    max = _props.max,
			    strategy = _props.strategy,
			    thumbStyle = _props.thumbStyle,
			    other = _objectWithoutProperties(_props, ['max', 'strategy', 'thumbStyle']),
			    previewVisible = this.previewVisible,
			    previewImage = this.previewImage,
			    fileList = this.fileList,
			    _customRequest = this._customRequest,
			    _uploadPath = this._uploadPath;

			var uploadButton = _react2.default.createElement(
				'div',
				{ style: _styles2.default.uploadButton },
				_react2.default.createElement(_icon2.default, { style: _styles2.default.uploadButtonIcon, type: 'plus' })
			);

			return _react2.default.createElement(
				'div',
				null,
				_react2.default.createElement(
					_Form.Upload,
					_extends({}, other, {
						style: _styles2.default.container,
						customRequest: _customRequest,
						action: _uploadPath,
						listType: 'picture-card',
						fileList: fileList,
						onPreview: this._handlePreview,
						onChange: this._handleChange,
						onRemove: this._handleRemove,
						multi: max > 1,
						noFieldDecorator: true,
						ref: this.uploadRef
					}),
					fileList.length < max ? uploadButton : null
				),
				_react2.default.createElement(
					_modal2.default,
					{
						visible: previewVisible,
						footer: null,
						onCancel: this._handleCloseModal
					},
					_react2.default.createElement('img', { style: _styles2.default.image, src: previewImage })
				)
			);
		}
	}]);

	return ImageField;
}(_react.Component), _class3.propTypes = {
	max: _PropTypes2.default.number,
	render: _PropTypes2.default.func,
	strategy: _PropTypes2.default.stringOrObject,
	thumbStyle: _PropTypes2.default.object,
	strategies: _PropTypes2.default.any,
	imagePath: _PropTypes2.default.string,
	requireAccessToken: _PropTypes2.default.bool,
	mapFileList: _PropTypes2.default.func // required by `Upload` component
}, _class3.defaultProps = {
	max: 1
}, _class3.contextTypes = {
	authStore: _PropTypes2.default.object.isRequired,
	appConfig: _PropTypes2.default.object.isRequired
}, _class3.resizeMode = _resizeMode2.default, _class3.BLANK_IMAGE = _ImageTableCell2.default.BLANK_IMAGE, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, 'fileList', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return [];
	}
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, 'previewVisible', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return false;
	}
}), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, 'previewImage', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return '';
	}
}), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, '_handleCloseModal', [_mobx.action], {
	enumerable: true,
	initializer: function initializer() {
		var _this2 = this;

		return function () {
			_this2.previewVisible = false;
		};
	}
}), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, '_handlePreview', [_mobx.action], {
	enumerable: true,
	initializer: function initializer() {
		var _this3 = this;

		return function (file) {
			_this3.previewImage = file.url || file.thumbUrl;
			_this3.previewVisible = true;
		};
	}
}), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, '_handleChange', [_mobx.action], {
	enumerable: true,
	initializer: function initializer() {
		var _this4 = this;

		return function (_ref3) {
			var fileList = _ref3.fileList;

			_this4.fileList = fileList;
		};
	}
}), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, '_handleRemove', [_mobx.action], {
	enumerable: true,
	initializer: function initializer() {
		var _this5 = this;

		return function (file) {
			var index = _this5.fileList.findIndex(function (_ref4) {
				var id = _ref4.id;
				return id === file.id;
			});
			var shouldRemove = index > -1;
			if (shouldRemove) _this5.fileList.splice(index, 1);
		};
	}
})), _class2)) || _class) || _class) || _class);
exports.default = ImageField;