'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Form = require('../../components/Form');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _field = require('../../hocs/field');

var _field2 = _interopRequireDefault(_field);

var _reactFormMobx = require('react-form-mobx');

var _fp = require('../../utils/fp');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var rangeInputFilter = function rangeInputFilter(range) {
	return range.map(function (val) {
		if ((0, _fp.isObject)(val)) {
			return val;
		} else if ((0, _fp.isString)(val)) {
			return (0, _moment2.default)(val);
		}
	});
};

var rangeOutputFilter = function rangeOutputFilter(range) {
	var output = range.map(function (val) {
		if (val && (0, _fp.isFunction)(val.toISOString)) {
			return val.toISOString();
		} else if ((0, _fp.isString)(val)) {
			return val;
		}
	}).filter(function (val) {
		return val;
	}).join(',');
	return output;
};

var formatFunc = function formatFunc(val) {
	return val.filter(Boolean).map(function (date) {
		return _reactFormMobx.formatHelper.date(date);
	});
};

var buildInDefaultProps = {
	preFormat: function preFormat(val) {
		if ((0, _fp.isString)(val)) return val.split(',');
		return val;
	},
	inputFilter: function inputFilter() {
		var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

		if ((0, _fp.isFunction)(value.map)) {
			return rangeInputFilter(value);
		} else if ((0, _fp.isFunction)(value.split)) {
			var _value$split = value.split(','),
			    _value$split2 = _slicedToArray(_value$split, 2),
			    v0 = _value$split2[0],
			    v1 = _value$split2[1];

			return v0 && v1 ? [(0, _moment2.default)(v0), (0, _moment2.default)(v1)] : undefined;
		}
		return [undefined, undefined];
	},
	outputFilter: function outputFilter(value) {
		if (value && (0, _fp.isFunction)(value.map)) {
			return rangeOutputFilter(value);
		}
		return value;
	}
};

var isEmpty = function isEmpty(val) {
	if (!val) {
		return true;
	}
	if ((0, _fp.isFunction)(val.every)) {
		return val.every(function (item) {
			return (0, _fp.isUndefined)(item);
		});
	}
	return false;
};

// TODO: add should ignore support
var shouldIgnore = function shouldIgnore(value, pristineValue) {
	return isEmpty(value) && isEmpty(pristineValue);
};

function RangePickerField(props) {
	return _react2.default.createElement(_Form.RangePicker, _extends({}, buildInDefaultProps, props, { formatFunc: formatFunc }));
}

exports.default = (0, _field2.default)(RangePickerField);