'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _class, _class2, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _fp = require('../../utils/fp');

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _field = require('../../hocs/field');

var _field2 = _interopRequireDefault(_field);

var _withAppConfig = require('../../hocs/withAppConfig');

var _withAppConfig2 = _interopRequireDefault(_withAppConfig);

var _RefSelector = require('../../components/RefSelector');

var _RefSelector2 = _interopRequireDefault(_RefSelector);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isRefObjectValue = function isRefObjectValue(val) {
	return val && (0, _fp.isObject)(val);
};

var warned = false;

var RefField = (_dec = (0, _withAppConfig2.default)(function (appConfig, props) {
	var tableConfig = appConfig.tables[props.table];
	if (tableConfig) return { tableUniqueKey: tableConfig.uniqueKey };
}), _dec(_class = (0, _field2.default)(_class = (_temp2 = _class2 = function (_Component) {
	_inherits(RefField, _Component);

	function RefField() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, RefField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = RefField.__proto__ || Object.getPrototypeOf(RefField)).call.apply(_ref, [this].concat(args))), _this), _this._inputFilter = function (val) {
			if (isRefObjectValue(val)) {
				var tableUniqueKey = _this.props.tableUniqueKey;

				return val[tableUniqueKey];
			}
			return val;
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(RefField, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    tableUniqueKey = _props.tableUniqueKey,
			    other = _objectWithoutProperties(_props, ['tableUniqueKey']);

			return _react2.default.createElement(_RefSelector2.default, _extends({ inputFilter: this._inputFilter }, other));
		}
	}], [{
		key: 'renderTable',
		value: function renderTable(props, _ref2) {
			var value = _ref2.value;

			var content = value;
			if (isRefObjectValue(value)) {
				var displayField = props.displayField;

				if (displayField) {
					content = value[displayField];
				} else {
					process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(warned, 'It\'s recommeded to set a `displayField` in Ref component') : void 0;
					warned = true;
					try {
						content = JSON.stringify(value);
					} catch (err) {}
				}
			}
			return _react2.default.createElement(
				'span',
				null,
				content
			);
		}
	}]);

	return RefField;
}(_react.Component), _class2.propTypes = {
	table: _propTypes2.default.string.isRequired,
	tableUniqueKey: _propTypes2.default.string.isRequired,
	displayField: _propTypes2.default.string
}, _temp2)) || _class) || _class);
exports.default = RefField;