'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = field;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobx = require('mobx');

var _mobxReact = require('mobx-react');

var _Issuers = require('../../utils/Issuers');

var _withIssuer = require('../withIssuer');

var _withIssuer2 = _interopRequireDefault(_withIssuer);

var _withStore = require('../withStore');

var _withStore2 = _interopRequireDefault(_withStore);

var _hoist = require('../hoist');

var _hoist2 = _interopRequireDefault(_hoist);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}

function field(WrappedComponent) {
	var _dec, _dec2, _dec3, _class, _desc, _value, _class2, _class3, _temp;

	var defaultProps = _extends({
		disabled: false,
		sortable: false
	}, WrappedComponent.defaultProps);

	var WithField = (_dec = (0, _hoist2.default)(WrappedComponent), _dec2 = (0, _withStore2.default)(), _dec3 = (0, _withIssuer2.default)(), _dec(_class = _dec2(_class = _dec3(_class = (0, _mobxReact.observer)(_class = (_class2 = (_temp = _class3 = function (_Component) {
		_inherits(WithField, _Component);

		function WithField(props) {
			_classCallCheck(this, WithField);

			var _this = _possibleConstructorReturn(this, (WithField.__proto__ || Object.getPrototypeOf(WithField)).call(this, props));

			var issuers = props.issuers;

			_this._isQuerier = issuers && issuers.has(_Issuers.QUERIER);
			return _this;
		}

		_createClass(WithField, [{
			key: 'render',
			value: function render() {
				if (!this._shouldShow) return null;

				var _props = this.props,
				    disabled = _props.disabled,
				    required = _props.required,
				    issuers = _props.issuers,
				    value = _props.value,
				    unique = _props.unique,
				    sortable = _props.sortable,
				    tableColumnWidth = _props.tableColumnWidth,
				    other = _objectWithoutProperties(_props, ['disabled', 'required', 'issuers', 'value', 'unique', 'sortable', 'tableColumnWidth']),
				    _isQuerier = this._isQuerier;

				return _react2.default.createElement(WrappedComponent, _extends({}, (0, _hoist.extractRef)(other), {
					required: required && !_isQuerier,
					disabled: disabled && !_isQuerier
				}));
			}
		}, {
			key: '_shouldShow',
			get: function get() {
				var _props2 = this.props,
				    name = _props2.name,
				    store = _props2.store;


				return !store || !store.selectedNames.length || ~store.selectedNames.indexOf(name);
			}
		}]);

		return WithField;
	}(_react.Component), _class3.propTypes = {
		name: _propTypes2.default.string,
		value: _propTypes2.default.any,
		defaultValue: _propTypes2.default.any,
		label: _propTypes2.default.string,
		tableColumnWidth: _propTypes2.default.number,
		labelCol: _propTypes2.default.object,
		wrapperCol: _propTypes2.default.object,
		required: _propTypes2.default.bool,
		unique: _propTypes2.default.bool,
		disabled: _propTypes2.default.bool,
		validations: _propTypes2.default.array,
		sortable: _propTypes2.default.bool,
		store: _propTypes2.default.object,

		// provided by `withIssuer()`
		issuers: _propTypes2.default.instanceOf(Set).isRequired
	}, _class3.defaultProps = defaultProps, _temp), (_applyDecoratedDescriptor(_class2.prototype, '_shouldShow', [_mobx.computed], Object.getOwnPropertyDescriptor(_class2.prototype, '_shouldShow'), _class2.prototype)), _class2)) || _class) || _class) || _class) || _class);

	// because schema component doesn't really render,
	// so HOCs won't able to setup default props from WrappedComponents

	WithField.defaultProps = defaultProps;

	return WithField;
}