'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.extractRef = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = hoist;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPolyfill = require('../../utils/reactPolyfill');

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _fp = require('../../utils/fp');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var isStatelessComponent = function isStatelessComponent(component) {
	return !component || (0, _fp.isFunction)(component) && !('render' in component.prototype);
};

var getDisplayName = function getDisplayName(component) {
	return component.displayName || component.name;
};

function hoist(WrappedComponent) {
	var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	var displayName = options.displayName;

	return function createHoistedComponent(TargetComponent) {
		var HoistedComponent = TargetComponent;
		if (!isStatelessComponent(TargetComponent) && !isStatelessComponent(WrappedComponent)) {
			HoistedComponent = (0, _reactPolyfill.forwardRef)(function (props, ref) {
				return _react2.default.createElement(TargetComponent, _extends({}, props, { forwardedRef: ref }));
			});
			HoistedComponent.displayName = getDisplayName(TargetComponent);
			HoistedComponent.defaultProps = TargetComponent.defaultProps;
		}

		if (WrappedComponent) {
			HoistedComponent.WrappedComponent = WrappedComponent;
			(0, _hoistNonReactStatics2.default)(HoistedComponent, WrappedComponent, { render: true });
		}
		if (displayName) {
			HoistedComponent.displayName = displayName;
		} else {
			var originalDisplayName = getDisplayName(WrappedComponent);
			var prefix = getDisplayName(HoistedComponent);
			HoistedComponent.displayName = prefix + '(' + originalDisplayName + ')';
		}
		return HoistedComponent;
	};
}

var extractRef = function extractRef(props) {
	var forwardedRef = props.forwardedRef,
	    other = _objectWithoutProperties(props, ['forwardedRef']);

	return forwardedRef ? _extends({}, other, { ref: forwardedRef }) : other;
};
exports.extractRef = extractRef;