'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = localize;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _LocaleStores = require('../../stores/LocaleStores');

var _LocaleStores2 = _interopRequireDefault(_LocaleStores);

var _hoist = require('../hoist');

var _hoist2 = _interopRequireDefault(_hoist);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function localize(name) {
	var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	var _options$prop = options.prop,
	    prop = _options$prop === undefined ? 'localeStore' : _options$prop;

	return function createLocalizedComponent(WrappedComponent) {
		var _dec, _class;

		var hasLocale = _LocaleStores2.default.test(name);
		var storeProps = {};
		process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(hasLocale, 'locale component "' + name + '" not found') : void 0;
		if (hasLocale) storeProps[prop] = _LocaleStores2.default.ensure(name);

		var Locale = (_dec = (0, _hoist2.default)(WrappedComponent), _dec(_class = (0, _mobxReact.observer)(_class = function (_Component) {
			_inherits(Locale, _Component);

			function Locale() {
				_classCallCheck(this, Locale);

				return _possibleConstructorReturn(this, (Locale.__proto__ || Object.getPrototypeOf(Locale)).apply(this, arguments));
			}

			_createClass(Locale, [{
				key: 'render',
				value: function render() {
					return _react2.default.createElement(WrappedComponent, _extends({}, (0, _hoist.extractRef)(this.props), storeProps));
				}
			}]);

			return Locale;
		}(_react.Component)) || _class) || _class);


		return Locale;
	};
}