'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Issuers = require('../../utils/Issuers');

var _Actions = require('../../constants/Actions');

var _joinKeys = require('../../utils/joinKeys');

var _joinKeys2 = _interopRequireDefault(_joinKeys);

var _deprecated = require('../../utils/deprecated');

var _deprecated2 = _interopRequireDefault(_deprecated);

var _routerStore = require('../../stores/routerStore');

var _routerStore2 = _interopRequireDefault(_routerStore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Actions = function () {
	_createClass(Actions, [{
		key: 'props',
		get: function get() {
			return this._reactInstance.props;
		}
	}, {
		key: 'modalController',
		get: function get() {
			return this._reactInstance.modalController;
		}
	}, {
		key: 'store',
		get: function get() {
			return this.props.store;
		}
	}, {
		key: 'issuers',
		get: function get() {
			return this.props.issuers;
		}
	}, {
		key: 'pageContext',
		get: function get() {
			return this.props.pageContext;
		}
	}, {
		key: 'selectedKeys',
		get: function get() {
			var _props = this.props,
			    store = _props.store,
			    tableRowKey = _props.tableRowKey;

			return tableRowKey ? [tableRowKey] : store.selectedKeys;
		}
	}, {
		key: 'selectedKeysString',
		get: function get() {
			return (0, _joinKeys2.default)(this.selectedKeys);
		}
	}, {
		key: 'selectedKeysHead',
		get: function get() {
			return this.selectedKeys.length ? this.selectedKeys[0] : undefined;
		}
	}]);

	function Actions(reactInstance) {
		var _this = this;

		_classCallCheck(this, Actions);

		this.getSelectedKeysString = function () {
			return _this.selectedKeysString;
		};

		this.getData = function () {
			return _this.store.getData(_this.selectedKeysHead);
		};

		this.dispatch = function (name, modalParams) {
			var modalController = _this.modalController,
			    store = _this.store,
			    _props2 = _this.props,
			    pageContext = _props2.pageContext,
			    issuers = _props2.issuers,
			    enforceModal = _props2.enforceModal;

			var keys = _this.selectedKeysString;
			if (!enforceModal && !modalParams && pageContext && pageContext.useDetail && (name === _Actions.CREATE || name === _Actions.UPDATE) && !issuers.has(_Issuers.MODAL)) {
				var path = name === _Actions.UPDATE ? '/update/' + keys : '/create';
				_routerStore2.default.location.pathname += path;
			} else {
				modalController.open(name, _extends({
					keys: keys,
					store: store
				}, modalParams));
				return modalController.close.bind(modalController);
			}
		};

		this.create = function (modalParams) {
			return _this.dispatch(_Actions.CREATE, modalParams);
		};

		this.update = function (modalParams) {
			return _this.dispatch(_Actions.UPDATE, modalParams);
		};

		this.ref = function (modalParams) {
			return _this.dispatch(_Actions.REF, _extends({
				fetch: 'fetch',
				save: 'request',
				width: 880
			}, modalParams));
		};

		this.open = (0, _deprecated2.default)(function (name) {
			var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
			var modalController = _this.modalController;

			var keys = _this.selectedKeysString;
			modalController.open(name, _extends({
				keys: keys
			}, params));
			return modalController.close.bind(modalController);
		}, '`open()` is deprecated, please use dispatch() instead');
		this.openCreaterModal = (0, _deprecated2.default)(function () {
			var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			return _this.open(_Actions.CREATE, params);
		}, '`openCreaterModal()` is deprecated, please use create() instead');
		this.openUpdaterModal = (0, _deprecated2.default)(function () {
			var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			var select = params.select,
			    otherParams = _objectWithoutProperties(params, ['select']);

			if (select && select.length) {
				otherParams.select = select.join(',');
			}
			return _this.open(_Actions.UPDATE, otherParams);
		}, '`openUpdaterModal()` is deprecated, please use update() instead');
		this.openRefModal = (0, _deprecated2.default)(function () {
			var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

			var _params$fetch = params.fetch,
			    fetch = _params$fetch === undefined ? 'fetch' : _params$fetch,
			    _params$save = params.save,
			    save = _params$save === undefined ? 'request' : _params$save,
			    _params$width = params.width,
			    width = _params$width === undefined ? 880 : _params$width,
			    other = _objectWithoutProperties(params, ['fetch', 'save', 'width']);

			var config = _extends({ fetch: fetch, save: save, width: width }, other);
			return _this.open(_Actions.REF, config);
		}, '`openRefModal()` is deprecated, please use ref() instead');

		this._reactInstance = reactInstance;
	}

	return Actions;
}();

exports.default = Actions;