'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = withActions;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _Actions = require('./Actions');

var _Actions2 = _interopRequireDefault(_Actions);

var _hoist = require('../hoist');

var _hoist2 = _interopRequireDefault(_hoist);

var _withStore = require('../withStore');

var _withStore2 = _interopRequireDefault(_withStore);

var _withIssuer = require('../withIssuer');

var _withIssuer2 = _interopRequireDefault(_withIssuer);

var _ModalControllerContext = require('../../components/Modal/ModalControllerContext');

var _ModalControllerContext2 = _interopRequireDefault(_ModalControllerContext);

var _PageContext = require('../../contexts/PageContext');

var _PageContext2 = _interopRequireDefault(_PageContext);

var _TableRowKey = require('../../contexts/TableRowKey');

var _TableRowKey2 = _interopRequireDefault(_TableRowKey);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Notice that this `Action` is NOT Redux or MobX action.
function withActions(WrappedComponent) {
	var _dec, _dec2, _dec3, _class, _class2, _temp2;

	var WithActions = (_dec = (0, _hoist2.default)(WrappedComponent), _dec2 = (0, _withIssuer2.default)(), _dec3 = (0, _withStore2.default)(), _dec(_class = _dec2(_class = _dec3(_class = (0, _mobxReact.observer)(_class = (_temp2 = _class2 = function (_Component) {
		_inherits(WithActions, _Component);

		function WithActions() {
			var _ref;

			var _temp, _this, _ret;

			_classCallCheck(this, WithActions);

			for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
				args[_key] = arguments[_key];
			}

			return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WithActions.__proto__ || Object.getPrototypeOf(WithActions)).call.apply(_ref, [this].concat(args))), _this), _this.actions = new _Actions2.default(_this), _temp), _possibleConstructorReturn(_this, _ret);
		}

		_createClass(WithActions, [{
			key: 'render',
			value: function render() {
				var _this2 = this;

				var _props = this.props,
				    store = _props.store,
				    pageContext = _props.pageContext,
				    tableRowKey = _props.tableRowKey,
				    enforceModal = _props.enforceModal,
				    props = _objectWithoutProperties(_props, ['store', 'pageContext', 'tableRowKey', 'enforceModal']),
				    actions = this.actions;

				return _react2.default.createElement(
					_ModalControllerContext2.default.Consumer,
					null,
					function (modalController) {
						_this2.modalController = modalController;
						return _react2.default.createElement(WrappedComponent, _extends({}, (0, _hoist.extractRef)(props), { actions: actions }));
					}
				);
			}
		}]);

		return WithActions;
	}(_react.Component), _class2.propTypes = {
		store: _propTypes2.default.object.isRequired,
		issuers: _propTypes2.default.instanceOf(Set).isRequired,
		pageContext: _propTypes2.default.object,
		tableRowKey: _propTypes2.default.string,
		enforceModal: _propTypes2.default.bool
	}, _class2.defaultProps = {
		enforceModal: false
	}, _temp2)) || _class) || _class) || _class) || _class);


	function WithActionsWrapper(props) {
		return _react2.default.createElement(
			_PageContext2.default.Consumer,
			null,
			function (pageContext) {
				return _react2.default.createElement(
					_TableRowKey2.default.Consumer,
					null,
					function (tableRowKey) {
						return _react2.default.createElement(WithActions, _extends({}, props, {
							pageContext: pageContext,
							tableRowKey: tableRowKey
						}));
					}
				);
			}
		);
	}

	return WithActionsWrapper;
}