'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = createFormModal;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactPolyfill = require('../../utils/reactPolyfill');

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _joinKeys = require('../../utils/joinKeys');

var _joinKeys2 = _interopRequireDefault(_joinKeys);

var _Issuers = require('../../utils/Issuers');

var _fp = require('../../utils/fp');

var _mobxReact = require('mobx-react');

var _withTable = require('../../hocs/withTable');

var _withTable2 = _interopRequireDefault(_withTable);

var _withIssuer = require('../../hocs/withIssuer');

var _withIssuer2 = _interopRequireDefault(_withIssuer);

var _Modal = require('../../components/Modal');

var _FormBody = require('../../components/FormBody');

var _FormBody2 = _interopRequireDefault(_FormBody);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function createFormModal(defaultTitle, issuer, displayName) {
	var _dec, _dec2, _class, _class2, _temp, _initialiseProps;

	var isCreater = issuer === _Issuers.CREATER;

	var FormModalView = (_dec = (0, _withTable2.default)(), _dec2 = (0, _withIssuer2.default)({ issuer: issuer }), _dec(_class = _dec2(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
		_inherits(FormModalView, _Component);

		function FormModalView(props) {
			_classCallCheck(this, FormModalView);

			var _this = _possibleConstructorReturn(this, (FormModalView.__proto__ || Object.getPrototypeOf(FormModalView)).call(this, props));

			_initialiseProps.call(_this);

			var store = props.store,
			    keys = props.keys,
			    names = props.names;

			if (names.length) {
				store.setSelectedNames(names);
			}
			if (isCreater) _this._createrValue = {};else {
				var selectedKeys = (keys || '').split(',');
				store.setSelectedKeys(selectedKeys);
				store.call('fetch');
			}
			return _this;
		}

		_createClass(FormModalView, [{
			key: 'componentWillUnmount',
			value: function componentWillUnmount() {
				this.props.store.clearSelectedNames();
			}
		}, {
			key: 'render',
			value: function render() {
				var _props = this.props,
				    store = _props.store,
				    title = _props.title,
				    width = _props.width,
				    keys = _props.keys,
				    isOk = this.state.isOk;

				return _react2.default.createElement(
					_Modal.ModalConsumer,
					{
						title: title,
						width: width,
						okButtonProps: { disabled: !isOk },
						onOk: this._handleOk,
						ref: this.modalRef
					},
					_react2.default.createElement(_FormBody2.default, {
						value: isCreater ? this._createrValue : store.getData(keys),
						formRef: this.formRef,
						store: store,
						selectedKeys: (0, _joinKeys2.default)(keys),
						onStatusChange: this._handleStatusChange,
						onSubmit: this._handleSubmit
					})
				);
			}
		}]);

		return FormModalView;
	}(_react.Component), _class2.displayName = displayName, _class2.propTypes = {
		store: _PropTypes2.default.object.isRequired,
		// table: PropTypes.string,
		keys: _PropTypes2.default.string,
		save: _PropTypes2.default.stringOrFunc,
		title: _PropTypes2.default.node,
		width: _PropTypes2.default.stringOrNumber,
		names: _PropTypes2.default.array
	}, _class2.defaultProps = {
		title: defaultTitle,
		width: 800,
		save: isCreater ? 'create' : 'update',
		names: []
	}, _initialiseProps = function _initialiseProps() {
		var _this2 = this;

		this.state = {
			isOk: false
		};
		this.formRef = (0, _reactPolyfill.createRef)();
		this.modalRef = (0, _reactPolyfill.createRef)();

		this._handleOk = function (ev) {
			var form = _this2.formRef.current;
			if (!form) return;
			ev.preventDefault();

			var _form$getValidState = form.getValidState(),
			    isValid = _form$getValidState.isValid;

			if (isValid) {
				var store = _this2.props.store;

				form.submit();
				store.setSelectedKeys([]);
			}
		};

		this._handleSubmit = function (body, state, _ref) {
			var selectedKeys = _ref.selectedKeys;
			var props = _this2.props;
			var save = props.save,
			    store = props.store;

			var options = _extends({}, props, { url: selectedKeys, body: body });
			(0, _fp.isFunction)(save) ? save(options) : store.call(save, options);
			_this2.modalRef.current.close();
		};

		this._handleStatusChange = function (isOk) {
			if (_this2.state.isOk !== isOk) {
				_this2.setState({ isOk: isOk });
			}
		};
	}, _temp)) || _class) || _class) || _class);


	return FormModalView;
}