'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dec, _dec2, _dec3, _class, _class2, _temp, _initialiseProps;
// import withStore from 'hocs/withStore';


var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _renderProp = require('../../utils/renderProp');

var _renderProp2 = _interopRequireDefault(_renderProp);

var _joinKeys = require('../../utils/joinKeys');

var _joinKeys2 = _interopRequireDefault(_joinKeys);

var _Issuers = require('../../utils/Issuers');

var _fp = require('../../utils/fp');

var _withTable = require('../../hocs/withTable');

var _withTable2 = _interopRequireDefault(_withTable);

var _withIssuer = require('../../hocs/withIssuer');

var _withIssuer2 = _interopRequireDefault(_withIssuer);

var _Modal = require('../../components/Modal');

var _TableBody = require('../../components/TableBody');

var _TableBody2 = _interopRequireDefault(_TableBody);

var _TableQuery = require('../../components/TableQuery');

var _TableQuery2 = _interopRequireDefault(_TableQuery);

var _Toolbar = require('../../components/Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _QueryConnector = require('../../components/QueryConnector');

var _QueryConnector2 = _interopRequireDefault(_QueryConnector);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RefModal = (_dec = (0, _withTable2.default)({ prop: 'contextStore' }), _dec2 = (0, _withTable2.default)(), _dec3 = (0, _withIssuer2.default)({ issuer: _Issuers.REF }), _dec(_class = _dec2(_class = _dec3(_class = (_temp = _class2 = function (_Component) {
	_inherits(RefModal, _Component);

	function RefModal(props, context) {
		_classCallCheck(this, RefModal);

		var _this = _possibleConstructorReturn(this, (RefModal.__proto__ || Object.getPrototypeOf(RefModal)).call(this, props, context));

		_initialiseProps.call(_this);

		var fetch = props.fetch,
		    refStore = props.store;

		(0, _fp.isFunction)(fetch) ? fetch(props) : refStore.call(fetch, props);
		return _this;
	}

	_createClass(RefModal, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    noQuery = _props.noQuery,
			    store = _props.store,
			    title = _props.title,
			    width = _props.width,
			    Header = _props.header,
			    Footer = _props.footer,
			    ModalFooter = _props.modalFooter,
			    toolbar = _props.toolbar;

			return _react2.default.createElement(
				_QueryConnector2.default,
				{ store: store },
				_react2.default.createElement(
					_Modal.ModalConsumer,
					{
						width: width,
						title: title,
						onOk: this._handleOk,
						footer: ModalFooter && _react2.default.createElement(ModalFooter, { store: store })
					},
					(0, _renderProp2.default)(Header),
					Header && _react2.default.createElement(Header, { store: store }),
					!noQuery && _react2.default.createElement(_TableQuery2.default, { store: store }),
					toolbar === true ? _react2.default.createElement(_Toolbar2.default, null) : (0, _renderProp2.default)(toolbar, { store: store }),
					_react2.default.createElement(_TableBody2.default, { store: store, selectionType: 'radio' }),
					Footer && _react2.default.createElement(Footer, { store: store })
				)
			);
		}
	}]);

	return RefModal;
}(_react.Component), _class2.propTypes = {
	table: _PropTypes2.default.string.isRequired,
	fetch: _PropTypes2.default.stringOrFunc,
	keys: _PropTypes2.default.string,
	save: _PropTypes2.default.stringOrFunc,
	noQuery: _PropTypes2.default.any,
	store: _PropTypes2.default.object,
	contextStore: _PropTypes2.default.object.isRequired,
	title: _PropTypes2.default.node,
	width: _PropTypes2.default.stringOrNumber,
	header: _PropTypes2.default.component,
	footer: _PropTypes2.default.component,
	toolbar: _PropTypes2.default.oneOfType([_PropTypes2.default.component, _PropTypes2.default.bool, _PropTypes2.default.node]),
	modalFooter: _PropTypes2.default.component
}, _class2.defaultProps = {
	fetch: 'fetch',
	save: 'request',
	noQuery: false,
	title: 'Reference',
	width: 800,
	toolbar: false
}, _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this._handleOk = function () {
		var props = _this2.props,
		    _props2 = _this2.props,
		    keys = _props2.keys,
		    save = _props2.save,
		    refStore = _props2.store;
		var pathname = refStore.pathname;

		var refKeys = refStore.selectedKeys;
		var url = (0, _joinKeys2.default)(keys) + ('/' + pathname + '/') + (0, _joinKeys2.default)(refKeys);
		var options = _extends({ method: 'POST', url: url }, props, { keys: keys, refKeys: refKeys, refStore: refStore });
		(0, _fp.isFunction)(save) ? save(options) : refStore.call(save, options);
	};
}, _temp)) || _class) || _class) || _class);
exports.default = RefModal;