'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = APISchema;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function APISchema() {
	return _react2.default.createElement('noscript', null);
}

APISchema.propTypes = {
	baseURL: _propTypes2.default.string.isRequired,
	timeout: _propTypes2.default.number,
	count: _propTypes2.default.number,
	accessTokenName: _propTypes2.default.string,
	accessTokenLocation: _propTypes2.default.oneOf(['headers', 'header', 'query']),
	sortKey: _propTypes2.default.string,
	orderKey: _propTypes2.default.string,
	descValue: _propTypes2.default.string,
	ascValue: _propTypes2.default.string
};

APISchema.defaultProps = {
	timeout: 15000,
	count: 20,
	accessTokenName: 'X-ACCESS-TOKEN',
	accessTokenLocation: 'headers',
	sortKey: 'sort',
	orderKey: 'order',
	descValue: 'desc',
	ascValue: 'asc'
};

APISchema.configuration = {
	name: 'api',
	propType: _propTypes2.default.object,
	pipe: function pipe(_ref) {
		var accessTokenLocation = _ref.accessTokenLocation,
		    props = _objectWithoutProperties(_ref, ['accessTokenLocation']);

		return Object.assign(this, props, {
			accessTokenLocation: accessTokenLocation !== 'query' ? 'headers' : 'query'
		});
	}
};