'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = AuthSchema;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _emptyFunctions = require('empty-functions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function AuthSchema() {
	return _react2.default.createElement('noscript', null);
}

AuthSchema.propTypes = {
	basePath: _propTypes2.default.string.isRequired,
	loginPath: _propTypes2.default.string.isRequired,
	getUserPath: _propTypes2.default.string.isRequired,
	defaultLoginRedirection: _propTypes2.default.string,
	mapOnLoginResponse: _propTypes2.default.func,
	mapOnGetUserResponse: _propTypes2.default.func
};

AuthSchema.defaultProps = {
	defaultLoginRedirection: '/',
	mapOnLoginResponse: _emptyFunctions.returnsArgument,
	mapOnGetUserResponse: _emptyFunctions.returnsArgument
};

AuthSchema.configuration = {
	name: 'auth',
	propType: _propTypes2.default.object,
	pipe: function pipe(props, auth) {
		return Object.assign(auth, props);
	}
};