'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = ModalSchema;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PropTypes = require('../../utils/PropTypes');

var _PropTypes2 = _interopRequireDefault(_PropTypes);

var _Actions = require('../../constants/Actions');

var Actions = _interopRequireWildcard(_Actions);

var _FormModals = require('../../modals/FormModals');

var _RefModal = require('../../modals/RefModal');

var _RefModal2 = _interopRequireDefault(_RefModal);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ModalSchema() {
	return _react2.default.createElement('noscript', null);
}

ModalSchema.propTypes = {
	name: _PropTypes2.default.string.isRequired,
	component: _PropTypes2.default.component.isRequired
};

ModalSchema.configuration = {
	name: 'modals',
	propType: _PropTypes2.default.map,
	pipe: function pipe(_ref, modals) {
		var name = _ref.name,
		    component = _ref.component;

		modals.set(name, component);
		return modals;
	},
	initialData: function initialData() {
		var modals = new Map();
		modals.set(Actions.CREATE, _FormModals.CreaterModal);
		modals.set(Actions.UPDATE, _FormModals.UpdaterModal);
		modals.set(Actions.REF, _RefModal2.default);
		return modals;
	}
};