'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = createRendererState;
var stateKeys = ['record', 'value', 'index', 'name', 'key', 'component', 'Component', 'text'];

function createRendererState(store, options) {
	var proxy = {};
	stateKeys.forEach(function (key) {
		Object.defineProperty(proxy, key, {
			get: function get() {
				if (key === 'text') key = 'value';else if (key === 'component') key = 'Component';
				if (store.hasOwnProperty(key)) return store[key];
				if (options.hasOwnProperty(key)) return options[key];
				if (key === 'record') return store.record || {};
				if (key === 'value') return proxy.record[proxy.key];
				if (key === 'index') return 0;
			}
		});
	});
	return proxy;
}