'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = UploadSchema;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function UploadSchema() {
	return _react2.default.createElement('noscript', null);
}

UploadSchema.propTypes = {
	imagePath: _propTypes2.default.string,
	imageSizeLimit: _propTypes2.default.number,
	filePath: _propTypes2.default.string,
	fileSizeLimit: _propTypes2.default.number,
	strategies: _propTypes2.default.object,
	requireAccessToken: _propTypes2.default.bool,
	mapFileList: _propTypes2.default.func
};

UploadSchema.defaultProps = {
	imagePath: 'upload/image',
	imageSizeLimit: 5120,
	filePath: 'upload/file',
	fileSizeLimit: 10240,
	strategies: {},
	requireAccessToken: false,
	mapFileList: function mapFileList(fileList) {
		return fileList.filter(function (_ref) {
			var status = _ref.status;
			return status === 'done';
		}).map(function (_ref2) {
			var thumbUrl = _ref2.thumbUrl,
			    response = _ref2.response;
			return response.url || thumbUrl;
		}).join(',');
	}
};

UploadSchema.configuration = {
	name: 'upload',
	propType: _propTypes2.default.object,
	pipe: function pipe(props, config) {
		return Object.assign(config, props);
	}
};