'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3;

var _mobx = require('mobx');

var _fp = require('../utils/fp');

var _showError = require('../utils/showError');

var _showError2 = _interopRequireDefault(_showError);

var _LocaleStores = require('./LocaleStores');

var _LocaleStores2 = _interopRequireDefault(_LocaleStores);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _Table = require('../schemas/Table');

var _Table2 = _interopRequireDefault(_Table);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _initDefineProp(target, property, descriptor, context) {
	if (!descriptor) return;
	Object.defineProperty(target, property, {
		enumerable: descriptor.enumerable,
		configurable: descriptor.configurable,
		writable: descriptor.writable,
		value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
	});
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}

function _initializerWarningHelper(descriptor, context) {
	throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var locale = _LocaleStores2.default.ensure('requests');

var BaseDataStore = (_class = function () {
	_createClass(BaseDataStore, [{
		key: 'cacheKey',
		get: function get() {
			return JSON.stringify(this.query);
		}
	}, {
		key: 'config',
		get: function get() {
			var name = this.name;
			var table = this.appConfig.tables[name];
			process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(!name || table, 'Table "' + name + '" is NOT found') : void 0;
			return _extends({}, _Table2.default.defaultProps, table, this._customConfig);
		}
	}, {
		key: 'renderers',
		get: function get() {
			return this.config.renderers;
		}
	}]);

	function BaseDataStore() {
		var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		_classCallCheck(this, BaseDataStore);

		_initDefineProp(this, 'query', _descriptor, this);

		_initDefineProp(this, 'selectedKeys', _descriptor2, this);

		_initDefineProp(this, 'selectedNames', _descriptor3, this);

		var name = options.name,
		    appConfig = options.appConfig,
		    authStore = options.authStore,
		    customConfig = options.config,
		    baseRequest = options.baseRequest,
		    router = options.router;

		this.name = name;
		this._customConfig = customConfig;
		this.appConfig = appConfig;
		this.extends = {};
		this.router = router;

		var _config = this.config,
		    extend = _config.extend,
		    api = _config.api;
		var _appConfig$api = appConfig.api,
		    accessTokenLocation = _appConfig$api.accessTokenLocation,
		    accessTokenName = _appConfig$api.accessTokenName;

		var fetchAuthTransformerName = accessTokenLocation === 'query' ? 'addQueryTransformer' : 'addHeadersTransformer';
		baseRequest[fetchAuthTransformerName](function (queryOrHeaders) {
			var accessToken = authStore.accessToken;

			if (accessToken) {
				queryOrHeaders[accessTokenName] = accessToken;
			}
			return queryOrHeaders;
		});

		if (api) {
			var pathname = api.pathname,
			    query = api.query,
			    headers = api.headers;

			this.pathname = pathname;
			this.extend(extend);
			this.baseRequest = baseRequest.clone({
				url: pathname,
				headers: headers,
				queryTransformer: function queryTransformer(reqQuery) {
					return (0, _fp.assign)({}, query, reqQuery);
				}
			});
		} else {
			this.baseRequest = baseRequest;
		}
		this.performRequest = this.baseRequest.fetch.bind(this.baseRequest);
	}

	_createClass(BaseDataStore, [{
		key: 'mount',
		value: function mount() {
			var _this = this;

			var router = this.router;

			if (router) {
				var location = router.location;

				this._queryDisposer = (0, _mobx.observe)(location, 'query', function (_ref) {
					var newValue = _ref.newValue;

					(0, _mobx.runInAction)(function () {
						return _this.query = newValue;
					});
				});
			}
		}
	}, {
		key: 'setupQuery',
		value: function setupQuery() {
			if (this.router) this.query = this.router.location.query;
		}
	}, {
		key: 'setQuery',
		value: function setQuery(query) {
			if (this.router) this.router.location.query = query;else this.query = query;
		}
	}, {
		key: 'observeQuery',
		value: function observeQuery(handler) {
			return (0, _mobx.observe)(this, 'query', handler);
		}
	}, {
		key: 'extend',
		value: function extend(extensions) {
			var _this2 = this;

			var extendProps = {};
			this.extends = (0, _fp.reduce)(extensions, function (ext, val, key) {
				if ((0, _fp.isFunction)(val)) ext[key] = val.bind(_this2);else extendProps[key] = val;
				return ext;
			}, this.extends);
			(0, _mobx.extendObservable)(this, extendProps);
			return this;
		}
	}, {
		key: 'call',
		value: function call(method) {
			for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
				args[_key - 1] = arguments[_key];
			}

			if ((0, _fp.isFunction)(this.extends[method])) {
				return this.extends[method].apply(this, args);
			} else if ((0, _fp.isFunction)(this[method])) {
				return this[method].apply(this, args);
			} else {
				throw new Error('Method "' + method + '" is not found in table store "' + this.name + '"');
			}
		}
	}, {
		key: 'fetch',
		value: function () {
			var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
				var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								return _context.abrupt('return', this.request(_extends({
									errorTitle: locale.data.fetchFailed
								}, options, {
									refresh: false
								})));

							case 1:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			function fetch() {
				return _ref2.apply(this, arguments);
			}

			return fetch;
		}()
	}, {
		key: 'create',
		value: function () {
			var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
				var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
				return regeneratorRuntime.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								return _context2.abrupt('return', this.request(_extends({
									method: 'POST',
									body: this.config.mapOnSave(options.body, 'create'),
									errorTitle: locale.data.createFailed,
									refresh: true
								}, options)));

							case 1:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, this);
			}));

			function create() {
				return _ref3.apply(this, arguments);
			}

			return create;
		}()
	}, {
		key: 'update',
		value: function () {
			var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3() {
				var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
				return regeneratorRuntime.wrap(function _callee3$(_context3) {
					while (1) {
						switch (_context3.prev = _context3.next) {
							case 0:
								return _context3.abrupt('return', this.request(_extends({
									method: 'PUT',
									body: this.config.mapOnSave(options.body, 'update'),
									errorTitle: locale.data.updateFailed,
									refresh: true
								}, options)));

							case 1:
							case 'end':
								return _context3.stop();
						}
					}
				}, _callee3, this);
			}));

			function update() {
				return _ref4.apply(this, arguments);
			}

			return update;
		}()
	}, {
		key: 'remove',
		value: function () {
			var _ref5 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4() {
				var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
				return regeneratorRuntime.wrap(function _callee4$(_context4) {
					while (1) {
						switch (_context4.prev = _context4.next) {
							case 0:
								return _context4.abrupt('return', this.request(_extends({
									method: 'DELETE',
									errorTitle: locale.data.removeFailed,
									refresh: true
								}, options)));

							case 1:
							case 'end':
								return _context4.stop();
						}
					}
				}, _callee4, this);
			}));

			function remove() {
				return _ref5.apply(this, arguments);
			}

			return remove;
		}()
	}, {
		key: 'request',
		value: function () {
			var _ref6 = _asyncToGenerator(regeneratorRuntime.mark(function _callee5() {
				var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

				var _options$errorTitle, errorTitle, _options$refresh, refresh, _options$throwError, throwError, footer, header, toolbar, title, requestOptions, res;

				return regeneratorRuntime.wrap(function _callee5$(_context5) {
					while (1) {
						switch (_context5.prev = _context5.next) {
							case 0:
								_options$errorTitle = options.errorTitle, errorTitle = _options$errorTitle === undefined ? locale.data.failed : _options$errorTitle, _options$refresh = options.refresh, refresh = _options$refresh === undefined ? false : _options$refresh, _options$throwError = options.throwError, throwError = _options$throwError === undefined ? false : _options$throwError, footer = options.footer, header = options.header, toolbar = options.toolbar, title = options.title, requestOptions = _objectWithoutProperties(options, ['errorTitle', 'refresh', 'throwError', 'footer', 'header', 'toolbar', 'title']);
								_context5.prev = 1;
								_context5.next = 4;
								return this.performRequest(requestOptions);

							case 4:
								res = _context5.sent;

								if (refresh && refresh !== 'no' && (0, _fp.isFunction)(this.refresh)) {
									this.refresh();
								}
								return _context5.abrupt('return', res);

							case 9:
								_context5.prev = 9;
								_context5.t0 = _context5['catch'](1);

								if (!throwError) {
									_context5.next = 15;
									break;
								}

								throw _context5.t0;

							case 15:
								console.error(errorTitle, _context5.t0);
								(0, _showError2.default)(errorTitle, _context5.t0);

							case 17:
							case 'end':
								return _context5.stop();
						}
					}
				}, _callee5, this, [[1, 9]]);
			}));

			function request() {
				return _ref6.apply(this, arguments);
			}

			return request;
		}()
	}, {
		key: 'unmount',
		value: function unmount() {
			this._queryDisposer && this._queryDisposer();
		}
	}]);

	return BaseDataStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'query', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return {};
	}
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'selectedKeys', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return [];
	}
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'selectedNames', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return [];
	}
}), _applyDecoratedDescriptor(_class.prototype, 'cacheKey', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'cacheKey'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'config', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'config'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setupQuery', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setupQuery'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setQuery', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setQuery'), _class.prototype)), _class);
exports.default = BaseDataStore;