'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor, _descriptor2, _descriptor3, _descriptor4;

var _mobx = require('mobx');

var _fp = require('../utils/fp');

var _BaseDataStore2 = require('./BaseDataStore');

var _BaseDataStore3 = _interopRequireDefault(_BaseDataStore2);

var _parseColumn = require('../utils/parseColumn');

var _parseColumn2 = _interopRequireDefault(_parseColumn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _initDefineProp(target, property, descriptor, context) {
	if (!descriptor) return;
	Object.defineProperty(target, property, {
		enumerable: descriptor.enumerable,
		configurable: descriptor.configurable,
		writable: descriptor.writable,
		value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
	});
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}

function _initializerWarningHelper(descriptor, context) {
	throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var DataListStore = (_class = function (_BaseDataStore) {
	_inherits(DataListStore, _BaseDataStore);

	_createClass(DataListStore, [{
		key: 'collection',
		get: function get() {
			var cacheKey = this.cacheKey;

			return this.collections.get(cacheKey);
		}
	}, {
		key: 'total',
		get: function get() {
			return this.totals.get(this.cacheKey);
		}
	}, {
		key: 'sortedKey',
		get: function get() {
			return this.query[this.appConfig.api.sortKey];
		}
	}, {
		key: 'sortedOrder',
		get: function get() {
			var _appConfig$api = this.appConfig.api,
			    orderKey = _appConfig$api.orderKey,
			    ascValue = _appConfig$api.ascValue;

			var order = this.query[orderKey];

			if (!this.sortedKey) {
				return order;
			}

			/* eslint-disable eqeqeq */
			return order == ascValue ? 'ascend' : 'descend';
		}
	}, {
		key: 'columns',
		get: function get() {
			var _this2 = this;

			var renderers = this.config.renderers;

			if (!renderers) return [];
			return renderers.filter(function (_ref) {
				var renderTable = _ref.renderTable;
				return renderTable;
			}).map(function (_ref2) {
				var renderCell = _ref2.renderTable,
				    props = _ref2.props;

				var column = (0, _parseColumn2.default)({
					title: props.label,
					key: props.name,
					dataIndex: props.name,
					width: props.tableColumnWidth || 'auto',
					headers: { renderCell: renderCell },
					body: function body(state) {
						return {
							store: _extends({ text: state.value }, state),
							renderCell: renderCell
						};
					}
				});
				if (props.sortable) {
					var sortedKey = _this2.sortedKey,
					    sortedOrder = _this2.sortedOrder;

					column.sortOrder = props.name === sortedKey ? sortedOrder : false;
					column.sorter = true;
				}
				return column;
			});
		}
	}, {
		key: 'prevCursor',
		get: function get() {
			var prevIndex = this.cursorIndex - 1;
			return prevIndex < 0 ? undefined : this.cursors[prevIndex];
		}
	}, {
		key: 'nextCursor',
		get: function get() {
			var cursors = this.cursors,
			    cursorIndex = this.cursorIndex;

			var nextIndex = cursorIndex + 1;
			return nextIndex >= cursors.length ? undefined : cursors[nextIndex];
		}
	}, {
		key: 'maxSelections',
		get: function get() {
			return this.config.maxSelections;
		}
	}]);

	function DataListStore(options) {
		_classCallCheck(this, DataListStore);

		var _this = _possibleConstructorReturn(this, (DataListStore.__proto__ || Object.getPrototypeOf(DataListStore)).call(this, options));

		_initDefineProp(_this, 'isFetching', _descriptor, _this);

		_initDefineProp(_this, 'queryFieldsCount', _descriptor2, _this);

		_initDefineProp(_this, 'cursors', _descriptor3, _this);

		_initDefineProp(_this, 'cursorIndex', _descriptor4, _this);

		_this.collections = _mobx.observable.map();
		_this.totals = _mobx.observable.map();
		var config = _this.config,
		    appConfig = _this.appConfig,
		    baseRequest = _this.baseRequest;
		var api = config.api;


		_this.size = +appConfig.api.count;

		if (api) {
			_this.uniqueKey = config.uniqueKey;
			_this.useCursor = config.useCursor;

			var count = +api.query.count;
			var hasCount = !!count;

			if (hasCount) {
				_this.size = count;
			}

			var request = baseRequest.clone({
				queryTransformer: function queryTransformer(query) {
					if (hasCount) query.count = count;
					return query;
				}
			});
			_this.performRequest = request.fetch.bind(request);
		}
		return _this;
	}

	_createClass(DataListStore, [{
		key: 'fetch',
		value: function () {
			var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
				var _this3 = this;

				var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

				var queryOptions, method, url, body, headers, cacheKey, useCursor, _collection, query, page, fetchOptions, res, requestRes, _ref4, total, _ref4$list, list, nextCursor, collection;

				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								queryOptions = options.query, method = options.method, url = options.url, body = options.body, headers = options.headers;
								cacheKey = this.cacheKey, useCursor = this.useCursor;

								if (!this.collections.has(cacheKey)) {
									_context.next = 6;
									break;
								}

								_collection = this.collections.get(cacheKey);

								if (!_collection.length) {
									_context.next = 6;
									break;
								}

								return _context.abrupt('return', _collection);

							case 6:

								this.isFetching = true;
								query = _extends({ count: this.size }, queryOptions);

								if (useCursor) {
									if (query.cursor === null) delete query.cursor;
								} else {
									page = queryOptions && queryOptions.page || 1;

									query.page = page < 1 ? 1 : page;
								}

								fetchOptions = {
									method: method,
									url: url,
									body: body,
									headers: headers,
									query: query
								};
								_context.next = 12;
								return this.request(_extends({}, (0, _fp.omitBy)(fetchOptions, _fp.isUndefined), {
									refresh: false
								}));

							case 12:
								res = _context.sent;
								_context.next = 15;
								return this.config.mapOnFetchResponse(res);

							case 15:
								requestRes = _context.sent;
								_ref4 = requestRes || {}, total = _ref4.total, _ref4$list = _ref4.list, list = _ref4$list === undefined ? [] : _ref4$list, nextCursor = _ref4.nextCursor;
								collection = list.map(function (data, index) {
									data.key = _this3.uniqueKey ? data[_this3.uniqueKey] : index;
									return data;
								});


								this.collections.set(cacheKey, collection);
								if (!(0, _fp.isUndefined)(total)) this.totals.set(cacheKey, total);

								(0, _mobx.runInAction)(function () {
									if (useCursor) _this3.cursors.push(nextCursor);
									_this3.isFetching = false;
								});
								return _context.abrupt('return', collection);

							case 22:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			function fetch() {
				return _ref3.apply(this, arguments);
			}

			return fetch;
		}()
	}, {
		key: 'clearCollections',
		value: function clearCollections() {
			this.collections.clear();
			this.totals.clear();
			this.selectedKeys = [];
		}
	}, {
		key: 'refresh',
		value: function refresh() {
			this.collections.clear();
			this.totals.clear();
			this.fetch({ query: this.query });
			this.selectedKeys = [];
		}
	}, {
		key: 'decreaseCursorIndex',
		value: function decreaseCursorIndex() {
			return --this.cursorIndex;
		}
	}, {
		key: 'increaseCursorIndex',
		value: function increaseCursorIndex() {
			return ++this.cursorIndex;
		}
	}, {
		key: 'increaseQueryFieldsCount',
		value: function increaseQueryFieldsCount() {
			this.queryFieldsCount++;
		}
	}, {
		key: 'setQuery',
		value: function setQuery(query) {
			if (this.useCursor) {
				this.cursorIndex = 0;
				this.cursors = [null];
				if (query.cursor) delete query.cursor;
				this.query = query;
			} else {
				_get(DataListStore.prototype.__proto__ || Object.getPrototypeOf(DataListStore.prototype), 'setQuery', this).call(this, query);
			}
		}
	}, {
		key: 'setQueryWithCursor',
		value: function setQueryWithCursor(query) {
			if (!query.cursor && query.hasOwnProperty('cursor')) {
				delete query.cursor;
			}
			this.query = query;
		}
	}, {
		key: 'decreaseQueryFieldsCount',
		value: function decreaseQueryFieldsCount() {
			this.queryFieldsCount--;
		}
	}, {
		key: 'setSelectedKeys',
		value: function setSelectedKeys() {
			var selectedKeys = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

			this.selectedKeys = selectedKeys;
		}
	}, {
		key: 'toggleSelectedKey',
		value: function toggleSelectedKey(key) {
			if (this.selectedKeys.length && this.selectedKeys[0] === key) {
				this.selectedKeys = [];
			} else {
				this.selectedKeys = [key];
			}
		}
	}, {
		key: 'clearSelectedKeys',
		value: function clearSelectedKeys() {
			this.selectedKeys = [];
		}
	}, {
		key: 'getData',
		value: function getData(key) {
			var collection = this.collection,
			    uniqueKey = this.uniqueKey,
			    selectedKeys = this.selectedKeys;

			if ((0, _fp.isUndefined)(key) && selectedKeys.length) {
				key = selectedKeys[0];
			}
			if ((0, _fp.isUndefined)(key) || !collection) {
				return null;
			}
			return collection.find(function (dataItem, index) {
				return key === (uniqueKey ? dataItem[uniqueKey] : index);
			});
		}
	}, {
		key: 'setSelectedNames',
		value: function setSelectedNames(names) {
			this.selectedNames = names;
		}
	}, {
		key: 'clearSelectedNames',
		value: function clearSelectedNames() {
			this.selectedNames = [];
		}
	}]);

	return DataListStore;
}(_BaseDataStore3.default), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'isFetching', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return false;
	}
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'queryFieldsCount', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return 0;
	}
}), _descriptor3 = _applyDecoratedDescriptor(_class.prototype, 'cursors', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return [null];
	}
}), _descriptor4 = _applyDecoratedDescriptor(_class.prototype, 'cursorIndex', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return 0;
	}
}), _applyDecoratedDescriptor(_class.prototype, 'collection', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'collection'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'total', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'total'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'sortedKey', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'sortedKey'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'sortedOrder', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'sortedOrder'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'columns', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'columns'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'prevCursor', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'prevCursor'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'nextCursor', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'nextCursor'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'fetch', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'fetch'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'clearCollections', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'clearCollections'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'refresh', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'refresh'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'decreaseCursorIndex', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'decreaseCursorIndex'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'increaseCursorIndex', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'increaseCursorIndex'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'increaseQueryFieldsCount', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'increaseQueryFieldsCount'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setQuery', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setQuery'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setQueryWithCursor', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setQueryWithCursor'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'decreaseQueryFieldsCount', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'decreaseQueryFieldsCount'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setSelectedKeys', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setSelectedKeys'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'toggleSelectedKey', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'toggleSelectedKey'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'clearSelectedKeys', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'clearSelectedKeys'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'setSelectedNames', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'setSelectedNames'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'clearSelectedNames', [_mobx.action], Object.getOwnPropertyDescriptor(_class.prototype, 'clearSelectedNames'), _class.prototype)), _class);
exports.default = DataListStore;