'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _style2 = require('antd/lib/message/style');

var _message = require('antd/lib/message');

var _message2 = _interopRequireDefault(_message);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor, _descriptor2;

var _mobx = require('mobx');

var _cookie = require('../utils/cookie');

var _cookie2 = _interopRequireDefault(_cookie);

var _CookieKeys = require('../constants/CookieKeys');

var _getRequest = require('../utils/getRequest');

var _getRequest2 = _interopRequireDefault(_getRequest);

var _fp = require('../utils/fp');

var _deprecated = require('../utils/deprecated');

var _deprecated2 = _interopRequireDefault(_deprecated);

var _showError = require('../utils/showError');

var _showError2 = _interopRequireDefault(_showError);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _LocaleStores = require('./LocaleStores');

var _LocaleStores2 = _interopRequireDefault(_LocaleStores);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _initDefineProp(target, property, descriptor, context) {
	if (!descriptor) return;
	Object.defineProperty(target, property, {
		enumerable: descriptor.enumerable,
		configurable: descriptor.configurable,
		writable: descriptor.writable,
		value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
	});
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
	var desc = {};
	Object['ke' + 'ys'](descriptor).forEach(function (key) {
		desc[key] = descriptor[key];
	});
	desc.enumerable = !!desc.enumerable;
	desc.configurable = !!desc.configurable;

	if ('value' in desc || desc.initializer) {
		desc.writable = true;
	}

	desc = decorators.slice().reverse().reduce(function (desc, decorator) {
		return decorator(target, property, desc) || desc;
	}, desc);

	if (context && desc.initializer !== void 0) {
		desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
		desc.initializer = undefined;
	}

	if (desc.initializer === void 0) {
		Object['define' + 'Property'](target, property, desc);
		desc = null;
	}

	return desc;
}

function _initializerWarningHelper(descriptor, context) {
	throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var locale = _LocaleStores2.default.ensure('requests');

var verifyAndSaveAccessToken = function verifyAndSaveAccessToken() {
	var authRes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	var accessToken = authRes.accessToken,
	    expiresIn = authRes.expiresIn,
	    expiresInMilliseconds = authRes.expiresInMilliseconds;


	if (!(0, _fp.isString)(accessToken)) {
		throw new Error('"accessToken" is INVALID, received "' + accessToken + '"');
	}

	var maxAge = expiresInMilliseconds || expiresIn && expiresIn * 1000 || 0;

	process.env.NODE_ENV !== 'production' && (process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(+maxAge, 'Missing `expiresIn` attribute.') : void 0);

	maxAge && _cookie2.default.set(_CookieKeys.ACCESS_TOKEN, accessToken, { maxAge: maxAge });
};

var AuthStore = (_class = function () {
	function AuthStore() {
		var _this = this;

		_classCallCheck(this, AuthStore);

		_initDefineProp(this, 'isFetching', _descriptor, this);

		_initDefineProp(this, 'accessToken', _descriptor2, this);

		this.getAccessToken = (0, _deprecated2.default)(function () {
			return _this.accessToken;
		}, '`getAccessToken()` is deprecated, please use `accessToken` instead');
	}

	_createClass(AuthStore, [{
		key: 'set',
		value: function set(config) {
			this._apiConfig = config.api;
			this._config = config.auth;
			process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(this._config.basePath, 'Missing auth.basePath') : void 0;
			this._request = (0, _getRequest2.default)(config).clone(this._config.basePath);
		}
	}, {
		key: 'auth',
		value: function () {
			var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
				var isOk, options, accessTokenLocation, res, authRes;
				return regeneratorRuntime.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								this.isFetching = true;
								isOk = false;
								_context.prev = 2;
								options = { url: this._config.getUserPath };

								if (this.accessToken) {
									accessTokenLocation = this._apiConfig.accessTokenLocation;

									options[accessTokenLocation] = _defineProperty({}, this._apiConfig.accessTokenName, this.accessToken);
								}

								_context.next = 7;
								return this._request.fetch(options);

							case 7:
								res = _context.sent;
								authRes = this._config.mapOnGetUserResponse(res);

								verifyAndSaveAccessToken(authRes);
								this.accessToken = authRes.accessToken;
								isOk = true;
								_context.next = 18;
								break;

							case 14:
								_context.prev = 14;
								_context.t0 = _context['catch'](2);

								this.accessToken = null;
								(0, _showError2.default)(locale.data.invalidToken, _context.t0);

							case 18:
								this.isFetching = false;
								return _context.abrupt('return', isOk);

							case 20:
							case 'end':
								return _context.stop();
						}
					}
				}, _callee, this, [[2, 14]]);
			}));

			function auth() {
				return _ref.apply(this, arguments);
			}

			return auth;
		}()
	}, {
		key: 'login',
		value: function () {
			var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(body) {
				var isOk, res, authRes;
				return regeneratorRuntime.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								isOk = false;
								_context2.prev = 1;
								_context2.next = 4;
								return this._request.fetch({
									url: this._config.loginPath,
									method: 'POST',
									body: body
								});

							case 4:
								res = _context2.sent;
								authRes = this._config.mapOnLoginResponse(res);

								verifyAndSaveAccessToken(authRes);
								this.accessToken = authRes.accessToken;

								isOk = true;
								_message2.default.success(locale.data.loginSuccessful);
								_context2.next = 16;
								break;

							case 12:
								_context2.prev = 12;
								_context2.t0 = _context2['catch'](1);

								this.accessToken = null;
								(0, _showError2.default)(locale.data.loginFailed, _context2.t0);

							case 16:
								return _context2.abrupt('return', isOk);

							case 17:
							case 'end':
								return _context2.stop();
						}
					}
				}, _callee2, this, [[1, 12]]);
			}));

			function login(_x2) {
				return _ref2.apply(this, arguments);
			}

			return login;
		}()
	}, {
		key: 'logout',
		value: function logout() {
			this.accessToken = null;
			_cookie2.default.remove(_CookieKeys.ACCESS_TOKEN);
		}
	}]);

	return AuthStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'isFetching', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return true;
	}
}), _descriptor2 = _applyDecoratedDescriptor(_class.prototype, 'accessToken', [_mobx.observable], {
	enumerable: true,
	initializer: function initializer() {
		return _cookie2.default.get(_CookieKeys.ACCESS_TOKEN);
	}
})), _class);
exports.default = new AuthStore();