'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var warned = {};

exports.default = _extends({}, _propTypes2.default, {
	component: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string, _propTypes2.default.func]),
	array: _propTypes2.default.oneOfType([_propTypes2.default.array, _mobxReact.propTypes.observableArray]),
	stringOrNumber: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
	stringOrObject: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),
	stringOrFunc: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]),
	nodeOrFunc: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
	render: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.func]),
	deprecated: function deprecatedProp(propType, explanation) {
		return function validate(props, propName, componentName) {
			if (props[propName] != null) {
				// eslint-disable-next-line max-len
				var message = '"' + propName + '" property of "' + componentName + '" has been deprecated.';
				if (explanation) message += ' ' + explanation;

				if (!warned[message]) {
					warned[message] = true;
					process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(false, message) : void 0;
				}
			}

			for (var _len = arguments.length, rest = Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
				rest[_key - 3] = arguments[_key];
			}

			return propType.apply(undefined, [props, propName, componentName].concat(rest));
		};
	}
});