'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = deprecated;

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var cache = new WeakSet();

function deprecated(fn, message) {
	return function () {
		if (!cache.has(fn)) {
			cache.add(fn);
			process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(false, message || fn.name + ' is deprecated.') : void 0;
		}
		return fn.apply(undefined, arguments);
	};
}