'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = ensureFileList;

var _fp = require('./fp');

var _mobx = require('mobx');

function ensureFileList() {
	var fileList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

	if ((0, _fp.isString)(fileList)) {
		fileList = fileList.split(',');
	}

	if (!(0, _fp.isArray)(fileList) && !(0, _mobx.isObservableArray)(fileList)) {
		throw new Error('`fileList` must be a string or array');
	}

	return fileList.map(_fp.trim).filter(Boolean).map(function (url, index) {
		return {
			uid: -index,
			url: url,
			name: url
		};
	});
}