'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = joinKeys;

var _mobx = require('mobx');

var _fp = require('./fp');

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function joinKeys(keys) {
	var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'CSV';

	if (!keys) return '';
	if ((0, _fp.isString)(keys)) return keys;

	if (type === 'CSV') {
		if ((0, _fp.isArray)(keys) || (0, _mobx.isObservableArray)(keys)) {
			return keys.join(',');
		}
	} else {
		process.env.NODE_ENV !== 'production' ? (0, _warning2.default)(false, 'Joining keys with "' + type + '" is not supported') : void 0;
	}

	return '';
}