'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = parseColumn;

var _fp = require('./fp');

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function parseColumn(column) {
	var title = column.title,
	    body = column.body,
	    other = _objectWithoutProperties(column, ['title', 'body']);

	var res = other;

	res.title = (0, _fp.isFunction)(title) ? title() : title;

	// inject props into `components/TableBody/TableHeadCell` component
	res.onHeaderCell = function (column) {
		return column.headers;
	};

	if (body) {
		res.render = function renderTable(value, record, index) {
			// inject props into `components/TableBody/TableCell` component
			return { props: body({ value: value, record: record, index: index }) };
		};
	}

	return res;
}